unit bmp;

{$ifdef fpc}
  {$mode objfpc}{$H+}
{$endif}

interface

uses
  {$ifdef Unix}
    WolfUtil,
  {$else}
    Windows,
  {$endif}
  {$ifdef fpc}
    LResources,
  {$endif}
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  ComCtrls,
  StdCtrls,
  Zusatz,
  Common;

type
  TBmpForm      = class(TForm)
    LblHoehe    : TLabel;
    LblBreite   : TLabel;
    Label1      : TLabel;
    Label2      : TLabel;
    Label3      : TLabel;
    Label4      : TLabel;
    Label5      : TLabel;
    HoeheMM     : TEdit;
    BreiteMM    : TEdit;
    DPI         : TEdit;
    BreitePixel : TEdit;
    HoehePixel  : TEdit;
    UpDownDPI   : TUpDown;
    BtnOk       : TButton;
    BtnCancel   : TButton;
    UpDownHoehe : TUpDown;
    procedure     DPIExit(Sender: TObject);
    procedure     HoeheMMExit(Sender: TObject);
    procedure     FormCreate(Sender: TObject);
    procedure     FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure     UpDownDPIClick(Sender: TObject; Button: TUDBtnType);
    procedure     UpDownHoeheClick(Sender: TObject; Button: TUDBtnType);
  public
    y_by_x      : real;
    procedure     Calculate;
  end;

var
  BmpForm: TBmpForm;

implementation

{$R *.dfm}

procedure TBmpForm.Calculate;
  var h    : Real;
      d, e : Integer;
      s    : String;
  begin
    val(HoeheMM.Text, h, e);
    val(DPI.Text,     d, e);
    UpDownDPI.Position := d;
    str(h * d / 25.4 : 1 : 0, s);
    HoehePixel.Text := s;
    h := h / y_by_x;
    str(h : 1 : 1, s);
    BreiteMM.Text := s;
    str(h * d / 25.4 : 1 : 0, s);
    BreitePixel.Text := s;
  end;

procedure TBmpForm.DPIExit(Sender: TObject);
  begin
    Calculate;
  end;

procedure TBmpForm.HoeheMMExit(Sender: TObject);
  begin
    Calculate;
  end;           

procedure TBmpForm.FormCreate(Sender: TObject);
  begin
    LoadFormFromIni(Self);
    case SysLocale.PriLangID of
      LANG_GERMAN: ;
    else
      Caption           := 'create Bitmap';
      LblHoehe.Caption  := 'Height';
      LblBreite.Caption := 'Width';
      BtnCancel.Caption := '&Cancel';
    end;
    UpDownHoehe.Height  := UpDownDPI.Height;
  end;

procedure TBmpForm.FormClose(Sender: TObject; var CloseAction: TCloseAction);
  begin
    if CloseAction = caFree then;
    SaveFormToIni(Self);
  end;

procedure TBmpForm.UpDownDPIClick(Sender: TObject; Button: TUDBtnType);
  begin
    if Button = btNext then;
    Calculate;
  end;

procedure TBmpForm.UpDownHoeheClick(Sender: TObject; Button: TUDBtnType);
  var r : Real;
      e : Integer;
      s : String;
  begin
    val(HoeheMM.Text, r, e);
    if Button = btNext then
      r := r + 10
    else
      r := r - 10;
    if r < 0 then
      r := 0;
    str(r : 1 : 1, s);
    if length(s) <= HoeheMM.MaxLength then
      HoeheMM.Text := s;
    Calculate;
  end;

end.
