program CalPrint;

{$ifdef fpc}
  {$mode objfpc}{$H+}
{$endif}

{$ifdef MSWINDOWS}
  {$ifndef fpc}
    { Delphi 2005 and newer }
    {$define DelphiPng}
  {$endif}
{$endif}

{$ifdef Ver130}
  { Delphi 5 }
  {$define DelphiPng}
{$endif}

{$ifdef Ver120}
  { Delphi 4 }
  {$define DelphiPng}
{$endif}

uses
  Forms,
  {$ifdef Unix}
    CLocale,
  {$endif}
  {$ifdef fpc}
    Interfaces,
    LResources,
    { https://svn.code.sf.net/p/lazarus-ccr/svn/components/richmemo }
    richmemopackage,
    sgrid,
  {$endif}
  {$ifdef DelphiPng}
    { http://pngdelphi.sourceforge.net
      http://www.delphi-forum.de/topic_PNGImage_90020,0.html
      http://www.torry.net/vcl/graphics/otherformats/pngimage.zip
    }
    PngImage in '..\..\..\PngImage\PngImage.pas',
    PngLang  in '..\..\..\PngImage\PngLang.pas',
    ZLibPas  in '..\..\..\PngImage\ZLibPas.pas',
  {$endif}
  {$ifndef fpc}
    {$ifdef Ver330}
      // http://www.tolderlund.eu/delphi/
      GifImage in '..\..\..\GifImage\GifImage.pas',
    {$else}
      // http://www.clootie.ru/delphi/VCL/GIFImageD6.zip
      GIFImage in '..\..\..\units\GifImage.pas',
    {$endif}
    // http://www.cadsofttools.com/download/pcximage.zip
    PCXImage in '..\..\..\units\pcximage.pas',
  {$endif}
  extpng     in '..\..\..\units\extpng.pas',
  extjpeg    in '..\..\..\units\extjpeg.pas',
  wolfutil   in '..\..\..\units\wolfutil.pas',
  copyrite   in '..\..\..\units\copyrite.pas',
  Zusatz     in '..\..\..\units\zusatz.pas',
  Deltime    in '..\..\..\units\deltime.pas',
  SortGrid   in '..\..\..\units\sortgrid.pas',
  {$ifndef Unix}
    link     in 'link.pas'     {LinkForm},
  {$endif}
  Common     in 'common.pas',
  Main       in 'main.pas'     {MainForm},
  Layout     in 'layout.pas'   {LayoutForm},
  Holidays   in 'holidays.pas' {HolidaysForm},
  Preview    in 'preview.pas'  {PreviewForm},
  Dates      in 'dates.pas'    {DatesForm},
  Pflege     in 'pflege.pas'   {MaintainForm},
  bmp        in 'bmp.pas'      {BmpForm},
  YesNo      in 'yesno.pas'    {YesNoForm},
  Lizenz     in 'lizenz.pas'   {LizenzForm},
  Afeier     in 'afeier.pas'   {AutoHolidayForm};

{$R *.res}

begin
  Application.Initialize;
  Application.CreateForm(TMainForm,         MainForm);
  Application.CreateForm(TLayoutForm,       LayoutForm);
  Application.CreateForm(TUserHolidaysForm, UserHolidaysForm);
  Application.CreateForm(TPreviewForm,      PreviewForm);
  Application.CreateForm(TDatesForm,        DatesForm);
  Application.CreateForm(TMaintainForm,     MaintainForm);
  Application.CreateForm(TBmpForm,          BmpForm);
  Application.CreateForm(TYesNoForm,        YesNoForm);
  Application.CreateForm(TLizenzForm,       LizenzForm);
  Application.CreateForm(TAutoHolidayForm,  AutoHolidayForm);
  {$ifndef Unix}
    Application.CreateForm(TLinkForm,       LinkForm);
  {$endif}
  Application.Run;
end.
