Unit
  copyrite;

{$ifdef FPC}
  {$mode objfpc}{$H+}
{$endif}

{$ifdef MSWINDOWS}
  { ab Delphi 2005 }
  {$define Delphi4}
  {$define Delphi3}
  {$ifndef fpc}
    {$define Delphi}
  {$endif}
{$endif}

{$ifdef Ver140}
  { Kylix 3 }
  {$define Delphi4}
  {$define Delphi3}
{$endif}

{$ifdef Ver130}
  { Delphi 5 }
  {$define Delphi4}
  {$define Delphi3}
  {$define Delphi}
{$endif}

{$ifdef Ver120}
  { Delphi 4 }
  {$define Delphi4}
  {$define Delphi3}
  {$define Delphi}
  {$define DelphiMax4}
{$endif}

{$ifdef Ver100}
  { Delphi 3 }
  {$define Delphi3}
  {$define Delphi}
  {$define DelphiMax3}
  {$define DelphiMax4}
{$endif}

{$ifdef Ver80}
  { Delphi 1 }
  {$define Delphi}
  {$define DelphiMax3}
  {$define DelphiMax4}
  {$define OSErrors}
{$endif}

{$ifdef FPC}
  {$ifndef Unix}
    {$define Delphi4}
    {$define Delphi3}
  {$endif}
  {$define OSErrors}
{$endif}

Interface

Uses
  {$ifdef Unix}
    WolfUtil,
  {$else}
    {$ifndef Unix}
      Windows,
      Registry,
    {$endif}
  {$endif}
  IniFiles,
  {$ifdef fpc}
    LConvEncoding,
  {$endif}
  {$ifdef Ver130}
    { Delphi 5 }
    SysConst,
  {$endif}
  {$ifdef Ver120}
    { Delphi 4 }
    SysConst,
  {$endif}
  SysUtils,
  zusatz;

var
  CopyrightName,
  CopyrightStrasse,
  CopyrightOrt,
  CopyrightTelefonRegion,
  CopyrightTelefon,
  CopyrightTelefax,
  CopyrighteMail,
  CopyrightInternet,
  LizenzNehmer,
  LizenzVersion : String;

function SetLizenz(Name, NewCode : String) : String;

Implementation

const
  Code       : LongInt = 27041960;
  IniLizenz  = 'License';
  IniCode    = 'Code';

function International(s : String; German : Boolean) : String;
  begin
    {$ifdef fpc}
      International := CP1252toUTF8(s);
      German        := German;
    {$else}
      {$ifdef Ver330}
        International := s;
      {$else}
          if German then
            International := s
          else
            begin
              s := StringReplace(s, A_ISO_LOWER_AE, 'ae', [rfReplaceAll]);
              s := StringReplace(s, A_ISO_LOWER_OE, 'oe', [rfReplaceAll]);
              s := StringReplace(s, A_ISO_LOWER_UE, 'ue', [rfReplaceAll]);
              s := StringReplace(s, A_ISO_SS      , 'ss', [rfReplaceAll]);
              s := StringReplace(s, A_ISO_UPPER_AE, 'Ae', [rfReplaceAll]);
              s := StringReplace(s, A_ISO_UPPER_OE, 'Oe', [rfReplaceAll]);
              s := StringReplace(s, A_ISO_UPPER_UE, 'Ue', [rfReplaceAll]);
              International := s;
            end;
      {$endif}
    {$endif}
  end;

procedure CheckLizenz(LizenzCode : String);
  var     Union     : packed Record
                        case Boolean of
                          true  : (l : LongInt;
                                   n : Char);
                          false : (c : Array[0 .. 4] of char);
                      end;
          Pruefzahl,
          s         : String;
          Anzahl,
          i, j      : Integer;
          c, l      : LongInt;
  begin
    LizenzNehmer  := '';
    LizenzVersion := '';
    Pruefzahl     := '';
    s             := '';
    j             := 0;
    Anzahl        := 0;
    l             := 0;
    C             := Code;
    Union.n       := #0;
    for i := 1 to Length(LizenzCode) do
      begin
        if    ('0' <= LizenzCode[i]) and (LizenzCode[i] <= '9')
           or ('a' <= LizenzCode[i]) and (LizenzCode[i] <= 'f')
           or ('A' <= LizenzCode[i]) and (LizenzCode[i] <= 'F')
        then
          begin
            inc(j);
            if odd(j) then
              s := s + LizenzCode[i]
            else
              if Anzahl < 2 then
                inc(l, StrToInt('$' + Lizenzcode[i]));
          end;
        if (length(s) > 8) or (length(s) = 8) and (anzahl > 1) then
          begin
            Union.l := StrToInt('$' + Copy(s, 1, 8)) xor C;
            s := Copy(s, 9, length(s));
            if C < 0 then
              C := (C shl 1) or 1
            else
              C := C shl 1;
            case Anzahl of
              0 : LizenzNehmer  := LizenzNehmer  + StrPas(Union.c);
              1 : LizenzVersion := LizenzVersion + StrPas(Union.c);
              2 : PruefZahl     := PruefZahl     + StrPas(Union.c);
            end;
            if strlen(Union.c) < 4 then
              inc(Anzahl);
          end;
      end;
    Val(Pruefzahl, c, i);
    if i <> 0 then
      begin
        Lizenznehmer  := '';
        LizenzVersion := '';
      end
    else
      begin
        for i := 1 to Length(Lizenznehmer) do
          inc(l, ord(Lizenznehmer[i]));
        for i := 1 to Length(LizenzVersion) do
          inc(l, ord(LizenzVersion[i]));
        if c <> l then
          begin
            Lizenznehmer  := '';
            LizenzVersion := '';
          end;
      end;
  end;

function SetLizenz(Name : String; NewCode : String) : String;
  var    {$ifdef Delphi3}
           Reg     : tRegistry;
         {$else}
           IniFile : tIniFile;
         {$endif}
  begin
    CheckLizenz(NewCode);
    if Lizenznehmer = Name then
      begin
        {$ifdef Delphi3}
          reg := Nil;
          try
            reg := tRegistry.Create;
          except
            reg := Nil;
          end;
          if reg <> Nil then
            begin
              if RegOpen(Reg, IniLizenz) then
                begin
                  try
                    Reg.WriteString(IniCode, NewCode);
                  except
                  end;
                  Reg.CloseKey;
                end;
              Reg.Free;
            end;
        {$else}
          try
            IniFile := tIniFile.Create(IniName);
          except
            IniFile := Nil;
          end;
          if IniFile <> Nil then
            begin
              IniFile.WriteString(IniLizenz, IniCode, NewCode);
              IniFile.Free;
            end;
        {$endif}
        SetLizenz := LizenzVersion;
      end
    else
      begin
        Lizenznehmer  := '';
        LizenzVersion := '';
      end;
  end;

procedure Decode;
  const   MaxValue    = 33;
          MaxList     = 9;
          Values      : Array[0 .. MaxValue] of LongInt
                      = ( 1878377952,
                          1801070626,
                          1780340096,
                           216335654,
                          1975152587,
                          1206347621,
                            49761138,
                         -1352243936,
                         -1667192831,
                           158891335,
                          1387566641,
                         -1854423990,
                         -1425375119,
                         -1188285416,
                           672870750,
                          1885419491,
                         -1819790929,
                          1095775498,
                         -1567280801,
                           845167571,
                           176172543,
                          1634098375,
                          1332872799,
                           946837776,
                          -582503994,
                           947342116,
                         -1604118868,
                           813207917,
                          -147397328,
                          1461576546,
                           755057733,
                          1923818770,
                          1706215644,
                            54095413);
  var     i, Anzahl  : Integer;
          Union      : packed Record
                         case Boolean of
                           true  : (l : DWORD;
                                    n : char;);
                           false : (c : Array[0 .. 4] of AnsiChar);
                       end;
          C          : LongInt;
          Copyright  : Array[1 .. MaxList] of String;
          {$ifdef Delphi3}
            Reg      : tRegistry;
          {$else}
            IniFile  : tIniFile;
          {$endif}
          German     : Boolean;
          LizenzCode : String;
  begin
    for i := 1 to MaxList do
      Copyright[i] := '';
    Anzahl         := 1;
    C              := Code;
    Union.n        := #0;
    for i := 0 to MaxValue do
      begin
        Union.l := DWORD(Values[i]) xor C;
        if C < 0 then
          C := (C shl 1) or 1
        else
          C := C shl 1;
        if Anzahl <= MaxList Then
          Copyright[Anzahl] := Copyright[Anzahl] + StrPas(Union.c);
        if strlen(Union.c) < 4 then
          inc(Anzahl);
      end;
    German                 := SysLocale.PriLangID = LANG_GERMAN;
    CopyrightName          := International(Copyright[1], German);
    CopyrightStrasse       := International(Copyright[2], German);
    CopyrightOrt           := International(Copyright[3], German);
    CopyrightTelefonRegion := International(Copyright[4], German);
    CopyrightTelefon       := International(Copyright[5], German);
    CopyrightTelefax       := International(Copyright[6], German);
    CopyrighteMail         := International(Copyright[7], German);
    CopyrightInternet      := International(Copyright[8], German);
    LizenzCode             := '';
    {$ifdef Delphi3}
      try
        reg := tRegistry.Create;
      except
        reg := Nil;
      end;
      if reg <> Nil then
        begin
          if RegOpen(Reg, IniLizenz) then
            begin
              try
                LizenzCode := Reg.ReadString(IniCode);
              except
              end;
              Reg.CloseKey;
            end;
          Reg.Free;
        end;
    {$else}
      try
        IniFile := tIniFile.Create(IniName);
      except
        IniFile := Nil;
      end;
      if IniFile <> Nil then
        begin
          LizenzCode := IniFile.ReadString(IniLizenz, IniCode, '');
          IniFile.Free;
        end;
    {$endif}
    CheckLizenz(LizenzCode);
  end;

begin
  Decode;
end.


