unit pflege;

{$ifdef fpc}
  {$mode objfpc}{$H+}
{$endif}

interface

uses
  {$ifdef Unix}
    WolfUtil,
  {$else}
    Windows,
  {$endif}
  {$ifdef fpc}
    LResources,
  {$endif}
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  ExtCtrls,
  Common,
  Zusatz;

type

  { TMaintainForm }

  TMaintainForm        = class(TForm)
    BtnOk              : TButton;
    Image              : TImage;
    Label1980          : TLabel;
    LabelWang          : TLabel;
    LabelUebersicht    : TLabel;
    Label1981          : TLabel;
    LabelCBM           : TLabel;
    Label1985          : TLabel;
    Labelschtac        : TLabel;
    LabelEpson         : TLabel;
    Label1990          : TLabel;
    LabelPC            : TLabel;
    Label1995          : TLabel;
    Labelhp            : TLabel;
    Label1998          : TLabel;
    LabelDelphi1       : TLabel;
    Label1999          : TLabel;
    LabelJulianisch    : TLabel;
    Label2002          : TLabel;
    LabelDelphi5       : TLabel;
    Label2003          : TLabel;
    LabelInternet      : TLabel;
    LabelRingbuch      : TLabel;
    Label2005          : TLabel;
    LabelGif1          : TLabel;
    LabelPCX           : TLabel;
    Label2006          : TLabel;
    LabelSamstag       : TLabel;
    Label2007          : TLabel;
    LabelMetafile      : TLabel;
    Label2008          : TLabel;
    LabelPNGWrite      : TLabel;
    Label2011          : TLabel;
    LabelInternational : TLabel;
    LabelPNGRead1      : TLabel;
    LabelLinux         : TLabel;
    Label2020          : TLabel;
    LabelPunching      : TLabel;
    LabelGif2          : TLabel;
    LabelPngRead2      : TLabel;
    procedure            FormCreate(Sender: TObject);
    procedure            FormClose(Sender: TObject;
                                   var CloseAction: TCloseAction);
  end;

var
  MaintainForm : TMaintainForm;

implementation

{$R *.dfm}

procedure TMaintainForm.FormCreate(Sender: TObject);
  begin
    case SysLocale.PriLangID of
      LANG_GERMAN : ;
    else
      Caption                    := 'Program maintained';
      Label1980.Caption          := 'approx. 1980';
      Label1981.Caption          := 'approx. 1981';
      Label1985.Caption          := 'approx. 1985';
      Label1990.Caption          := 'approx. 1990';
      Label1995.Caption          := 'approx. 1995';
      Label1998.Caption          := 'approx. 1998';
      Label1999.Caption          := 'approx. 1999';
      LabelWang.Caption          := 'Wang Computer, BASIC, Gregorian calendar, '
                                    + 'no holidays,';
      LabelUebersicht.Caption    := 'only outline form';
      LabelCBM.Caption           := 'Commodore 4032, calculation of holidays';
      Labelschtac.Caption        := 'schtac Pascal';
      LabelPC.Caption            := 'PC, Turbo Pascal for DOS,';
      LabelEpson.Caption         := 'printer driver for big headline '
                                    + 'on Epson LQ-800';
      Labelhp.Caption            := 'printer driver '
                                    + 'for colour on hp DeskJet 500 C,';
      LabelRingbuch.Caption      := 'appointment book form';
      LabelDelphi1.Caption       := 'Delphi 1, Windows 16 bit';
      LabelJulianisch.Caption    := 'Julian calendar, monthly schedule form';
      LabelDelphi5.Caption       := 'Delphi 5, Windows 32 bit, pictures form';
      LabelInternet.Caption      := 'Internet access for mail, '
                                    + 'website and update';
      {$ifdef fpc}
        LabelGif1.Caption        := 'GIF read support,';
        LabelGif2.Caption        := '';
      {$else}
        LabelGif1.Caption        := 'GIF support by http://www.clootie.ru/ ,';
        LabelGif2.Caption        := 'since 2020 by http://www.tolderlund.eu/delphi/';
      {$endif}
      {$ifdef fpc}
        LabelPcx.Caption         := 'background';
      {$else}
        LabelPcx.Caption         := 'background, PCX import by '
                                    + 'http://www.cadsofttools.com/';
      {$endif}
      LabelSamstag.Caption       := 'HTML, RTF, Saturday in distinct colour';
      {$ifdef fpc}
        LabelPngRead1.Caption    := 'PNG read support';
        LabelPngRead2.Caption    := '';
      {$else}
        LabelPngRead1.Caption    := 'PNG read support by '
                                     + 'http://pngdelphi.sourceforge.net';
        LabelPngRead2.Caption    := 'since 2020 by https://sourceforge.net/projects/pngdelphi2/';
      {$endif}
      LabelPngWrite.Caption      := 'PNG write support';
      LabelInternational.Caption := 'formats and texts taken from the system';
      LabelPunching.Caption      := 'Delphi 10.3, '
                                     + 'appointment book punching error correction, '
                                     + 'Windows 8 shortcuts';
    end;
    LoadFormFromIni(Self);
  end;

procedure TMaintainForm.FormClose(Sender: TObject;
                                  var CloseAction: TCloseAction);
  begin
    if CloseAction = caFree then;
    SaveFormToIni(Self);
  end;

end.
