unit Preview;

{$ifdef fpc}
  {$mode objfpc}{$H+}
{$endif}

interface

uses
  {$ifdef Unix}
    WolfUtil,
  {$else}
    Windows,
  {$endif}
  {$ifdef fpc}
    LResources,
  {$endif}
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  ExtCtrls,
  Common,
  Zusatz;

type
  TPreviewForm  = class(TForm)
    Image1      : TImage;
    Image2      : TImage;
    Timer       : TTimer;
    procedure     FormResize(Sender: TObject);
    procedure     FormCreate(Sender: TObject);
    procedure     FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure     TimerTimer(Sender: TObject);
  public
    Image       : TImage;
  end;

var
  PreviewForm   : TPreviewForm;

implementation

{$R *.dfm}

Uses Main;

procedure TPreviewForm.FormResize(Sender: TObject);
  begin
    if Visible then
      begin
        MainForm.ResizePreview;
        Timer.Interval := 1000;
        Timer.enabled  := True;
      end;
    SaveFormToIni(Self);
  end;

procedure TPreviewForm.FormCreate(Sender: TObject);
  begin
    Image1.Align   := alClient;
    Image2.Align   := alClient;
    Image          := Image1;
    Image2.Visible := False;
    LoadFormFromIni(Self);
    case SysLocale.PriLangID of
      Lang_German:
    else
      Caption := 'Preview';
    end;
  end;

procedure TPreviewForm.FormClose(Sender: TObject;
                                 var CloseAction: TCloseAction);
  begin
    if CloseAction = caFree then;
    SaveFormToIni(Self);
  end;

procedure TPreviewForm.TimerTimer(Sender: TObject);
  begin
    Timer.enabled := False;
    MainForm.PaintPreview(false);
  end;

end.
