{ This here is only a dummie. The original unit uses encryption. }
{ $Id: copyrite.pas 342 2020-11-13 02:35:11Z Heiner $ }

Unit
  copyrite;

{$define NeedWolfUtil}

{$ifdef MSWINDOWS}
  { Delphi 2005 and newer }
  {$undef NeedWolfUtil}
{$endif}

{$ifdef Ver140}
  { Kylix 3 }
  {$undef NeedWolfUtil}
{$endif}

{$ifdef Ver130}
  { Delphi 5 }
  {$undef NeedWolfUtil}
{$endif}

{$ifdef Ver120}
  { Delphi 4 }
  {$undef NeedWolfUtil}
{$endif}

Interface

Uses
  {$ifndef Win32}
    Windows,
  {$else}
  {$endif}
  {$ifdef fpc}
    LConvEncoding,
    GetText,
    WolfUtil,
  {$endif}
  {$ifdef Ver130}
    SysConst,
  {$endif}
  {$ifdef Ver120}
    SysConst,
  {$endif}
  {$ifdef NeedWolfUtil}
    WolfUtil,
  {$endif}
  SysUtils,
  zusatz;

var
  CopyrightName,
  CopyrightStrasse,
  CopyrightOrt,
  CopyrightTelefonRegion,
  CopyrightTelefon,
  CopyrightTelefax,
  CopyrighteMail,
  CopyrightInternet,
  Lizenznehmer,
  LizenzVersion          : String;

function SetLizenz(Name, NewCode : String) : String;

Implementation

function International(s : String; German : Boolean) : String;
  begin
    {$ifdef FPC}
      International := CP1252toUTF8(s);
      German        := German;
    {$else}
      if German then
        International := s
      else
        begin
          s := StringReplace(s, A_ISO_LOWER_AE, 'ae', [rfReplaceAll]);
          s := StringReplace(s, A_ISO_LOWER_OE, 'oe', [rfReplaceAll]);
          s := StringReplace(s, A_ISO_LOWER_UE, 'ue', [rfReplaceAll]);
          s := StringReplace(s, A_ISO_SS      , 'ss', [rfReplaceAll]);
          s := StringReplace(s, A_ISO_UPPER_AE, 'Ae', [rfReplaceAll]);
          s := StringReplace(s, A_ISO_UPPER_OE, 'Oe', [rfReplaceAll]);
          s := StringReplace(s, A_ISO_UPPER_UE, 'Ue', [rfReplaceAll]);
          International := s;
        end;
    {$endif}
  end;

procedure CheckLizenz(LizenzCode : String);
  begin
    LizenzCode    := LizenzCode;
    Lizenznehmer  := '';
    LizenzVersion := '';
  end;

function SetLizenz(Name : String; NewCode : String) : String;
  begin
    Lizenznehmer := Name;
    CheckLizenz(NewCode);
    SetLizenz    := LizenzVersion;
  end;

procedure Decode;
  var     German : Boolean;
  begin
    German                 := SysLocale.PriLangID = LANG_GERMAN;
    CopyrightName          := 'Heinrich Wolf';
    CopyrightStrasse       := International('Keplerstrae 16a', German);
    CopyrightOrt           := International('D-90766 Frth',    German);
    CopyrightTelefonRegion := '+49-911';
    CopyrightTelefon       := '-75 30 336';
    CopyrightTelefax       := '';
    CopyrighteMail         := 'Software@Wolf-Fuerth.de';
    CopyrightInternet      := 'http://www.Wolf-Fuerth.de/';
    CheckLizenz('');
  end;

begin
  decode;
end.

