unit main;

{$ifdef fpc}
  {$mode objfpc}{$H+}
{$endif}

{$ifdef MSWINDOWS}
  {$ifndef fpc}
    { Delphi 2005 and newer }
    {$define DelphiPng}
  {$endif}
{$endif}

{$ifdef Ver130}
  { Delphi 5 }
  {$define DelphiPng}
{$endif}

{$ifdef Ver120}
  { Delphi 4 }
  {$define DelphiPng}
{$endif}

interface

uses
  {$ifdef Unix}
    Unix,
  {$else}
    Windows,
    Link,
  {$endif}
  {$ifdef fpc}
    LCLType,
    LCLIntf,
    LCLProc,
    LResources,
    LConvEncoding,
    PrintersDlgs,
    RichMemo,
  {$else}
    Jpeg,
    GifImage,
    PcxImage,
    Messages,
  {$endif}
  {$ifdef DelphiPng}
    PngImage,
  {$endif}
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  Printers,
  ExtCtrls,
  IniFiles,
  ComCtrls,
  ExtDlgs,
  Layout,
  Dates,
  Common,
  Preview,
  Copyrite,
  Zusatz,
  DelTime,
  Holidays,
  Pflege,
  bmp,
  YesNo,
  Lizenz,
  Afeier,
  WolfUtil,
  ExtJpeg,
  ExtPng;

const
  {$ifdef fpc}
    VersionTag         =   14;
    VersionMonat       =   11;
    VersionJahr        = 2020;
  {$else}
    VersionTag         =   14;
    VersionMonat       =   11;
    VersionJahr        = 2020;
  {$endif}
  
  ExtTxt               = 'txt';
  ExtHtm               = 'htm';
  ExtRtf               = 'rtf';

type
  tStatus              = (Ok, ZuvielText, FontZuHoch, FontZuBreit, PicNotFound);

  tPicIndex            = (PicIndexBmp,
                          {$ifndef fpc}
                            PicIndexGif,
                            PicIndexEmf,
                            PicIndexWmf,
                          {$endif}
                          PicIndexPng,
                          PicIndexJpg);

  tFileIndex           = (FileIndexTxt,
                          {$ifndef Unix}
                            FileIndexRtf,
                          {$endif}
                          FileIndexHtm);

  tJulDate             = Record
    JDay               : tJulianDay;
    DateName           : String;
  end;
  pJulDate             = ^tJulDate;

  tDateList            = class(tSort)
    Dates              : tList;
    Constructor          Create;
    Destructor           Destroy; override;
    function             MayContinue : Boolean; override;
    function             Compare(a, b : LongInt) : Integer; override;
    procedure            Swap(a, b : LongInt); override;
    function             GetWidth(c : tCanvas) : Word;
    procedure            Add(jDay : tJulianDay; DateName : String);
  end;

  { TMainForm }

  TMainForm              = class(TForm)
    LabelBereich         : TLabel;
    LabelMath            : TLabel;
    LabelVon             : TLabel;
    LabelBis             : TLabel;
    LabelAuthor          : TLabel;
    LabelPhone           : TLabel;
    LabelEMail           : TLabel;
    LabelInternet        : TLabel;
    LabelVersion         : TLabel;
    AuthorVal            : TLabel;
    HidePanel            : TPanel;
    Memo                 : TMemo;
    Strasse              : TLabel;
    Ort                  : TLabel;
    TelefonRegion        : TLabel;
    TelefonVal           : TLabel;
    eMailVal             : TLabel;
    InternetVal          : TLabel;
    JahrBox              : TGroupBox;
    TerminBox            : TGroupBox;
    BereichBox           : TGroupBox;
    Formular             : TRadioGroup;
    TerminListe          : TComboBox;
    BtnNewDates          : TButton;
    BtnCopyDates         : TButton;
    BtnEditDates         : TButton;
    BtnDelDates          : TButton;
    BtnDrucken           : TButton;
    PrintDialog          : TPrintDialog;
    SaveDialog           : TSaveDialog;
    LayoutGroupBox       : TGroupBox;
    LayoutComboBox       : TComboBox;
    BtnNewLayout         : TButton;
    BtnCopyLayout        : TButton;
    BtnEditLayout        : TButton;
    BtnDelLayout         : TButton;
    von                  : TEdit;
    bis                  : TEdit;
    BtnPflege            : TButton;
    BtnLink              : TButton;
    UpDownVon            : TUpDown;
    UpDownBis            : TUpDown;
    JahrEdit             : TEdit;
    Jahr                 : TUpDown;
    SavePictureDialog    : TSavePictureDialog;
    BtnExport            : TButton;
    LabelLizenz          : TLabel;
    LabelLizenznehmer    : TLabel;
    FeiertageBox         : TGroupBox;
    FeiertageListe       : TComboBox;
    IndividualHolidayBox : TGroupBox;
    AutoHolidayBox       : TGroupBox;
    BtnNewUserHoliday    : TButton;
    BtnCopyUserHoliday   : TButton;
    BtnEditUserHoliday   : TButton;
    BtnDelHoliday        : TButton;
    BtnNewAutoHoliday    : TButton;
    BtnCopyAutoHoliday   : TButton;
    BtnEditAutoHoliday   : TButton;
    RichEdit             : TRichMemo;
    procedure              BtnDruckenClick(Sender: TObject);
    procedure              FormularClick(Sender: TObject);
    procedure              FormCreate(Sender: TObject);
    procedure              BtnDelLayoutClick(Sender: TObject);
    procedure              LayoutComboBoxChange(Sender: TObject);
    procedure              BtnNewLayoutClick(Sender: TObject);
    procedure              BtnEditLayoutClick(Sender: TObject);
    procedure              BtnNewDatesClick(Sender: TObject);
    procedure              BtnEditDatesClick(Sender: TObject);
    procedure              BtnDelDatesClick(Sender: TObject);
    procedure              TerminListeChange(Sender: TObject);
    procedure              BtnCopyDatesClick(Sender: TObject);
    procedure              FormClose(Sender: TObject;
                                     var CloseAction: TCloseAction);
    procedure              VonChange(Sender: TObject);
    procedure              BisChange(Sender: TObject);
    procedure              JahrChange(Sender: TObject);
    procedure              BtnPflegeClick(Sender: TObject);
    procedure              eMailValClick(Sender: TObject);
    procedure              InternetValClick(Sender: TObject);
    procedure              BtnLinkClick(Sender: TObject);
    procedure              BtnExportClick(Sender: TObject);
    procedure              JahrEditExit(Sender: TObject);
    procedure              UpDownBisClick(Sender: TObject; Button: TUDBtnType);
    procedure              UpDownVonClick(Sender: TObject; Button: TUDBtnType);
    procedure              LabelLizenznehmerClick(Sender: TObject);
    procedure              FeiertageListeChange(Sender: TObject);
    procedure              BtnNewUserHolidayClick(Sender: TObject);
    procedure              BtnNewAutoHolidayClick(Sender: TObject);
    procedure              BtnCopyUserHolidayClick(Sender: TObject);
    procedure              BtnEditUserHolidayClick(Sender: TObject);
    procedure              BtnDelHolidayClick(Sender: TObject);
    procedure              BtnCopyAutoHolidayClick(Sender: TObject);
    procedure              BtnEditAutoHolidayClick(Sender: TObject);
    procedure              BtnCopyLayoutClick(Sender: TObject);
  private
    ThinPenWidth,
    ThickPenWidth,
    LochX, LochY,
    LochRand,
    TextRand,
    TextHoehe,
    FeiertagHoehe,
    CanvasX,
    CanvasY,
    LineGap,
    yEnde,
    WTagWeite,
    ZahlWeite,
    DayGap,
    WochenBreite,
    PunktWeite,
    BlankWeite,
    MondHoehe,
    MondWeite,
    FormBreite,
    FormHoehe,
    Mitte,
    Spalten,
    Breite, Hoehe,
    Loch1,  Loch2,
    Loch3,
    RichLen           : Integer;
    RichFormat        : tList;
    Status            : tStatus;
    Keine,
    Standard          : String;
    DayLightDate1,
    DoubleSummerDate,
    DayLightDate2,
    StandardDate      : tJulianDay;
    procedure           ClearPreview;
    procedure           FeierOut(x : Integer; Holiday : tJulDate; c : tCanvas);
    procedure           BlockMonat(Monat, xBeginn, yBeginn : Integer;
                                   c: tCanvas);
    function            PaintEineSeite(var x, y : Word; cv : tCanvas) : Boolean;
    procedure           PreviewEineSeite;
    procedure           PrintEineSeite;
    procedure           BmpEineSeite(Bitmap : tBitmap);
    procedure           EmfEineSeite;
    procedure           PrepareRingbuch(PixelsX, PixelsY, MaxBreite : Word;
                                        c : tCanvas);
    procedure           PrintTag(x, yVon, yBis : word; Datum : tJulianDay;
                                 var NaechstesMondDatum : tJulianDay;
                                 var NaechsteMondPhase  : tMoonsPhase;
                                 c : tCanvas);
    procedure           PaintRingbuch(Woche : Integer; Datum : tJulianDay;
                                      x : Integer; c : tCanvas);
    procedure           PreviewRingbuch;
    procedure           PrintRingbuch;
    procedure           BmpRingbuch(Bitmap : tBitmap);
    procedure           EmfRingbuch;
    procedure           PrepareBilder(c : tCanvas);
    procedure           PrintBilder;
    procedure           PaintBilder(Monat : Word; c : tCanvas);
    procedure           PreviewBilder;
    procedure           BmpBilder(Bitmap : tBitmap);
    procedure           EmfBilder;
    procedure           PrepareMonatsplaner(PixelsY : Word; c : tCanvas);
    procedure           PaintMonatHeader(c : tCanvas);
    procedure           PaintMonat(Monat, y : Word; c : tCanvas);
    procedure           PrintMonatsplaner;
    procedure           PreviewMonatsplaner;
    procedure           BmpMonatsplaner(Bitmap : tBitmap);
    procedure           EmfMonatsplaner;
    procedure           Datei;
    procedure           TextDatei;
    procedure           HTMLDatei;
    procedure           RTFDatei;
    procedure           EnableAll(MakeEnabled : Boolean);
    procedure           ShowLayout;
    procedure           SaveLayouts;
    procedure           SaveTerminListen;
    procedure           SaveFeiertageListe;
    procedure           TerminListeLoad;
    procedure           UserHolidaysLoad;
    procedure           AutoHolidaysLoad;
    procedure           LayoutLoad;
    procedure           CheckTerminListeButtons;
    procedure           CheckLayoutButtons;
    procedure           CheckFeiertageButtons;
    procedure           StatusCheck;
    procedure           KorrektVon;
    procedure           KorrektBis;
    function            CalPrintHoliday(JulianDay    : tJulianDay;
                                        var Holidays : String) : Boolean;
    procedure           TextOutRight(x, y : Integer; s : String;
                                     c : tCanvas);
    procedure           TextOutCenter(x, y, Max : Integer; s : String;
                                      c : tCanvas);
    procedure           SplitText(var Txt, Part : String;
                                  b             : Word;
                                  c             : tCanvas;
                                  KeepBlanks    : Boolean);
    function            MMtoPixel(MM : Real; PixelPerInch : Word) : Word;
    function            GetMonat(Txt : String) : Integer;
    function            GetWochenBreite(c : tCanvas) : Word;
    function            GetTagWeite(c : tCanvas) : Word;
    procedure           DownClick(Edit : TEdit);
    procedure           UpClick(Edit : TEdit);
    procedure           SaveBMP(Bitmap : tBitmap; D : String;
                                var YesNo : Integer);
    {$ifndef fpc}
      procedure         SaveEmf(MetaFile : tMetaFile; Datei : String;
                                var YesNo : Integer);
      procedure         CreateMetaFile(Description        : String;
                                       var MetaFile       : tMetaFile;
                                       var MetaFileCanvas : tMetaFileCanvas);
    {$endif}
    procedure           PaintBkgnd(c : tCanvas;
                                   x, y, Br, Hh : Integer);
    procedure           RTFAdd(s : String; f : tFont);
    function            DaylightText(Datum : tJulianDay) : String;
  public
    procedure           PublicSaveLayouts;
    procedure           PrintDates;
    procedure           ResizePreview;
    procedure           PaintPreview(Check : Boolean);
    procedure           ClosePreview;
    procedure           ShowPreview;
  end;

var MainForm : TMainForm;

implementation

{$R *.dfm}

{$ifndef Unix}
  function GetMetric(c : tCanvas) : pOutlineTextMetric;
    var    i      : Integer;
           Metric : pOutlineTextMetric;
    begin
      i := GetOutlineTextMetrics(c.Handle, 0, Nil);
      if i = 0 then
        i := sizeof(tOutlineTextMetric);
      GetMem(Metric, i);
      Metric^.otmSize := i;
      if GetOutlineTextMetrics(c.Handle, i, pointer(Metric)) <> 0 then
        GetMetric := Metric
      else
        begin
          FreeMem(Metric, i);
          GetMetric := Nil;
        end;
    end;
{$endif}

function GetTextHoehe(c : tCanvas) : Integer;
  var    Metric :
           {$ifdef Unix}
             Pointer;
           {$else}
             pOutlineTextMetric;
           {$endif}
  begin
    {$ifdef Unix}
      Metric := Nil;
    {$else}
      Metric := GetMetric(c);
    {$endif}
    if Metric = Nil then
      GetTextHoehe := c.TextHeight(CP1252ToSystem('g')) * 25 div 20
    else
      begin
        {$ifdef Unix}
          GetTextHoehe := 0;
        {$else}
          GetTextHoehe := Metric^.otmTextMetrics.tmHeight
                          + longint(Metric^.otmLineGap);
          FreeMem(Metric);
        {$endif}
      end;
  end;

function GetMondHoehe(c : tCanvas) : Integer;
  var    Metric :
           {$ifdef Unix}
             Pointer;
           {$else}
             pOutlineTextMetric;
           {$endif}
  begin
    {$ifdef Unix}
      Metric := Nil;
    {$else}
      Metric := GetMetric(c);
    {$endif}
    if Metric = Nil then
      GetMondHoehe := c.TextHeight(CP1252ToSystem('g')) * 7 div 10
    else
      begin
        {$ifdef Unix}
          GetMondHoehe := 0;
        {$else}
          GetMondHoehe := Metric^.otmTextMetrics.tmAscent
                          - LongInt(Metric^.otmLineGap);
          FreeMem(Metric);
        {$endif}
      end;
  end;

function GetLineGap(c : tCanvas) : Integer;
  var    Metric :
           {$ifdef Unix}
             Pointer;
           {$else}
             pOutlineTextMetric;
           {$endif}
  begin
    {$ifdef Unix}
      Metric := Nil;
    {$else}
      Metric := GetMetric(c);
    {$endif}
    if Metric = Nil then
      GetLineGap := c.TextHeight(CP1252ToSystem('g')) div 4
    else
      begin
        {$ifdef Unix}
          GetLineGap := 0;
        {$else}
          GetLineGap := Metric^.otmLineGap;
          FreeMem(Metric);
        {$endif}
      end;
  end;

function LongWeekName : String;
  begin
    case SysLocale.PriLangID of
      LANG_GERMAN:
        LongWeekName := 'Woche';
    else
      LongWeekName := 'Week';
    end;
  end;

function ShortWeekName : String;
  begin
    case SysLocale.PriLangID of
      LANG_GERMAN:
        ShortWeekName := 'Wo';
    else
      ShortWeekName := 'Wk';
    end;
  end;

function TMainForm.DaylightText(Datum: tJulianDay): String;
  begin
    if LocalSameDate(Datum, DaylightDate1) then
      case SysLocale.PriLangID of
        LANG_GERMAN : DaylightText := 'Sommerzeit Beginn';
      else
        DaylightText := 'Start of daylight savings time';
      end
    else
      if LocalSameDate(Datum, DoubleSummerDate) then
        case SysLocale.PriLangID of
          LANG_GERMAN : DaylightText := 'Hochsommerzeit Beginn';
        else
          DaylightText := 'Start of double summer time';
        end
      else
        if LocalSameDate(Datum, DaylightDate2) then
          case SysLocale.PriLangID of
            LANG_GERMAN : DaylightText := 'Hochsommerzeit Ende';
          else
            DaylightText := 'End of double summer time';
          end
        else
          if LocalSameDate(Datum, StandardDate) then
            case SysLocale.PriLangID of
              LANG_GERMAN : DaylightText := 'Normalzeit Beginn';
            else
              DaylightText := 'Start of standard time';
            end
          else
            DaylightText := '';
  end;

Constructor tDateList.Create;
  begin
    inherited create;
    try
      Dates := tList.Create;
    except
      Dates := Nil;
    end;
    if Dates = Nil then
      raise Exception.Create('error in tDateList.Create');
  end;

Destructor tDateList.Destroy;
  begin
    if Dates <> Nil then
      begin
        While Dates.Count > 0 do
          begin
            Dispose(pJulDate(Dates.Items[0]));
            Dates.Delete(0);
          end;
        Dates.Free;
      end;
    inherited destroy;
  end;

function tDateList.MayContinue : Boolean;
  begin
    MayContinue := True;
  end;

function tDateList.Compare(a, b : LongInt) : Integer;
  begin
    if pJulDate(Dates.Items[a])^.JDay
       = pJulDate(Dates.Items[b])^.JDay then
      Compare := AnsiCompareStr(pJulDate(Dates.Items[a])^.DateName,
                                pJulDate(Dates.Items[b])^.DateName)
    else
      Compare := trunc(pJulDate(Dates.Items[a])^.JDay
                       - pJulDate(Dates.Items[b])^.JDay);
  end;

function tDateList.GetWidth(c : tCanvas) : Word;
  var    w, j : Word;
         i    : Integer;
  begin
    w := 0;
    for i := 0 to Dates.Count - 1 do
      begin
        j := c.TextWidth(pJulDate(Dates.Items[i])^.DateName);
        if j > w then
          w := j;
      end;
    GetWidth := w;
  end;

procedure tDateList.Add(jDay : tJulianDay; DateName : String);
  var     JulDate : pJulDate;
  begin
    New(JulDate);
    if JulDate = Nil then
      MsgBox('Cannot add date to list', MainForm.Caption, mb_IconHand)
    else
      begin
        JulDate^.JDay     := jDay;
        JulDate^.DateName := DateName;
        Dates.Add(JulDate);
      end;
  end;

procedure tDateList.Swap(a, b : LongInt);
  begin
    Dates.Exchange(a, b);
  end;

procedure TMainForm.TextOutRight(x, y: Integer; s: String; c: tCanvas);
  begin
    c.TextOut(x - c.TextWidth(s), y, s);
  end;

procedure TMainForm.TextOutCenter(x, y, Max: Integer; s: String; c: tCanvas);
  var w : Integer;
  begin
    w := c.TextWidth(s);
    if w > Max then
      Status := FontZuBreit;
    c.TextOut(x - w div 2, y, s);
  end;

procedure TMainForm.SplitText(var Txt, Part: String; b: Word; c: tCanvas;
 KeepBlanks: Boolean);
  var p : Integer;
      t : String;
  begin
    if not KeepBlanks then
      while Copy(Txt, 1, 1) = ' ' do
        Txt := Copy(Txt, 2, $100);
    if c.TextWidth(Txt) <= b then
      begin
        Part := Txt;
        Txt  := '';
      end
    else
      begin
        Part := '';
        repeat
          p := 1 + Pos(' ', Copy(Txt, 2, $100));
          if p > 1 then
            begin
              t := Copy(Txt, 1, p - 1);
              if c.TextWidth(Part + t) > b then
                p := 0
              else
                begin
                  Part := Part + t;
                  Txt  := Copy(Txt, p, $100);
                end;
            end;
        until p <= 1;
        if Part = '' then
          repeat
            t := Copy(Txt, 1, 1);
            if c.TextWidth(Part + t) > b then
              t := ''
            else
              begin
                Part := Part + t;
                Txt  := Copy(Txt, 2, $100);
              end;
          until t = '';
      end;
  end;

function TMainForm.MMtoPixel(MM: Real; PixelPerInch: Word): Word;
  begin
    MMtoPixel := round((MM * PixelPerInch) / 25.4);
  end;

function TMainForm.CalPrintHoliday(JulianDay: tJulianDay; var Holidays: String
 ): Boolean;
  var    s : String;
  begin
    Holidays := '';
    s        := '';
    CalPrintHoliday := LocalJulDayOfWeek(JulianDay) = Sunday;
    if AutoHolidayForm.IsHoliday(JulianDay, s) then
      CalPrintHoliday := True;
    if s > '' then
      Holidays := Holidays + A_LF + s;
    if UserHolidaysForm.IsHoliday(JulianDay, s) then
      CalPrintHoliday := True;
    if s > '' then
      Holidays := Holidays + A_LF + s;
    Holidays := Copy(Holidays, 2, length(Holidays));
  end;

procedure TMainForm.ResizePreview;
  begin
    PreviewForm.ClientWidth :=
      (LongInt(PreviewForm.ClientHeight)
       * LayoutForm.PrinterResX) div LayoutForm.PrinterResY;
  end;

procedure TMainForm.ClearPreview;
  begin
    PreviewForm.Image.Picture.Bitmap.Canvas.Brush.Style := bsSolid;
    PreviewForm.Image.Picture.Bitmap.Canvas.Brush.Color := clWhite;
    PreviewForm.Image.Picture.Bitmap.Canvas.FillRect(Rect(0, 0,
      PreviewForm.Image.Picture.Bitmap.Width,
      PreviewForm.Image.Picture.Bitmap.Height));
  end;

procedure TMainForm.PrepareMonatsplaner(PixelsY: Word; c: tCanvas);
  var     i, w : Integer;
  begin
    c.Font.Name    := LayoutForm.FontData[eArbeitsTag, False].Name;
    c.Font.Charset := LayoutForm.FontData[eArbeitsTag, False].Charset;
    c.Font.Size    := (LayoutForm.FontData[eArbeitsTag, False].Size
                       * longint(PixelsY)) div c.Font.PixelsPerInch;
    c.Font.Style   := [];
    c.Brush.Style  := bsClear;
    ThinPenWidth   := MMtoPixel(MMPenWidth,     PixelsY);
    ThickPenWidth  := MMtoPixel(2 * MMPenWidth, PixelsY);
    LochRand       := MMtoPixel(MMTextRand,     PixelsY);
    ZahlWeite      := GetTagWeite(c) + ThickPenWidth;
    TextRand       := 0;
    for i := 1 to 12 do
      begin
        w := c.TextWidth(GetLongMonthName(i));
        if w > TextRand Then
          TextRand := w;
      end;
    Inc(TextRand, ThickPenWidth);
    if TextRand + 6 * ThickPenWidth + 31 * ThinPenWidth + 37 * ZahlWeite
       >= FormBreite
    then
      Status  := FontZuBreit;
    Breite    := FormBreite - TextRand;
    TextHoehe := GetTextHoehe(c);
    Hoehe     := (FormHoehe - TextHoehe - LochRand) div 2;
  end;

procedure TMainForm.PaintMonatHeader(c: tCanvas);
  var     i : LongInt;
  begin
    c.Font.Name    := LayoutForm.FontData[eArbeitsTag, False].Name;
    c.Font.Charset := LayoutForm.FontData[eArbeitsTag, False].Charset;
    c.Font.Size    := (LayoutForm.FontData[eArbeitsTag, False].Size
                       * longint(CanvasY)) div c.Font.PixelsPerInch;
    c.Font.Style   := [];
    c.Brush.Style  := bsClear;
    PaintBkgnd(c, 0, 0, FormBreite, FormHoehe);
    c.Pen.Color    := clBlack;
    c.Pen.Mode     := pmCopy;
    c.Font.Style   := LayoutForm.FontData[eArbeitsTag, False].Style;
    c.Font.Color   := LayoutForm.FontData[eArbeitsTag, False].Color;
    c.Brush.style  := bsClear;
    c.TextOut(0, LochRand, YearText(Jahr.Position));
    for i := 0 to 36 do
      begin
        if (i + Monday + 6) mod 7 + 1 = Monday then
          c.Pen.Width  := ThickPenWidth
        else
          c.Pen.Width  := ThinPenWidth;
        c.MoveTo(TextRand + (i * Breite) div 37, LochRand);
        c.LineTo(TextRand + (i * Breite) div 37,
                      LochRand + 2 * ThickPenWidth + TextHoehe);
        case (i + Monday + 6) mod 7 + 1 of
          Sunday:
            begin
              c.Font.Style := LayoutForm.FontData[eFeiertag, False].Style;
              c.Font.Color := LayoutForm.FontData[eFeiertag, False].Color;
            end;
          Saturday:
            begin
              c.Font.Style := LayoutForm.FontData[eSamstag, False].Style;
              c.Font.Color := LayoutForm.FontData[eSamstag, False].Color;
            end;
        else
          begin
            c.Font.Style := LayoutForm.FontData[eArbeitsTag, False].Style;
            c.Font.Color := LayoutForm.FontData[eArbeitsTag, False].Color;
          end;
        end;
        TextOutRight(TextRand + ((i + 1) * Breite) div 37 - ThickPenWidth,
                     LochRand,
                     Copy(GetShortDayName((i + Monday + 6) mod 7 + 1), 1, 2), c);
      end;
  end;

procedure TMainForm.PaintMonat(Monat, y: Word; c: tCanvas);
  var     i     : LongInt;
          j     : Integer;
          m     : Word;
          day   : Double;
          Datum : tJulianDay;
          s, t  : String;
          b     : Boolean;
  begin
    c.Pen.Color := clBlack;
    c.Pen.Width := ThickPenWidth;
    c.Pen.Mode  := pmCopy;
    c.MoveTo(0,          y);
    c.LineTo(FormBreite, y);
    c.MoveTo(0,          y + ThickPenWidth + TextHoehe);
    c.LineTo(FormBreite, y + ThickPenWidth + TextHoehe);
    c.Pen.Width   := ThinPenWidth;
    c.Brush.style := bsClear;
    c.Font.Style  := LayoutForm.FontData[eArbeitsTag, False].Style;
    c.Font.Color  := LayoutForm.FontData[eArbeitsTag, False].Color;
    i := 2 * (ThickPenWidth + TextHoehe);
    while i < Hoehe do
      begin
        c.MoveTo(0,          y + i);
        c.LineTo(FormBreite, y + i);
        Inc(i, ThinPenWidth + TextHoehe);
      end;
    c.TextOut(0, y + ThickPenWidth, GetLongMonthName(Monat));
    m     := Monat;
    day   := 1.5;
    Datum := LocalJulianDay(Jahr.Position, m, day);
    i := (LocalJulDayOfWeek(Datum) + 7 - Monday) mod 7 + 1;
    while m = Monat do
      begin
        Application.ProcessMessages;
        s:= IntToStr(Trunc(day));
        b := DatesForm.IsTermin(trunc(day), Monat, Jahr.Position) > '';
        t := '';
        if CalPrintHoliday(Datum, t) Then
          begin
            c.Font.Color := LayoutForm.FontData[eFeiertag, b].Color;
            c.Font.Style := LayoutForm.FontData[eFeiertag, b].Style;
          end
        else
          if LocalJulDayOfWeek(Datum) = Saturday then
            begin
              c.Font.Color := LayoutForm.FontData[eSamstag, b].Color;
              c.Font.Style := LayoutForm.FontData[eSamstag, b].Style;
            end
          else
            begin
              c.Font.Color := LayoutForm.FontData[eArbeitsTag, b].Color;
              c.Font.Style := LayoutForm.FontData[eArbeitsTag, b].Style;
            end;
        TextOutRight(TextRand - ThickPenWidth + (i * Breite) div 37,
                     y + ThickPenWidth, s, c);
        inc(i);
        Datum := Datum + 1;
        j     := 0;
        LocalJulianDate(Datum, j, m, day);
      end;
    for i := 0 to 36 do
      begin
        if (i + Monday + 6) mod 7 + 1 = Monday then
          c.Pen.Width := ThickPenWidth
        else
          c.Pen.Width := ThinPenWidth;
        c.MoveTo(TextRand + (i * Breite) div 37, y);
        c.LineTo(TextRand + (i * Breite) div 37, y + Hoehe);
      end;
  end;

function TMainForm.GetMonat(Txt: String): Integer;
  var    i : Integer;
  begin
    if Txt = '' then
      GetMonat := 0
    else
      begin
        GetMonat := -1;
        for i := 1 to 12 do
          if AnsiUpperCase(Txt) = AnsiUpperCase(GetLongMonthName(i)) then
            GetMonat := i;
      end;
  end;

procedure TMainForm.PreviewMonatsplaner;
  var     iVon : Integer;
  begin
    FormBreite := PreviewForm.ClientWidth;
    FormHoehe  := PreviewForm.ClientHeight;
    PrepareMonatsplaner(CanvasY, PreviewForm.Image.Picture.Bitmap.Canvas);
    PaintMonatHeader(PreviewForm.Image.Picture.Bitmap.Canvas);
    iVon := GetMonat(von.Text);
    if iVon > 11 then
      iVon := 11;
    PaintMonat(iVon,     LochRand + 2 * ThickPenWidth + TextHoehe,
               PreviewForm.Image.Picture.Bitmap.Canvas);
    PaintMonat(iVon + 1, LochRand + 2 * ThickPenWidth + TextHoehe + Hoehe,
               PreviewForm.Image.Picture.Bitmap.Canvas);
  end;

procedure TMainForm.LayoutLoad;
  begin
    if LayoutCombobox.Text = Standard then
      LayoutForm.Layout.Text := ''
    else
      LayoutForm.Layout.Text := LayoutCombobox.Text;
    LayoutForm.Load;
  end;

procedure TMainForm.SaveBMP(Bitmap: tBitmap; D: String; var YesNo: Integer);
  var     Graphic : tGraphic;
          s       : String;
  begin
    if Status = Ok then
      begin
        Graphic := Nil;
        s       := '';
        try
          case TPicIndex(SavePictureDialog.FilterIndex - 1) of
            PicIndexJpg :
              begin
                try
                  Graphic := tJPegImage.Create;
                except
                  Graphic := Nil;
                end;
                if Graphic <> Nil then
                  begin
                    (Graphic as tJPegImage).CompressionQuality  := 100;
                    {$ifndef fpc}
                      (Graphic as tJPegImage).Grayscale           := False;
                      (Graphic as tJPegImage).ProgressiveEncoding := False;
                    {$endif}
                  end;
              end;
            PicIndexBmp   : try
                              Graphic := tBitmap.Create;
                            except
                              Graphic := Nil;
                            end;
            {$ifdef fpc}
              PicIndexPng : try
                              Graphic := tPortableNetworkGraphic.Create;
                            except
                              Graphic := Nil;
                            end;
            {$else}
              PicIndexGif : try
                              Graphic := tGifImage.Create;
                            except
                              Graphic := Nil;
                            end;
            {$endif}
            {$ifdef DelphiPng}
              PicIndexPng : try
                              Graphic := tPngObject.Create;
                            except
                              Graphic := Nil;
                            end;
            {$endif}
          end;
          if Graphic = Nil then
            case SysLocale.PriLangID of
              Lang_German:
                MsgBox('Speichern gescheitert! kann Bild nicht erzeugen.',
                       Caption, mb_IconHand);
            else
              MsgBox('Saving failed! Cannot create picture.',
                     Caption, mb_IconHand);
            end
          else
            begin
              Graphic.Assign(Bitmap);
              if not FileExists(D) then
                Graphic.SaveToFile(D)
              else
                if YesNo = mrYesToAll then
                  Graphic.SaveToFile(D)
                else
                  if YesNo <> mrNoToAll then
                    begin
                      case SysLocale.PriLangID of
                        Lang_German:
                          YesNoForm.Datei.Caption :=
                            D + A_LF + CP1252toSystem('berschreiben?');
                      else
                          YesNoForm.Datei.Caption :=
                            'override' + A_LF + D + ' ?';
                      end;
                      if YesNoForm.Datei.Width + 2 * YesNoForm.Datei.Left
                         > YesNoForm.ClientWidth
                      then
                        YesNoForm.ClientWidth :=
                          YesNoForm.Datei.Width + 2 * YesNoForm.Datei.Left;
                      YesNo := YesNoForm.ShowModal;
                      if (YesNo = mrYes) or (YesNo = mrYesToAll) then
                        Graphic.SaveToFile(D);
                    end;
              case TPicIndex(SavePictureDialog.FilterIndex - 1) of
                PicIndexBmp : SetBmpDPI(D,  BmpForm.UpDownDPI.Position,
                                            BmpForm.UpDownDPI.Position);
                PicIndexJpg : SetJpegDPI(D, BmpForm.UpDownDPI.Position,
                                            BmpForm.UpDownDPI.Position);
                PicIndexPng : SetPngPixPerMeter(D,
                  (BmpForm.UpDownDPI.Position * 10000) div 254,
                  (BmpForm.UpDownDPI.Position * 10000) div 254);
              end;
            end;
        except
          on e : exception do
            s := e.Message;
        end;
        if s > '' then
          begin
            DeleteFile(D);
            case SysLocale.PriLangID of
              Lang_German:
                MsgBox('Speichern gescheitert! '
                       + 'Versuchen Sie es z.B. mit weniger DPI nochmal.'
                       + a_LF + s,
                       Caption, mb_IconHand);
            else
              MsgBox('Saving failed! Try again e.g. with less DPI.' + a_LF + s,
                     Caption, mb_IconHand);
            end;
          end;
        Graphic.Free;
      end;
  end;

{$ifndef fpc}
  procedure tMainForm.SaveEmf(MetaFile  : tMetaFile;
                              Datei     : String;
                              var YesNo : Integer);
    begin
      if Status = Ok then
        begin
          if not FileExists(Datei) then
            MetaFile.SaveToFile(Datei)
          else
            if YesNo = mrYesToAll then
              MetaFile.SaveToFile(Datei)
            else
              if YesNo <> mrNoToAll then
                begin
                  case SysLocale.PriLangID of
                    Lang_German:
                      YesNoForm.Datei.Caption :=
                        Datei + A_LF + CP1252ToSystem('berschreiben?');
                  else
                      YesNoForm.Datei.Caption :=
                        'override' + A_LF + Datei + ' ?';
                  end;
                  if YesNoForm.Datei.Width + 2 * YesNoForm.Datei.Left
                     > YesNoForm.ClientWidth
                  then
                    YesNoForm.ClientWidth :=
                      YesNoForm.Datei.Width + 2 * YesNoForm.Datei.Left;
                  YesNo := YesNoForm.ShowModal;
                  if (YesNo = mrYes) or (YesNo = mrYesToAll) then
                    MetaFile.SaveToFile(Datei);
                end;
        end;
    end;

  procedure TMainForm.CreateMetaFile(Description        : String;
                                     var MetaFile       : tMetaFile;
                                     var MetaFileCanvas : tMetaFileCanvas);
    begin
      try
        MetaFile := tMetaFile.Create;
      except
        MetaFile := Nil;
      end;
      if MetaFile <> Nil then
        begin
          MetaFile.Enhanced := SavePictureDialog.FilterIndex
                               = ord(PicIndexEmf) + 1;
          try
            MetaFileCanvas :=
              tMetaFileCanvas.CreateWithComment(
                MetaFile, Printer.Canvas.Handle,
                CalPrint + ' ' + CopyrightInternet, Description);
          except
            MetaFileCanvas := Nil;
          end;
          if MetaFileCanvas = Nil then
            begin
              MetaFile.Free;
              MetaFile := Nil;
            end;
        end;
    end;
{$endif}

procedure TMainForm.BmpMonatsplaner(Bitmap: tBitmap);
  var     y,
          Monat : Word;
          iVon,
          iBis,
          YesNo : Integer;
          s, t  : String;
  begin
    PrepareMonatsplaner(BmpForm.UpDownDPI.Position, Bitmap.Canvas);
    iVon := GetMonat(von.Text);
    iBis := GetMonat(Bis.Text);
    if iBis = 0 then
      iBis := iVon;
    Monat  := iVon;
    YesNo  := mrNo;
    while Monat <= iBis do
      begin
        y := LochRand + 2 * ThickPenWidth + TextHoehe;
        if odd(Monat - iVon) then
          inc(y, Hoehe)
        else
          begin
            Bitmap.Canvas.Brush.Color := clWhite;
            Bitmap.Canvas.Brush.Style := bsSolid;
            Bitmap.Canvas.FillRect(Rect(0, 0, Bitmap.Width, Bitmap.Height));
            PaintMonatHeader(Bitmap.Canvas);
          end;
        PaintMonat(Monat, y, Bitmap.Canvas);
        if odd(Monat - iVon) or (Monat = iBis) then
          begin
            s := SavePictureDialog.FileName;
            if iBis - iVon > 1 then
              begin
                t := ExtractFileExt(s);
                s := Copy(s, 1, length(s) - length(t)) + ' ';
                if odd(Monat - iVon) then
                  s := s + GetShortMonthName(Monat - 1) + ' - '
                         + GetShortMonthName(Monat) + t
                else
                  s := s + GetShortMonthName(Monat) + t;
              end;
            SaveBMP(Bitmap, s, YesNo);
          end;
        inc(Monat);
      end;
  end;

procedure TMainForm.EmfMonatsplaner;
  {$ifndef fpc}
    var   y,
          Monat          : Word;
          iVon, iBis,
          YesNo          : Integer;
          s, t           : String;
          MetaFile       : tMetaFile;
          MetaFileCanvas : tMetaFileCanvas;
  {$endif}
  begin
    {$ifndef fpc}
      MetaFileCanvas := Nil;
      MetaFile       := Nil;
      PrepareMonatsplaner(BmpForm.UpDownDPI.Position, Printer.Canvas);
      iVon := GetMonat(von.Text);
      iBis := GetMonat(Bis.Text);
      if iBis = 0 then
        iBis := iVon;
      Monat  := iVon;
      YesNo  := mrNo;
      while Monat <= iBis do
        begin
          y := LochRand + 2 * ThickPenWidth + TextHoehe;
          if odd(Monat - iVon) then
            inc(y, Hoehe)
          else
            begin
              case SysLocale.PriLangID of
                Lang_German:
                  begin
                    s := GetLongMonthName(Monat);
                    if Monat < iBis then
                      s := s + ' bis ' + GetLongMonthName(Monat + 1);
                    CreateMetaFile('Montsplaner ' + s,
                                   MetaFile, MetaFileCanvas);
                    if MetaFile = Nil then
                      MsgBox(CP1252ToSystem('kann Metafile fr ') + s
                             + ' nicht erzeugen', Caption, mb_IconHand);
                  end;
              else
                s := GetLongMonthName(Monat);
                if Monat < iBis then
                  s := s + ' to ' + GetLongMonthName(Monat + 1);
                CreateMetaFile('monthly schedule ' + s,
                               MetaFile, MetaFileCanvas);
                if MetaFile = nil then
                  MsgBox('cannot create metafile of ' + s,
                         Caption, mb_IconHand);
              end;
              if MetaFile = Nil then
                Monat := iBis
              else
                PaintMonatHeader(MetaFileCanvas);
            end;
          if MetaFile <> Nil then
            begin
              PaintMonat(Monat, y, MetaFileCanvas);
              if odd(Monat - iVon) or (Monat = iBis) then
                begin
                  s := SavePictureDialog.FileName;
                  if iBis - iVon > 1 then
                    begin
                      t := ExtractFileExt(s);
                      s := Copy(s, 1, length(s) - length(t)) + ' ';
                      if odd(Monat - iVon) then
                        s := s + GetShortMonthName(Monat - 1) + ' - '
                               + GetShortMonthName(Monat) + t
                      else
                        s := s + GetShortMonthName(Monat) + t;
                    end;
                  MetaFileCanvas.Free;
                  SaveEMF(MetaFile, s, YesNo);
                  MetaFile.Free;
                end;
              inc(Monat);
            end;
        end;
    {$endif}
  end;

procedure TMainForm.PrintMonatsplaner;
  var     k, y,
          Monat,
          Copies : Word;
          s      : String;
          iVon,
          iBis   : Integer;
  begin
    s := FormularName(FormularMonat, SysLocale.PriLangID) + ' ' + Von.Text;
    if Bis.Text > '' then
      s := s + ' - ' + Bis.Text;
    Printer.Title      := s + ' ' + YearText(Jahr.Position);
    FormBreite         := LayoutForm.PrinterResX;
    FormHoehe          := LayoutForm.PrinterResY;
    Copies             := PrintDialog.Copies;
    PrintDialog.Copies := 1;
    k := 0;
    while k < Copies do
      begin
        inc(k);
        Printer.BeginDoc;
        if k = 1 then
          PrepareMonatsplaner(LayoutForm.PrinterLogY, Printer.Canvas);
        if (Status = FontZuBreit) and (LayoutForm.CheckSizes.Checked) then
          begin
            Printer.Abort;
            k := Copies;
          end
        else
          begin
            iVon := GetMonat(von.Text);
            iBis := GetMonat(Bis.Text);
            if iBis = 0 then
              iBis := iVon;
            Monat := iVon;
            while Monat <= iBis do
              begin
                y := LochRand + 2 * ThickPenWidth + TextHoehe;
                if odd(Monat - iVon) then
                  inc(y, Hoehe)
                else
                  PaintMonatHeader(Printer.Canvas);
                PaintMonat(Monat, y, Printer.Canvas);
                if odd(Monat - iVon) and (Monat <> iBis) then
                  Printer.NewPage;
                inc(Monat);
              end;
          end;
        Printer.EndDoc;
      end;
  end;

procedure TMainForm.ClosePreview;
  begin
    PreviewForm.Close;
    EnableAll(True);
  end;

procedure TMainForm.ShowPreview;
  begin
    if PreviewForm.Visible then
      PaintPreview(True);
  end;

procedure TMainForm.PublicSaveLayouts;
  begin
    LayoutComboBox.ItemIndex :=
      LayoutComboBox.Items.Add(LayoutForm.Layout.Text);
    CheckLayoutButtons;
    SaveLayouts;
  end;

procedure TMainForm.PrintDates;
  var     ZeilenHoehe,
          PosTag,
          PosMonat,
          PosJahr,
          PosText,
          k, y,
          Zeilen,
          Seite      : Integer;
          i          : LongInt;
          Copies     : Word;
          s, Txt     : String;
  begin
    if PrintDialog.Execute then
      begin
        LayoutLoad;
        Screen.Cursor := crHourGlass;
        FormHoehe     := LayoutForm.PrinterResY;
        FormBreite    := LayoutForm.PrinterResX;
        With Printer.Canvas.Font do
          begin
            Name  := LayoutForm.FontData[eArbeitsTag, False].Name;
            Size  := LayoutForm.FontData[eArbeitsTag, False].Size;
            Style := [];
            Color := clBlack;
          end;
        case SysLocale.PriLangID of
          LANG_GERMAN:
            Printer.Title := 'Kalender Termine ' + DatesForm.Liste.Text;
        else
            Printer.Title := 'Calendar dates '   + DatesForm.Liste.Text;
        end;
        i                  := Printer.Canvas.TextWidth('##. ');
        PosTag             := Printer.Canvas.TextWidth('#######');
        PosMonat           := PosTag   + i;
        PosJahr            := PosMonat + i;
        PosText            := PosJahr  + Printer.Canvas.TextWidth('#### ');
        Copies             := PrintDialog.Copies;
        PrintDialog.Copies := 1;
        k                  := 0;
        while k < Copies do
          begin
            inc(k);
            Printer.BeginDoc;
            ZeilenHoehe := GetTextHoehe(Printer.Canvas);
            Zeilen      := FormHoehe div ZeilenHoehe - 2;
            y           := 0;
            Seite       := 1;
            for i := 1 to DatesForm.Grid.RowCount - 1 do
              begin
                Application.ProcessMessages;
                Printer.Canvas.TextOut(PosTag,   y * ZeilenHoehe,
                                       DatesForm.Grid.Cells[0, i] + '.');
                Printer.Canvas.TextOut(PosMonat, y * ZeilenHoehe,
                                       DatesForm.Grid.Cells[1, i] + '.');
                Printer.Canvas.TextOut(PosJahr,  y * ZeilenHoehe,
                                       DatesForm.Grid.Cells[2, i]);
                Txt := DatesForm.Grid.Cells[3, i];
                while Txt > '' do
                  begin
                    s := '';
                    SplitText(Txt, s, FormBreite - PosText, Printer.Canvas,
                              True);
                    Printer.Canvas.TextOut(PosText, y * ZeilenHoehe, s);
                    inc(y);
                    if (y >= Zeilen) and
                       ((Txt > '') or (i < DatesForm.Grid.RowCount - 1)) then
                      begin
                        s := IntToStr(Seite);
                        case SysLocale.PriLangID of
                          LANG_GERMAN:
                            Printer.Canvas.TextOut(
                              PosTag,
                              (Zeilen + 1) * ZeilenHoehe,
                              'Seite ' + s + ' ' + DatesForm.Caption + ' '
                              + DatesForm.Liste.Text
                              + ' (weitere Seite folgt)');
                        else
                          Printer.Canvas.TextOut(
                            PosTag,
                            (Zeilen + 1) * ZeilenHoehe,
                            'Page ' + s + ' ' + DatesForm.Caption + ' '
                            + DatesForm.Liste.Text
                            + ' (another page is following)');
                        end;
                        Inc(Seite);
                        y := 0;
                        Printer.NewPage;
                      end;
                  end;
              end;
            s := IntToStr(Seite);
            case SysLocale.PriLangID of
              LANG_GERMAN:
                Printer.Canvas.TextOut(
                  PosTag,
                  (Zeilen + 1) * ZeilenHoehe,
                  'Seite ' + s + ' ' + DatesForm.Caption + ' '
                  + DatesForm.Liste.Text + ' (letzte Seite)');
            else
              Printer.Canvas.TextOut(
                PosTag,
                (Zeilen + 1) * ZeilenHoehe,
                'Page ' + s + ' ' + DatesForm.Caption + ' '
                + DatesForm.Liste.Text + ' (last page)');
            end;
            Printer.EndDoc;
          end;
        Screen.Cursor := crDefault;
      end;
  end;

procedure TMainForm.BlockMonat(Monat, xBeginn, yBeginn : Integer;
                               c: tCanvas);
  var     Day,
          Datum   : tJulianDay;
          Woche,
          Year,
          j       : Integer;
          b       : Boolean;
          y, m,
          w, x    : Word;
          s, t    : String;
          Picture : tPicture;
          Bitmap  : tBitmap;
  begin
    Bitmap := Nil;
    if LayoutForm.TagHintergrund > '' then
      begin
        Picture := tPicture.Create;
        if Picture <> Nil then
          try
            Picture.LoadFromFile(LayoutForm.TagHintergrund);
          except
            Picture := Nil;
          end;
        if Picture <> Nil then
          begin
            Bitmap := tBitmap.Create;
            if Bitmap <> Nil then
              begin
                Bitmap.Height := Picture.Graphic.Height;
                Bitmap.Width  := Picture.Graphic.Width;
                Bitmap.Canvas.Draw(0, 0, Picture.Graphic);
              end;
            Picture.Free;
          end;
      end;
    c.Font.Size   := (LayoutForm.FontData[eArbeitsTag, False].Size
                      * Longint(CanvasY)) div c.Font.PixelsPerInch;
    c.Font.Color  := LayoutForm.FontData[eArbeitsTag, False].Color;
    c.Font.Style  := LayoutForm.FontData[eArbeitsTag, False].Style;
    c.Brush.style := bsClear;
    y := yBeginn;
    if Monat <= 12 then
      Year := Jahr.Position
    else
      begin
        Dec(Monat, 12);
        Year := Jahr.Position + 1;
      end;
    s := GetLongMonthName(Monat);
    if not LayoutForm.Headline.Checked then
      s := s + ' ' + YearText(Year);
    if LayoutForm.Weeks.Checked then
      x := WochenBreite + DayGap + ZahlWeite
    else
      x := ZahlWeite;
    c.TextOut(xBeginn, (y * LongInt(CanvasY)) div LayoutForm.PrinterLogY, s);
    inc(y, TextHoehe);
    if LayoutForm.Weeks.Checked then
      begin
        if Bitmap <> Nil then
          c.StretchDraw(Rect(xBeginn,
                                  (y * LongInt(CanvasY))
                                    div LayoutForm.PrinterLogY,
                                  xBeginn + WochenBreite,
                                  ((y + TextHoehe) * LongInt(CanvasY))
                                    div LayoutForm.PrinterLogY),
                             Bitmap);
        c.Font.Size  := (LayoutForm.FontData[eFeiertagListe, False].Size
                         * Longint(CanvasY)) div c.Font.PixelsPerInch;
        c.Font.Color := LayoutForm.FontData[eFeiertagListe, False].Color;
        c.Font.Style := LayoutForm.FontData[eFeiertagListe, False].Style;
        TextOutRight(xBeginn + WochenBreite,
                     ((y + (TextHoehe - FeiertagHoehe) div 2)
                      * LongInt(CanvasY)) div LayoutForm.PrinterLogY,
                     ShortWeekName, c);
      end;
    c.Font.Size  := (LayoutForm.FontData[eArbeitsTag, False].Size
                     * Longint(CanvasY)) div c.Font.PixelsPerInch;
    c.Font.Color := LayoutForm.FontData[eArbeitsTag, False].Color;
    c.Font.Style := LayoutForm.FontData[eArbeitsTag, False].Style;
    if Bitmap <> Nil then
      for w := Monday to Sunday + 7 do
        c.StretchDraw(Rect(xBeginn + x + (w - 3) * ZahlWeite
                                       + (w - 2) * DayGap,
                           (y * LongInt(CanvasY))
                             div LayoutForm.PrinterLogY,
                           xBeginn + x + (w - 2) * (ZahlWeite + DayGap),
                           ((y + TextHoehe) * LongInt(CanvasY))
                             div LayoutForm.PrinterLogY),
                      Bitmap);
    for w := Monday to Friday do
      TextOutRight(xBeginn + x + (w - 2) * (ZahlWeite + DayGap),
                   (y * LongInt(CanvasY)) div LayoutForm.PrinterLogY,
                   copy(GetShortDayName(w), 1, 2), c);
    c.Font.Color := LayoutForm.FontData[eSamstag, False].Color;
    c.Font.Style := LayoutForm.FontData[eSamstag, False].Style;
    TextOutRight(xBeginn + x + 5 * (ZahlWeite + DayGap),
                 (y * LongInt(CanvasY)) div LayoutForm.PrinterLogY,
                 copy(GetShortDayName(Saturday), 1, 2), c);
    c.Font.Color := LayoutForm.FontData[eFeiertag, False].Color;
    c.Font.Style := LayoutForm.FontData[eFeiertag, False].Style;
    TextOutRight(xBeginn + x + 6 * (ZahlWeite + DayGap),
                 (y * LongInt(CanvasY)) div LayoutForm.PrinterLogY,
                 copy(GetShortDayName(Sunday), 1, 2), c);
    inc(y, TextHoehe);
    Day   := 1.5;
    Datum := LocalJulianDay(Year, Monat, Day);
    Woche := 0;
    if LayoutForm.Weeks.Checked Then
      begin
        if Bitmap <> Nil then
          c.StretchDraw(Rect(xBeginn,
                             (y * LongInt(CanvasY))
                               div LayoutForm.PrinterLogY,
                             xBeginn + WochenBreite,
                             ((y + TextHoehe) * LongInt(CanvasY))
                               div LayoutForm.PrinterLogY),
                        Bitmap);
        Woche        := round(Datum - Week0(Year)) div 7;
        c.Font.Size  := (LayoutForm.FontData[eFeiertagListe, False].Size
                         * Longint(CanvasY)) div c.Font.PixelsPerInch;
        c.Font.Color := LayoutForm.FontData[eFeiertagListe, False].Color;
        c.Font.Style := LayoutForm.FontData[eFeiertagListe, False].Style;
        s := IntToStr(Woche);
        TextOutRight(xBeginn + WochenBreite,
                     ((y + (TextHoehe - FeiertagHoehe) div 2)
                      * LongInt(CanvasY)) div LayoutForm.PrinterLogY,
                     s, c);
      end;
    if Year <= 0 then
      dec(Year);
    repeat
      Application.ProcessMessages;
      c.Font.Size := (LayoutForm.FontData[eArbeitsTag, False].Size
                      * Longint(CanvasY)) div c.Font.PixelsPerInch;
      w := (LocalJulDayOfWeek(Datum) + 7 - Monday) mod 7;
      if Bitmap <> Nil then
        c.StretchDraw(Rect(xBeginn + x + (w - 1) * ZahlWeite
                                            + w * DayGap,
                                (y * LongInt(CanvasY))
                                  div LayoutForm.PrinterLogY,
                                xBeginn + x + w * (ZahlWeite + DayGap),
                                ((y + TextHoehe) * LongInt(CanvasY))
                                  div LayoutForm.PrinterLogY),
                           Bitmap);
      with c.Font do
        begin
          b := DatesForm.IsTermin(trunc(Day), Monat, Year) > '';
          t := '';
          if CalPrintHoliday(Datum, t) Then
            begin
              Color := LayoutForm.FontData[eFeiertag, b].Color;
              Style := LayoutForm.FontData[eFeiertag, b].Style;
            end
          else
            if w = 5 then
              begin
                Color := LayoutForm.FontData[eSamstag, b].Color;
                Style := LayoutForm.FontData[eSamstag, b].Style;
              end
            else
              begin
                Color := LayoutForm.FontData[eArbeitsTag, b].Color;
                Style := LayoutForm.FontData[eArbeitsTag, b].Style;
              end;
        end;
      s := IntToStr(Trunc(Day));
      TextOutRight(xBeginn + x + w * (ZahlWeite + DayGap),
                   (y * LongInt(CanvasY)) div LayoutForm.PrinterLogY, s, c);
      Datum := Datum + 1;
      m     := 0;
      j     := 0;
      LocalJulianDate(Datum, j, m, Day);
      if (w = 6) and (m = Monat) Then
        begin
          inc(y, TextHoehe);
          if LayoutForm.Weeks.Checked then
            begin
              inc(Woche);
              if Bitmap <> Nil then
                c.StretchDraw(Rect(xBeginn,
                                   (y * LongInt(CanvasY))
                                     div LayoutForm.PrinterLogY,
                                   xBeginn + WochenBreite,
                                   ((y + TextHoehe) * LongInt(CanvasY))
                                     div LayoutForm.PrinterLogY),
                              Bitmap);
              c.Font.Size :=
                (LayoutForm.FontData[eFeiertagListe, False].Size
                 * Longint(CanvasY)) div c.Font.PixelsPerInch;
              c.Font.Color :=
                LayoutForm.FontData[eFeiertagListe, False].Color;
              c.Font.Style :=
                LayoutForm.FontData[eFeiertagListe, False].Style;
              s := IntToStr(Woche);
              TextOutRight(xBeginn + WochenBreite,
                           ((y + (TextHoehe - FeiertagHoehe) div 2)
                            * LongInt(CanvasY)) div LayoutForm.PrinterLogY,
                           s, c);
            end;
        end;
    until m <> Monat;
    inc(y, TextHoehe);
    if y > yEnde Then
      yEnde := y;
    if Bitmap <> Nil then
      Bitmap.Free;
  end;

procedure TMainForm.FeierOut(x : Integer; Holiday : tJulDate; c : tCanvas);
  var     s       : String;
          Year    : Integer;
          Month,
          w       : Word;
          dDay    : Double;
  begin
    Year  := 0;
    Month := 0;
    dDay  := 0;
    LocalJulianDate(Holiday.JDay, Year, Month, dDay);
    str(Trunc(dDay) : 2, s);
    w := WochenBreite + PunktWeite;
    TextOutRight(x + w,
                 (yEnde * LongInt(CanvasY)) div LayoutForm.PrinterLogY,
                 s + '.', c);
    str(Month : 2, s);
    inc(w, DayGap + ZahlWeite);
    TextOutRight(x + w,
                 (yEnde * LongInt(CanvasY)) div LayoutForm.PrinterLogY,
                 s + '.', c);
    inc(w, DayGap);
    c.TextOut(x + w,
                   (yEnde * LongInt(CanvasY)) div LayoutForm.PrinterLogY,
                   Holiday.DateName);
    Inc(yEnde, FeiertagHoehe);
  end;

procedure TMainForm.StatusCheck;
  begin
    if LayoutForm.CheckSizes.Checked then
      case Status of
        FontZuHoch:
          case SysLocale.PriLangID of
            LANG_GERMAN:
              MsgBox(CP1252ToSystem('Die Schrift ist zu hoch fr das Formular'),
                     Caption, mb_IconExclamation);
          else
            MsgBox('The font is too high for the form', Caption,
                   mb_IconExclamation);
          end;
        FontZuBreit:
          case SysLocale.PriLangID of
            LANG_GERMAN:
              MsgBox(CP1252ToSystem(
                       'Die Schrift ist zu breit fr das Formular'), Caption,
                     mb_IconExclamation);
          else
            MsgBox('The font is too wide for the form', Caption,
                   mb_IconExclamation);
          end;
        ZuvielText:
          case SysLocale.PriLangID of
            LANG_GERMAN:
              MsgBox('Zuviel Text', Caption, mb_IconExclamation);
          else
            MsgBox('Too much text', Caption, mb_IconExclamation);
          end;
      end;
  end;

procedure TMainForm.PaintBkgnd(c : tCanvas; x, y, Br, Hh : Integer);
  var     Picture    : tPicture;
          Bitmap     : tBitmap;
          bx,   by,
          b,    h,
          xDPI, yDPI : Integer;
  begin
    if LayoutForm.BlattHintergrund > '' then
      begin
        try
          Picture := tPicture.Create;
        except
          Picture := Nil;
        end;
        if Picture <> Nil then
          try
            Picture.LoadFromFile(LayoutForm.BlattHintergrund);
          except
            Picture.Free;
            Picture := Nil;
          end;
        if Picture <> Nil then
          begin
            xDPI := 0;
            yDPI := 0;
            if Picture.Graphic is tBitmap then
              GetBMPDPI(LayoutForm.BlattHintergrund, xDPI, yDPI)
            else
              if Picture.Graphic is tJpegImage then
                GetJpegDPI(LayoutForm.BlattHintergrund, xDPI, yDPI)
              else
              {$ifdef fpc}
                if Picture.Graphic is tPortableNetworkGraphic then
              {$else}
                if Picture.Graphic is tPngObject then
              {$endif}
                  begin
                    GetPngPixPerMeter(LayoutForm.BlattHintergrund, xDPI, yDPI);
                    xDPI := (xDPI * 254 + 5000) div 10000;
                    yDPI := (yDPI * 254 + 5000) div 10000;
                  end
              {$ifndef fpc}
                else
                  if Picture.Graphic is tsgPcxImage then
                    begin
                      xDPI := (Picture.Graphic as tsgPcxImage).PcxHeader.hRes;
                      yDPI := (Picture.Graphic as tsgPcxImage).PcxHeader.vRes;
                    end
               {$endif}
               ;
            if xDPI <= 0 then
              xDPI := Screen.PixelsPerInch;
            if yDPI <= 0 then
              yDPI := Screen.PixelsPerInch;
            try
              Bitmap := tBitmap.Create;
            except
              Bitmap := Nil;
            end;
            if Bitmap <> Nil then
              begin
                Bitmap.Height := Picture.Graphic.Height;
                Bitmap.Width  := Picture.Graphic.Width;
                Bitmap.Canvas.Draw(0, 0, Picture.Graphic);
                if LayoutForm.rbStretch.checked then
                  c.StretchDraw(Rect(x, y, x + Br, y + Hh), Bitmap)
                else
                  begin
                    by := 0;
                    h  := (Bitmap.Height * CanvasY) div yDPI;
                    while by < Hh do
                      begin
                        Bitmap.Height := Picture.Graphic.Height;
                        Bitmap.Width  := Picture.Graphic.Width;
                        Bitmap.Canvas.Draw(0, 0, Picture.Graphic);
                        bx := 0;
                        b  := (Bitmap.Width * CanvasX) div xDPI;
                        if Hh - by < h then
                          begin
                            h             := Hh - by;
                            Bitmap.Height := (h * yDPI) div CanvasY;
                          end;
                        while bx < Br do
                          begin
                            Application.ProcessMessages;
                            if Br - bx < b then
                              begin
                                b            := Br - bx;
                                Bitmap.Width := (b * xDPI) div CanvasX;
                              end;
                            c.StretchDraw(Rect(x + bx,
                                               y + by,
                                               x + bx + b,
                                               y + by + h),
                                          Bitmap);
                            inc(bx, b);
                          end;
                        inc(by, h);
                      end;
                  end;
                Bitmap.Free;
              end;
            Picture.Free;
          end;
      end;
  end;

function TMainForm.PaintEineSeite(var x, y : Word; cv : tCanvas) : Boolean;
  var    Monat       : Word;
         vonMonat,
         bisMonat,
         yBeginn,
         i, j,
         TextWeite,
         Right,
         SpaltenGap  : Integer;
         JDay        : tJulianDay;
         Day         : Double;
         r           : Real;
         HolidayList : tDateList;
         hName, s    : String;
         c           : tLanguageList;
  begin
    PaintEineSeite := False;
    try
      c := tLanguageList.Create;
    except
      c := Nil;
    end;
    if c = Nil then
      MsgBox('cannot create language list', Caption, mb_IconHand)
    else
      try
        VonMonat := GetMonat(Von.Text);
        BisMonat := GetMonat(Bis.Text);
        if BisMonat = 0 then
          BisMonat := VonMonat
        else
          if BisMonat < VonMonat then
            inc(BisMonat, 12);
        Val(LayoutForm.PaperWidth.Text, r, i);
        FormBreite := MMtoPixel(r, CanvasX);
        Val(LayoutForm.PaperHeight.Text, r, i);
        FormHoehe  := MMtoPixel(r, CanvasY);
        Val(LayoutForm.MarginLeft.Text, r, i);
        TextRand   := MMtoPixel(r, CanvasX);
        Val(LayoutForm.MarginRight.Text, r, i);
        Right      := MMtoPixel(r, CanvasX);
        Val(LayoutForm.MarginTop.Text, r, i);
        yEnde      := MMtoPixel(r, LayoutForm.PrinterLogY) + y;
        Breite     := FormBreite - TextRand - Right;
        Mitte      := Breite div 2;
        PaintBkgnd(cv, x, y, FormBreite, FormHoehe);
        cv.Font.Name    := LayoutForm.FontData[eArbeitsTag, False].Name;
        cv.Font.CharSet := LayoutForm.FontData[eArbeitsTag, False].CharSet;
        cv.Font.Size    := (LayoutForm.FontData[eArbeitsTag, False].Size
                            * longint(CanvasY)) div cv.Font.PixelsPerInch;
        cv.Brush.style  := bsClear;
        ZahlWeite       := GetTagWeite(cv);
        SpaltenGap      := cv.TextWidth('W');
        if LayoutForm.Weeks.checked then
          begin
            cv.Font.Size  := (LayoutForm.FontData[eFeiertagListe, False].Size
                              * longint(CanvasY)) div cv.Font.PixelsPerInch;
            PunktWeite    := cv.TextWidth('.');
            WochenBreite  := GetWochenBreite(cv);
            DayGap        := (Breite
                               - LayoutForm.Columns.Position
                                 * (WochenBreite + 7 * ZahlWeite)
                               - (LayoutForm.Columns.Position - 1) * SpaltenGap
                              ) div (LayoutForm.Columns.Position * 8 - 1);
          end
        else
          begin
            WochenBreite := GetTagWeite(cv);
            cv.Font.Size := (LayoutForm.FontData[eFeiertagListe, False].Size
                             * longint(CanvasY)) div cv.Font.PixelsPerInch;
            PunktWeite   := cv.TextWidth('.');
            DayGap       := (Breite
                              - LayoutForm.Columns.Position * 7 * ZahlWeite
                              - (LayoutForm.Columns.Position - 1) * SpaltenGap
                             ) div (LayoutForm.Columns.Position * 7 - 1);
          end;
        if DayGap < PunktWeite then
          Status := FontZuBreit;
        inc(SpaltenGap, DayGap);
        Breite := (Breite + SpaltenGap)
                  div LayoutForm.Columns.Position - SpaltenGap;
        if LayoutForm.DocFrame.Checked then
          begin
            cv.Brush.Style := bsClear;
            cv.Pen.Color   := clBlack;
            cv.Pen.Width   := 1;
            cv.Pen.Mode    := pmCopy;
            cv.Rectangle(x,
                         (y * LongInt(CanvasY)) div LayoutForm.PrinterLogY,
                         x + FormBreite - 1,
                         (y * LongInt(CanvasY)) div LayoutForm.PrinterLogY
                         + FormHoehe - 1);
          end;
        if LayoutForm.Headline.Checked then
          begin
            cv.Font.Style := LayoutForm.FontData[eJahr, False].Style;
            cv.Font.Color := LayoutForm.FontData[eJahr, False].Color;
            cv.Font.Size  := (LayoutForm.FontData[eJahr, False].Size
                              * longint(CanvasY)) div cv.Font.PixelsPerInch;
            if (VonMonat + BisMonat) div 2 > 12 then
              s := YearText(Jahr.Position + 1)
            else
              s := YearText(Jahr.Position);
            TextOutCenter(x + TextRand + Mitte,
                          (yEnde * LongInt(CanvasY)) div LayoutForm.PrinterLogY,
                          FormBreite - TextRand, s, cv);
            cv.Font.Size := (LayoutForm.FontData[eJahr, False].Size
                             * longint(LayoutForm.PrinterLogY))
                            div cv.Font.PixelsPerInch;
            inc(yEnde, GetTextHoehe(cv));
          end;
        cv.Font.Size  := (LayoutForm.FontData[eArbeitsTag, False].Size
                          * longint(LayoutForm.PrinterLogY))
                         div cv.Font.PixelsPerInch;
        TextHoehe     := GetTextHoehe(cv);
        cv.Font.Size  := (LayoutForm.FontData[eFeiertagListe, False].Size
                          * longint(LayoutForm.PrinterLogY))
                         div cv.Font.PixelsPerInch;
        FeiertagHoehe := GetTextHoehe(cv);
        if LayoutForm.Weeks.checked then
          if FeiertagHoehe > TextHoehe then
            TextHoehe := FeiertagHoehe;
        cv.Font.Size  := (LayoutForm.FontData[eArbeitsTag, False].Size
                          * longint(CanvasY)) div cv.Font.PixelsPerInch;
        Dec(yEnde, TextHoehe);
        i       := 0;
        yBeginn := 0;
        for Monat := VonMonat to BisMonat do
          begin
            if (i > 0) and (i mod LayoutForm.Columns.Position = 0)
                       and LayoutForm.MonthFrame.Checked
            then
              begin
                cv.Brush.Style := bsClear;
                cv.Pen.Color   := clBlack;
                cv.Pen.Width   := 1;
                cv.Pen.Mode    := pmCopy;
                for j := 0 to LayoutForm.Columns.Position - 1 do
                  cv.Rectangle(x + TextRand
                                 + j * (Breite + SpaltenGap) - 1
                                 - cv.TextWidth('#') div 2,
                               (yBeginn * LongInt(CanvasY))
                                 div LayoutForm.PrinterLogY
                                 - cv.TextHeight('#') div 3,
                               x + TextRand
                                 + j * (Breite + SpaltenGap) + Breite
                                 + cv.TextWidth('#') div 2,
                               (yEnde * LongInt(CanvasY))
                                 div LayoutForm.PrinterLogY
                                 + cv.TextHeight('#') div 3);
              end;
            if i mod LayoutForm.Columns.Position = 0 Then
              yBeginn := yEnde + TextHoehe;
            BlockMonat(Monat,
                       x + TextRand
                         + (i mod LayoutForm.Columns.Position)
                           * (Breite + SpaltenGap),
                       yBeginn, cv);
            inc(i);
          end;
        if LayoutForm.MonthFrame.Checked then
          begin
            cv.Brush.Style := bsClear;
            cv.Pen.Color   := clBlack;
            cv.Pen.Width   := 1;
            cv.Pen.Mode    := pmCopy;
            for j := 0 to (i - 1) mod LayoutForm.Columns.Position do
              cv.Rectangle(x + TextRand
                             + j * (Breite + SpaltenGap) - 1
                             - cv.TextWidth('#') div 2,
                           (yBeginn * LongInt(CanvasY))
                             div LayoutForm.PrinterLogY
                             - cv.TextHeight('#') div 3,
                           x + TextRand
                             + j * (Breite + SpaltenGap) + Breite
                             + cv.TextWidth('#') div 2,
                           (yEnde * LongInt(CanvasY))
                             div LayoutForm.PrinterLogY
                             + cv.TextHeight('#') div 3);
          end;
        if ((yEnde - y) * LongInt(CanvasY)) div LayoutForm.PrinterLogY
           > FormHoehe
        then
          Status := FontZuHoch;
        if LayoutForm.HolidayList.Checked then
          begin
            try
              HolidayList := tDateList.Create;
            except
              HolidayList := Nil;
            end;
            if HolidayList = Nil then
              MsgBox('cannot create holiday list', Caption, mb_IconHand)
            else
              try
                c.Clear;
                c.Add(SysLocale.PriLangID, SysLocale.SubLangID);
                hName := '';
                JDay  := 0;
                Day   := 0;
                for i := 1 to AutoHolidayForm.Feiertag.RowCount - 1 do
                  if AutoHolidayForm.IsHolidayList(i, Jahr.Position, JDay, hName) then
                    begin
                      LocalJulianDate(JDay, j, Monat, Day);
                      if (VonMonat <= Monat) and (Monat <= BisMonat) then
                        HolidayList.Add(jDay, hName);
                    end;
                for i := 1 to UserHolidaysForm.Grid.RowCount - 1 do
                  if UserHolidaysForm.IsHolidayList(i, Jahr.Position, JDay, hName) then
                    begin
                      LocalJulianDate(JDay, j, Monat, Day);
                      if (VonMonat <= Monat) and (Monat <= BisMonat) then
                        HolidayList.Add(jDay, hName);
                    end;
                for i := 1 to AutoHolidayForm.Feiertag.RowCount - 1 do
                  if AutoHolidayForm.IsHolidayList(i, Jahr.Position + 1, JDay, hName) then
                    begin
                      LocalJulianDate(JDay, j, Monat, Day);
                      if Monat + 12 <= BisMonat then
                        HolidayList.Add(jDay, hName);
                    end;
                for i := 1 to UserHolidaysForm.Grid.RowCount - 1 do
                  if UserHolidaysForm.IsHolidayList(i, Jahr.Position + 1,
                                                    JDay, hName)
                  then
                    begin
                      LocalJulianDate(JDay, j, Monat, Day);
                      if Monat + 12 <= BisMonat then
                        HolidayList.Add(jDay, hName);
                    end;
                if HolidayList.Dates.Count > 0 then
                  begin
                    HolidayList.Sort(0, HolidayList.Dates.Count - 1);
                    cv.Font.Size   :=
                      (LayoutForm.FontData[eFeiertagListe, False].Size
                       * longint(CanvasY)) div cv.Font.PixelsPerInch;
                    cv.Font.Color  :=
                      LayoutForm.FontData[eFeiertagListe, False].Color;
                    cv.Font.Style  :=
                      LayoutForm.FontData[eFeiertagListe, False].Style;
                    cv.Brush.style := bsClear;
                    if DayGap > cv.TextWidth('###') then
                      begin
                        DayGap     := cv.TextWidth('#');
                        ZahlWeite  := WochenBreite;
                        PunktWeite := 0;
                      end;
                    TextWeite := HolidayList.GetWidth(cv)
                                 + WochenBreite + DayGap
                                 + ZahlWeite + PunktWeite + DayGap;
                    Spalten := (FormBreite - TextRand - Right + SpaltenGap)
                               div (TextWeite + SpaltenGap);
                    if Spalten < 1 then
                      Status := FontZuBreit
                    else
                      begin
                        Inc(yEnde, FeiertagHoehe);
                        Hoehe   := (HolidayList.Dates.Count + Spalten - 1)
                                   div Spalten;
                        { Aufgrund der Hoehe knnte jetzt die letze Spalte
                          leer bleiben
                        }
                        Spalten := (HolidayList.Dates.Count + Hoehe - 1)
                                   div Hoehe;
                        Breite  := (FormBreite - TextRand - Right + SpaltenGap)
                                   div Spalten;
                        yBeginn := yEnde;
                        for i := 1 to HolidayList.Dates.Count do
                          begin
                            Application.ProcessMessages;
                            FeierOut(x + TextRand + ((i - 1) div Hoehe) * Breite,
                                     pJulDate(HolidayList.Dates.Items[i - 1])^,
                                     cv);
                            if i mod Hoehe = 0 then
                              begin
                                if ((yEnde - y) * LongInt(CanvasY))
                                   div LayoutForm.PrinterLogY
                                   > FormHoehe
                                then
                                  Status := FontZuHoch;
                                yEnde := yBeginn;
                              end;
                          end;
                        yEnde := yBeginn + FeiertagHoehe * Hoehe;
                      end;
                  end;
              finally
                HolidayList.Free;
              end;
            if ((yEnde - y) * LongInt(CanvasY)) div LayoutForm.PrinterLogY
               > FormHoehe
            then
              Status := FontZuHoch;
          end;
        if LayoutForm.Footer.Text > '' then
          begin
            Inc(yEnde, TextHoehe);
            cv.Font.Color  := LayoutForm.FontData[eFeiertagListe, False].Color;
            cv.Font.Size   := (LayoutForm.FontData[eFeiertagListe, False].Size
                               * longint(CanvasY)) div cv.Font.PixelsPerInch;
            cv.Font.Style  := LayoutForm.FontData[eFeiertagListe, False].Style;
            cv.Brush.style := bsClear;
            TextOutCenter(x + TextRand + Mitte,
                          (yEnde * LongInt(CanvasY)) div LayoutForm.PrinterLogY,
                          FormBreite - TextRand, LayoutForm.Footer.Text, cv);
            Inc(yEnde, TextHoehe);
            if ((yEnde - y) * LongInt(CanvasY)) div LayoutForm.PrinterLogY
               > FormHoehe
            then
              Status := FontZuHoch;
          end;
        inc(x, FormBreite);
        if (x + FormBreite) * LongInt(LayoutForm.PrinterLogX)
           > CanvasX * LongInt(LayoutForm.PrinterResX)
        then
          begin
            inc(y, (FormHoehe * LongInt(LayoutForm.PrinterLogY)) div CanvasY);
            x := 0;
          end;
        if y + (FormHoehe * LongInt(LayoutForm.PrinterLogY)) div CanvasY
           > LayoutForm.PrinterResY
        then
          begin
            PaintEineSeite := True;
            x              := 0;
            y              := 0;
          end
        else
          PaintEineSeite := False;
      finally
        c.Free;
      end;
  end;

procedure TMainForm.PreviewEineSeite;
  var     x, y : Word;
  begin
    x := 0;
    y := 0;
    Repeat
    until PaintEineSeite(x, y, PreviewForm.Image.Picture.Bitmap.Canvas);
  end;

procedure TMainForm.BmpEineSeite(Bitmap: tBitmap);
  var     x, y  : Word;
          YesNo : Integer;
  begin
    x     := 0;
    y     := 0;
    YesNo := mrNo;
    PaintEineSeite(x, y, Bitmap.Canvas);
    SaveBmp(Bitmap, SavePictureDialog.FileName, YesNo);
  end;

procedure TMainForm.EmfEineSeite;
  {$ifndef fpc}
    var   x, y           : Word;
          MetaFileCanvas : tMetaFileCanvas;
          MetaFile       : tMetaFile;
          YesNo          : Integer;
  {$endif}
  begin
    {$ifndef fpc}
      x     := 0;
      y     := 0;
      YesNo := mrNo;
      case SysLocale.PriLangID of
        Lang_German:
          begin
            CreateMetaFile('Kalender', MetaFile, MetaFileCanvas);
            if MetaFile = Nil then
              MsgBox('kann Metafile nicht erzeugen', Caption, mb_IconHand);
          end;
      else
        CreateMetaFile('calendar', MetaFile, MetaFileCanvas);
        if MetaFile = Nil then
          MsgBox('cannot create metafile', Caption, mb_IconHand);
      end;
      if MetaFile <> Nil then
        begin
          PaintEineSeite(x, y, MetaFileCanvas);
          MetaFileCanvas.Free;
          SaveEMF(MetaFile, SavePictureDialog.FileName, YesNo);
          MetaFile.Free;
        end;
    {$endif}
  end;

procedure TMainForm.PrintEineSeite;
  var     k, x, y,
          Copies  : Word;
          NewPage : Boolean;
  begin
    case SysLocale.PriLangID of
      LANG_GERMAN:
        Printer.Title := 'Kalender ' + YearText(Jahr.Position) + ' '
                         + FormularName(tFormular(Formular.ItemIndex),
                                        SysLocale.PriLangID);
    else
      Printer.Title := 'Calendar ' + YearText(Jahr.Position) + ' '
                       + FormularName(tFormular(Formular.ItemIndex),
                                      SysLocale.PriLangID);
    end;
    Copies             := PrintDialog.Copies;
    PrintDialog.Copies := 1;
    Printer.BeginDoc;
    k := 0;
    x := 0;
    y := 0;
    while k < Copies do
      begin
        inc(k);
        NewPage := PaintEineSeite(x, y, Printer.Canvas) and (k < Copies);
        if ((Status = FontZuHoch) or (Status = FontZuBreit))
           and (LayoutForm.CheckSizes.Checked)
        then
          k := Copies
        else
          if NewPage then
            Printer.NewPage;
      end;
    if ((Status = FontZuHoch) or (Status = FontZuBreit))
       and (LayoutForm.CheckSizes.Checked)
    then
      Printer.Abort
    else
      Printer.EndDoc;
  end;

procedure TMainForm.PrintTag(x, yVon, yBis : word; Datum : tJulianDay;
                             var NaechstesMondDatum : tJulianDay;
                             var NaechsteMondPhase  : tMoonsPhase;
                             c : tCanvas);
  var     Day           : tJulianDay;
          Monat         : Word;
          MondX, MondY,
          DaylightX,
          i,     Year   : Integer;
          BesondererTag,
          s, t, p       : String;
          Mund          : Array[0 .. 3] of tPoint;
  begin
    Year  := 0;
    Monat := 0;
    Day   := 0;
    LocalJulianDate(Datum, Year, Monat, Day);
    c.Brush.style := bsClear;
    with c.Font do
      begin
        Name := LayoutForm.FontData[eArbeitsTag, False].Name;
        Size := (LayoutForm.FontData[eArbeitsTag, False].Size
                 * longint(CanvasY)) div PixelsPerInch;
        BesondererTag := '';
        if CalPrintHoliday(Datum, BesondererTag) Then
          begin
            Color := LayoutForm.FontData[eFeiertag, False].Color;
            Style := LayoutForm.FontData[eFeiertag, False].Style;
          end
        else
          if LocalJulDayOfWeek(Datum) = Saturday then
            begin
              Color := LayoutForm.FontData[eSamstag, False].Color;
              Style := LayoutForm.FontData[eSamstag, False].Style;
            end
          else
            begin
              Color := LayoutForm.FontData[eArbeitsTag, False].Color;
              Style := LayoutForm.FontData[eArbeitsTag, False].Style;
            end;
      end;
    c.TextOut(x, yVon, GetLongDayName(LocalJulDayOfWeek(Datum)));
    try
      s := LocalJulianFormatDateTime(LayoutForm.DayMonthFormat.Text, Datum);
    except
      s := '';
    end;
    if LayoutForm.rbRight.Checked then
      TextOutRight(x + WTagWeite + ZahlWeite, yVon, s, c)
    else
      c.TextOut(x + WTagWeite, yVon, s);
    MondX     := x + WTagWeite + ZahlWeite + BlankWeite;
    DaylightX := MondX;
    if LocalSameDate(Datum, NaechstesMondDatum) Then
      with c do
        begin
          Pen.Color := Font.Color;
          Pen.Width := MondHoehe div 20;
          Pen.Mode  := pmCopy;
          MondY     := yVon + LineGap;
          DaylightX := MondX + MondWeite + BlankWeite;
          case NaechsteMondphase of
            NewMoon:
              begin
                Brush.Style := bsSolid;
                Brush.Color := Font.Color;
                Ellipse(MondX,             MondY,
                        MondX + MondWeite, MondY + MondHoehe);
                Brush.Color := clWhite;
                Pen.Mode    := pmWhite;
                Pen.Width   := 1;
                Ellipse(MondX +  MondWeite      div  4,
                        MondY +  MondHoehe      div  4,
                        MondX + (MondWeite * 7) div 16,
                        MondY + (MondHoehe * 7) div 16);
                Ellipse(MondX + (MondWeite * 9) div 16,
                        MondY +  MondHoehe      div  4,
                        MondX + (MondWeite * 3) div  4,
                        MondY + MondHoehe * 7 div 16);
                Mund[0].x := MondX +  MondWeite       div  4;
                Mund[0].y := MondY + (MondHoehe *  9) div 16;
                Mund[1].x := MondX +  MondWeite       div  2;
                Mund[1].y := MondY + (MondHoehe * 21) div 32;
                Mund[2].x := MondX + (MondWeite *  3) div  4;
                Mund[2].y := MondY + (MondHoehe *  9) div 16;
                Mund[3].x := MondX +  MondWeite       div  2;
                Mund[3].y := MondY + (MondHoehe * 13) div 16;
                Polygon(Mund);
              end;
            FirstQuarter:
              begin
                {$ifdef fpc}
                  Ellipse(MondX,             MondY,
                          MondX + MondWeite, MondY + MondHoehe);
                  Brush.Style := bsSolid;
                  Brush.Color := clWhite;
                  FillRect(Rect(MondX -  MondHoehe       div 20,
                                MondY -  MondHoehe       div 20,
                                MondX + (MondWeite *  3) div  8,
                                MondY + (MondHoehe * 21) div 20));
                  MoveTo(MondX + (MondWeite *  3) div  8,
                         MondY +  MondHoehe       div 20);
                  LineTo(MondX +  MondWeite       div  2,
                         MondY +  MondHoehe       div  2);
                  LineTo(MondX + (MondWeite *  3) div  8,
                         MondY + (MondHoehe * 19) div 20);
                {$else}
                  Pie(MondX,                         MondY,
                      MondX +  MondWeite,            MondY + MondHoehe,
                      MondX + (MondWeite * 3) div 8, MondY + MondHoehe,
                      MondX + (MondWeite * 3) div 8, MondY);
                {$endif}
                Brush.Color := Font.Color;
                Pen.Width   := 1;
                Ellipse(MondX + (MondWeite * 9) div 16,
                        MondY +  MondHoehe      div  4,
                        MondX + (MondWeite * 3) div  4,
                        MondY + (MondHoehe * 7) div 16);
                Mund[0].x := MondX + (MondWeite *  3) div  4;
                Mund[0].y := MondY + (MondHoehe *  9) div 16;
                Mund[1].x := MondX + (MondWeite *  7) div 16;
                Mund[1].y := MondY + (MondHoehe * 13) div 16;
                Mund[2].x := MondX +  MondWeite       div  2;
                Mund[2].y := MondY + (MondHoehe * 21) div 32;
                Mund[3].x := MondX + (MondWeite *  3) div  4;
                Mund[3].y := MondY + (MondHoehe *  9) div 16;
                Polygon(Mund);
              end;
            FullMoon:
              begin
                Ellipse(MondX,             MondY,
                        MondX + MondWeite, MondY + MondHoehe);
                Brush.Style := bsSolid;
                Brush.Color := Font.Color;
                Pen.Width   := 1;
                Ellipse(MondX +  MondWeite      div  4,
                        MondY +  MondHoehe      div  4,
                        MondX + (MondWeite * 7) div 16,
                        MondY + (MondHoehe * 7) div 16);
                Ellipse(MondX + (MondWeite * 9) div 16,
                        MondY +  MondHoehe      div  4,
                        MondX + (MondWeite * 3) div  4,
                        MondY + (MondHoehe * 7) div 16);
                Mund[0].x := MondX +  MondWeite       div  4;
                Mund[0].y := MondY + (MondHoehe *  9) div 16;
                Mund[1].x := MondX +  MondWeite       div  2;
                Mund[1].y := MondY + (MondHoehe * 21) div 32;
                Mund[2].x := MondX + (MondWeite *  3) div  4;
                Mund[2].y := MondY + (MondHoehe *  9) div 16;
                Mund[3].x := MondX +  MondWeite       div  2;
                Mund[3].y := MondY + (MondHoehe * 13) div 16;
                Polygon(Mund);
              end;
            LastQuarter:
              begin
                {$ifdef fpc}
                  Ellipse(MondX,             MondY,
                          MondX + MondWeite, MondY + MondHoehe);
                  Brush.Style := bsSolid;
                  Brush.Color := clWhite;
                  FillRect(Rect(MondX + (MondWeite *  5) div 8,
                                MondY -  MondHoehe       div 20,
                                MondX +  MondWeite + MondHoehe div 20,
                                MondY + (MondHoehe * 21) div 20));
                  MoveTo(MondX + (MondWeite *  5) div  8,
                         MondY +  MondHoehe       div 20);
                  LineTo(MondX +  MondWeite       div  2,
                         MondY +  MondHoehe       div  2);
                  LineTo(MondX + (MondWeite *  5) div  8,
                         MondY + (MondHoehe * 19) div 20);
                {$else}
                  Pie(MondX,                         MondY,
                      MondX +  MondWeite,            MondY + MondHoehe,
                      MondX + (MondWeite * 5) div 8, MondY,
                      MondX + (MondWeite * 5) div 8, MondY + MondHoehe);
                {$endif}
                Brush.Color := Font.Color;
                Pen.Width   := 1;
                Ellipse(MondX +  MondWeite      div  4,
                        MondY +  MondHoehe      div  4,
                        MondX + (MondWeite * 7) div 16,
                        MondY + (MondHoehe * 7) div 16);
                Mund[0].x := MondX +  MondWeite       div  4;
                Mund[0].y := MondY + (MondHoehe *  9) div 16;
                Mund[1].x := MondX +  MondWeite       div  2;
                Mund[1].y := MondY + (MondHoehe * 21) div 32;
                Mund[2].x := MondX + (MondWeite *  9) div 16;
                Mund[2].y := MondY + (MondHoehe * 13) div 16;
                Mund[3].x := MondX +  MondWeite       div  4;
                Mund[3].y := MondY + (MondHoehe *  9) div 16;
                Polygon(Mund);
              end;
          end;
          if NaechsteMondPhase = high(tMoonsPhase) Then
            NaechsteMondPhase := Low(tMoonsPhase)
          else
            inc(NaechsteMondPhase);
          NaechstesMondDatum :=
            MoonsPhase(NaechsteMondPhase, NaechstesMondDatum + 7);
        end;
    c.Brush.Style := bsClear;
    c.TextOut(DaylightX, yVon, DaylightText(Datum));
    inc(yVon, TextHoehe);
    while BesondererTag > '' do
      begin
        i := Pos(A_LF, BesondererTag);
        if i = 0 then
          i := $100;
        t := Copy(BesondererTag, 1, i - 1);
        while t > '' do
          begin
            SplitText(t, s, Breite - TextRand - 2 * ThinPenWidth, c, False);
            if yVon + TextHoehe <= yBis then
              c.TextOut(x, yVon, s)
            else
              if Status < ZuvielText then
                Status := ZuvielText;
            inc(yVon, TextHoehe);
          end;
        BesondererTag := Copy(BesondererTag, i + 1, length(BesondererTag));
      end;
    c.Brush.style := bsClear;
    with c.Font do
      begin
        Name    := LayoutForm.FontData[eTermin, False].Name;
        Charset := LayoutForm.FontData[eTermin, False].Charset;
        Size    := (LayoutForm.FontData[eTermin, False].Size
                    * longint(CanvasY)) div PixelsPerInch;
        Color   := LayoutForm.FontData[eTermin, False].Color;
        Style   := LayoutForm.FontData[eTermin, False].Style;
      end;
    p := DatesForm.IsTermin(Trunc(Day), Monat, Year);
    while p > '' do
      begin
        i := Pos(A_LF, p);
        if i = 0 then
          i := Length(p) + 1;
        t := CalcTermin(Copy(p, 1, i - 1), Year, s);
        while t > '' do
          begin
            SplitText(t, s, Breite - TextRand - 2 * ThinPenWidth, c, False);
            if yVon + TextHoehe <= yBis then
              c.TextOut(x, yVon, s)
            else
              if Status < ZuvielText then
                Status := ZuvielText;
            inc(yVon, TextHoehe);
          end;
        p := Copy(p, i + 1, length(p));
      end;
  end;

procedure TMainForm.PaintRingbuch(Woche : Integer; Datum : tJulianDay;
                                  x : Integer; c : tCanvas);
  var     i                   : Integer;
          s                   : String;
          Phase,
          NaechsteMondPhase   : tMoonsPhase;
          NaechstesMondDatum,
          TestDatum           : tJulianDay;
  begin
    PaintBkgnd(c, x, 0, Breite, Hoehe);
    c.Brush.style := bsClear;
    with c.Font do
      begin
        Name := LayoutForm.FontData[eArbeitsTag, False].Name;
        Size := (LayoutForm.FontData[eArbeitsTag, False].Size
                 * longint(CanvasY)) div PixelsPerInch;
        s    := '';
        if CalPrintHoliday(Datum, s) Then
          begin
            Color := LayoutForm.FontData[eFeiertag, False].Color;
            Style := LayoutForm.FontData[eFeiertag, False].Style;
          end
        else
          if LocalJulDayOfWeek(Datum) = Saturday then
            begin
              Color := LayoutForm.FontData[eSamstag, False].Color;
              Style := LayoutForm.FontData[eSamstag, False].Style;
            end
          else
            begin
              Color := LayoutForm.FontData[eArbeitsTag, False].Color;
              Style := LayoutForm.FontData[eArbeitsTag, False].Style;
            end;
      end;
    s := IntToStr(Woche);
    c.TextOut(x + TextRand, 2 * ThinPenWidth, LongWeekName + ' ' + s);
    if LayoutForm.rbRight.Checked then
      TextOutRight(x + TextRand + WTagWeite + ZahlWeite,
                   2 * ThinPenWidth, YearText(Jahr.Position), c)
    else
      c.TextOut(x + TextRand + WTagWeite, 2 * ThinPenWidth,
                YearText(Jahr.Position));
    NaechstesMondDatum := Datum + 7.5;
    NaechsteMondPhase  := NewMoon;
    for Phase := Low(tMoonsPhase) to high(tMoonsPhase) do
      begin
        TestDatum := MoonsPhase(Phase, Datum);
        if TestDatum >= Datum - 0.5 Then
          if TestDatum < NaechstesMondDatum Then
            begin
              NaechstesMondDatum := TestDatum;
              NaechsteMondPhase  := Phase;
            end;
      end;
    PrintTag(x + TextRand, 2 * ThinPenWidth + TextHoehe,
             Hoehe div 7 - 2 * ThinPenWidth, Datum,
             NaechstesMondDatum, NaechsteMondPhase, c);
    for i := 1 to 6 do
      begin
        Application.ProcessMessages;
        Datum := Datum + 1;
        PrintTag(x + TextRand, 2 * ThinPenWidth + i * Hoehe div 7,
                 (i + 1) * Hoehe div 7 - 2 * ThinPenWidth, Datum,
                 NaechstesMondDatum, NaechsteMondPhase, c);
      end;
    c.Pen.Color := clBlack;
    c.Pen.Width := ThinPenWidth;
    c.Pen.Mode  := pmCopy;
    c.MoveTo(x + ThinPenWidth, ThinPenWidth);
    c.LineTo(x + ThinPenWidth, Hoehe);
    c.MoveTo(x + Breite,   ThinPenWidth);
    c.LineTo(x + Breite,   Hoehe);
    for i := 0 to 7 do
      begin
        c.MoveTo(x + ThinPenWidth, Hoehe * i div 7 + ThinPenWidth);
        c.LineTo(x + Breite,       Hoehe * i div 7 + ThinPenWidth);
      end;
    c.Ellipse(x + LochRand - LochX, Hoehe div 2 - Loch1 - LochY,
                   x + LochRand + LochX, Hoehe div 2 - Loch1 + LochY);
    c.Ellipse(x + LochRand - LochX, Hoehe div 2 + Loch1 - LochY,
                   x + LochRand + LochX, Hoehe div 2 + Loch1 + LochY);
    if LayoutForm.Punches.Position > 2 Then
      begin
        c.Ellipse(x + LochRand - LochX, Hoehe div 2 - Loch2 - LochY,
                       x + LochRand + LochX, Hoehe div 2 - Loch2 + LochY);
        c.Ellipse(x + LochRand - LochX, Hoehe div 2 + Loch2 - LochY,
                       x + LochRand + LochX, Hoehe div 2 + Loch2 + LochY);
      end;
    if LayoutForm.Punches.Position > 4 Then
      begin
        c.Ellipse(x + LochRand - LochX, Hoehe div 2 - Loch3 - LochY,
                       x + LochRand + LochX, Hoehe div 2 - Loch3 + LochY);
        c.Ellipse(x + LochRand - LochX, Hoehe div 2 + Loch3 - LochY,
                       x + LochRand + LochX, Hoehe div 2 + Loch3 + LochY);
      end;
  end;

function FormatWidth(Format : String; c : tCanvas) : Integer;
  var    s, u, v    : String;
         i, w, m, t : Integer;
         ch         : Char;
         M_is_Min,
         b          : Boolean;
  begin
    if Trim(Format) = '' then
      Format := GetShortDateFormat + ' ' + GetLongTimeFormat;
    s        := '';
    M_is_Min := False;
    while Format > '' do
      begin
        repeat
          b := False;
          i := FormatLength(Format, 'c');
          if i > 0 then
            Format := GetShortDateFormat + ' ' + GetLongTimeFormat
                      + Copy(Format, i + 1, length(Format))
          else
            begin
              i := FormatLength(Format, 't');
              case i of
                0 : b      := True;
                1 : Format := GetShortTimeFormat
                              + Copy(Format, i + 1, length(Format));
              else
                Format := GetLongTimeFormat
                          + Copy(Format, i + 1, length(Format));
              end;
            end;
          if b then
            begin
              i := FormatLength(Format, 'd');
              if i >= 6 then
                begin
                  Format := GetLongDateFormat
                            + Copy(Format, i + 1, length(Format));
                  b      := False;
                end
              else
                if i >= 5 then
                  begin
                    Format := GetShortDateFormat
                              + Copy(Format, i + 1, length(Format));
                    b      := False;
                  end;
            end;
        until b;
        if Format > '' then
          case UpperCase(Format[1])[1] of
            'D' : begin
                    case FormatLength(Format, Format[1]) of
                      1,
                      2 : s := s + '##';
                      3 : begin
                            w := 0;
                            m := 1;
                            for i := 1 to 7 do
                              begin
                                t := c.TextWidth(s + GetShortDayName(i));
                                if t > w then
                                  begin
                                    w := t;
                                    m := i;
                                  end;
                              end;
                            s := s + GetShortDayName(m);
                          end;
                    else
                      w := 0;
                      m := 1;
                      for i := 1 to 7 do
                        begin
                          t := c.TextWidth(s + GetLongDayName(i));
                          if t > w then
                            begin
                              w := t;
                              m := i;
                            end;
                        end;
                      s := s + GetLongDayName(m);
                    end;
                    M_is_Min := False;
                    Format   := StripFormat(Format);
                  end;
            'M' : begin
                    if M_is_Min then
                      s := s + '##'
                    else
                      case FormatLength(Format, Format[1]) of
                        1,
                        2 : s := s + '##';
                        3 : begin
                              w := 0;
                              m := 1;
                              for i := 1 to 12 do
                                begin
                                  t := c.TextWidth(s + GetShortMonthName(i));
                                  if t > w then
                                    begin
                                      w := t;
                                      m := i;
                                    end;
                                end;
                              s := s + GetShortMonthName(m);
                            end;
                      else
                        w := 0;
                        m := 1;
                        for i := 1 to 12 do
                          begin
                            t := c.TextWidth(s + GetLongMonthName(i));
                            if t > w then
                              begin
                                w := t;
                                m := i;
                              end;
                          end;
                        s := s + GetLongMonthName(m);
                      end;
                    M_is_Min := False;
                    Format   := StripFormat(Format);
                  end;
            'Y' : begin
                    s        := s + YearText(MinYear);
                    M_is_Min := False;
                    Format   := StripFormat(Format);
                  end;
            'H' : begin
                    s        := s + '##';
                    M_is_Min := True;
                    Format   := StripFormat(Format);
                  end;
            'N',
            'S' : begin
                    s        := s + '##';
                    M_is_Min := False;
                    Format   := StripFormat(Format);
                  end;
            'Z' : begin
                    s        := s + '###';
                    M_is_Min := False;
                    Format   := StripFormat(Format);
                  end;
            'A' : begin
                    u := '';
                    v := '';
                    if StripString('am/pm', Format) then
                      begin
                        u := 'am';
                        v := 'pm';
                      end
                    else
                      if StripString('a/p', Format) then
                        begin
                          u := 'a';
                          v := 'p';
                        end
                      else
                        if StripString('ampm', Format) then
                          begin
                            u := GetTimeAMString;
                            v := GetTimePMString;
                          end;
                    w := c.TextWidth(s + u);
                    t := c.TextWidth(s + v);
                    if w > t then
                      s := s + u
                    else
                      s := s + v;
                    M_is_Min := False;
                  end;
            '/' : begin
                    s      := s + GetDateSeparator;
                    Format := Copy(Format, 2, length(Format));
                  end;
            ':' : begin
                    s      := s + GetTimeSeparator;
                    Format := Copy(Format, 2, length(Format));
                  end;
            '''',
            '"' : begin
                    ch     := Format[1];
                    Format := Copy(Format, 2, length(Format));
                    i      := Pos(ch, Format);
                    if i = 0 then
                      i    := Length(Format) + 1;
                    s      := s + Copy(Format, 1, i - 1);
                    Format := Copy(Format, i + 1, length(Format));
                  end;
          else
            s      := s + Format[1];
            Format := Copy(Format, 2, length(Format));
          end;
      end;
    FormatWidth := c.TextWidth(s);
  end;

procedure TMainForm.PrepareRingbuch(PixelsX, PixelsY, MaxBreite : Word;
                                    c : tCanvas);
  var     i, w, Error       : Integer;
          f                 : Real;
          DaylightBias,
          DoubleSummerBias,
          StandardBias      : Double;
  begin
    c.Font.Name    := LayoutForm.FontData[eArbeitsTag, False].Name;
    c.Font.CharSet := LayoutForm.FontData[eArbeitsTag, False].CharSet;
    c.Font.Size    := (LayoutForm.FontData[eArbeitsTag, False].Size
                       * longint(PixelsY)) div c.Font.PixelsPerInch;
    c.Font.Style   := [];
    ThinPenWidth   := MMtoPixel(MMPenWidth, PixelsY);
    Val(LayoutForm.PaperHeight.Text, f, Error);
    Error          := Error;
    Hoehe          := MMtoPixel(f, PixelsY);
    Val(LayoutForm.PaperWidth.Text, f, Error);
    Breite         := MMtoPixel(f, PixelsX);
    Spalten        := Maxbreite div Breite;
    LochX          := MMtoPixel(MMLoch, PixelsX) div 2;
    LochY          := MMtoPixel(MMLoch, PixelsY) div 2;
    Val(LayoutForm.Punch1.Text, f, Error);
    Loch1          := MMtoPixel(f, PixelsY);
    Val(LayoutForm.Punch2.Text, f, Error);
    Loch2          := MMtoPixel(f, PixelsY);
    Val(LayoutForm.Punch3.Text, f, Error);
    Loch3          := MMtoPixel(f, PixelsY);
    Val(LayoutForm.MarginLeft.Text, f, Error);
    TextRand       := MMtoPixel(f, PixelsX);
    LochRand       := MMtoPixel(f / 2, PixelsX);
    ZahlWeite      := FormatWidth(LayoutForm.DayMonthFormat.Text, c);
    i              := c.TextWidth(YearText(Jahr.Position));
    if i > ZahlWeite then
      ZahlWeite    := i;
    WTagWeite      := 0;
    for i := Sunday to Saturday do
      begin
        w := c.TextWidth(GetLongDayName(i) + '#');
        if w > WTagWeite Then
          WTagWeite := w;
      end;
    w := c.TextWidth(LongWeekName + '##');
    if w > WTagWeite Then
      WTagWeite := w;
    BlankWeite  := c.TextWidth(' ');
    TextHoehe   := GetTextHoehe(c);
    MondHoehe   := GetMondHoehe(c);
    LineGap     := GetLineGap(c);
    MondWeite   := (MondHoehe * PixelsX) div PixelsY;
    if TextRand + WTagWeite + ZahlWeite + BlankWeite
       + MondWeite + 2 * ThinPenWidth >= Breite
    then
      Status := FontZuBreit;
    if 3 * TextHoehe + 4 * ThinPenWidth > Hoehe div 7 then
      Status := FontZuHoch;
    DaylightBias     := 0;
    DoubleSummerBias := 0;
    StandardBias     := 0;
    GetDayLightDates(Jahr.Position,
                     DaylightDate1,
                     DoubleSummerDate,
                     DaylightDate2,
                     StandardDate,
                     DaylightBias,
                     DoubleSummerBias,
                     StandardBias);
  end;

procedure TMainForm.PreviewRingbuch;
  var     iVon,
          i, Error : Integer;
          Anfang   : tJulianDay;
  begin
    PrepareRingbuch(CanvasX, CanvasY,
                    PreviewForm.ClientWidth, PreviewForm.Canvas);
    Anfang := Week0(Jahr.Position);
    val(Von.Text, iVon, Error);
    Error := Error;
    if iVon > LastWeek(Jahr.Position) - Spalten + 1 then
      iVon := LastWeek(Jahr.Position) - Spalten + 1;
    for i := 0 to Spalten - 1 do
      PaintRingbuch(iVon + i, Anfang + (iVon + i) * 7, i * Breite,
                    PreviewForm.Image.Picture.Bitmap.Canvas);
  end;

procedure TMainForm.BmpRingbuch(Bitmap: tBitmap);
  var     i,
          iVon,
          iBis,
          Error,
          YesNo  : Integer;
          Anfang : tJulianDay;
          s, t   : String;
  begin
    Anfang := Week0(Jahr.Position);
    YesNo  := mrNo;
    PrepareRingbuch(BmpForm.UpDownDPI.Position, BmpForm.UpDownDPI.Position,
                    FormBreite, Bitmap.Canvas);
    val(Von.Text, iVon, Error);
    Error := Error;
    if Bis.Text = '' then
      iBis := iVon
    else
      val(Bis.Text, iBis, Error);
    if iBis < iVon then
      begin
        i    := iBis;
        iBis := iVon;
        iVon := i;
      end;
    for i := iVon to iBis do
      begin
        Bitmap.Canvas.Brush.Color := clWhite;
        Bitmap.Canvas.Brush.Style := bsSolid;
        Bitmap.Canvas.FillRect(Rect(0, 0, Bitmap.Width, Bitmap.Height));
        PaintRingbuch(i, Anfang + i * 7, 0, Bitmap.Canvas);
        s := SavePictureDialog.FileName;
        if iBis <> iVon then
          begin
            t := ExtractFileExt(s);
            s := Copy(s, 1, length(s) - length(t))
                 + ' ' + IntToDez(i, 2, False) + t;
          end;
        SaveBMP(Bitmap, s, YesNo);
      end;
  end;

procedure TMainForm.EmfRingbuch;
  {$ifndef fpc}
    var   i,
          iVon,
          iBis,
          Error,
          YesNo          : Integer;
          Anfang         : tJulianDay;
          s, t           : String;
          MetaFile       : tMetaFile;
          MetaFileCanvas : tMetaFileCanvas;
  {$endif}
  begin
    {$ifndef fpc}
      Anfang := Week0(Jahr.Position);
      YesNo  := mrNo;
      PrepareRingbuch(BmpForm.UpDownDPI.Position, BmpForm.UpDownDPI.Position,
                      FormBreite, Printer.Canvas);
      val(Von.Text, iVon, Error);
      if Bis.Text = '' then
        iBis := iVon
      else
        val(Bis.Text, iBis, Error);
      if iBis < iVon then
        begin
          i    := iBis;
          iBis := iVon;
          iVon := i;
        end;
      i := iVon;
      while i <= iBis do
        begin
          case SysLocale.PriLangID of
            Lang_German:
              begin
                s := 'Terminplaner Woche ' + IntToStr(i);
                CreateMetaFile(s, MetaFile, MetaFileCanvas);
                if MetaFile = Nil then
                  MsgBox(CP1252ToSystem('kann Metafile fr ') + s
                         + ' nicht erzeugen',
                         Caption, mb_IconHand);
              end;
          else
            s := 'appointment book week ' + IntToStr(i);
            CreateMetaFile(s, MetaFile, MetaFileCanvas);
            if MetaFile = Nil then
              MsgBox('cannot create metafile of ' + s,
                     Caption, mb_IconHand);
          end;
          if MetaFile = Nil then
            i := iBis
          else
            begin
              PaintRingbuch(i, Anfang + i * 7, 0, MetaFileCanvas);
              s := SavePictureDialog.FileName;
              if iBis <> iVon then
                begin
                  t := ExtractFileExt(s);
                  s := Copy(s, 1, length(s) - length(t))
                       + ' ' + IntToDez(i, 2, False) + t;
                end;
              MetaFileCanvas.Free;
              SaveEMF(MetaFile, s, YesNo);
              MetaFile.Free;
            end;
          inc(i);
        end;
    {$endif}
  end;

procedure TMainForm.PrintRingbuch;
  var     i, k,
          w, dw,
          Error,
          iVon,
          iBis,
          Copies : Integer;
          Anfang : tJulianDay;
  begin
    case SysLocale.PriLangID of
      LANG_GERMAN:
        Printer.Title := 'Kalender ' + YearText(Jahr.Position)
                         + ' Ringbuch '  + Von.Text;
    else
      Printer.Title := 'Calendar ' + YearText(Jahr.Position)
                       + ' App. book ' + Von.Text;
    end;
    if Bis.Text > '' then
      Printer.Title := Printer.Title + ' - ' + Bis.Text;
    Anfang             := Week0(Jahr.Position);
    Copies             := PrintDialog.Copies;
    PrintDialog.Copies := 1;
    k                  := 0;
    while k < Copies do
      begin
        inc(k);
        Printer.BeginDoc;
        if k = 1 then
          PrepareRingbuch(LayoutForm.PrinterLogX, LayoutForm.PrinterLogY,
                          LayoutForm.PrinterResX, Printer.Canvas);
        val(Von.Text, iVon, Error);
        Error := Error;
        w := iVon;
        if Bis.Text = '' then
          iBis := w
        else
          val(Bis.Text, iBis, Error);
        if iBis >= w then
          dw := (iBis - w + Spalten) div Spalten
        else
          dw := (w - iBis + Spalten) div Spalten;
        i := 0;
        while i <= abs(iBis - iVon) do
          begin
            inc(i);
            PaintRingbuch(w, Anfang + w * 7, ((i - 1) mod Spalten) * Breite,
                          Printer.Canvas);
            if ((Status = FontZuHoch) or (Status = FontZuBreit))
               and (LayoutForm.CheckSizes.Checked)
            then
              i := 53;
            if (i mod Spalten) = 0 then
              begin
                if (w <> iBis) or ((abs(iBis - iVon) + 1) mod Spalten <> 0) Then
                  Printer.NewPage;
                if iVon < iBis then
                  dec(w, (Spalten - 1) * dw - 1)
                else
                  inc(w, (Spalten - 1) * dw - 1);
              end
            else
              if iVon < iBis then
                inc(w, dw)
              else
                dec(w, dw);
          end;
        if ((Status = FontZuHoch) or (Status = FontZuBreit))
           and (LayoutForm.CheckSizes.Checked)
        then
          begin
            Printer.Abort;
            k := Copies;
          end;
        Printer.EndDoc;
      end;
  end;

function DateiFilter(TextDatei, HtmlDatei, RtfDatei : String) : String;
  var    s : String;
         i : tFileIndex;
  begin
    s := '';
    if RtfDatei = '' then;
    for i := Low(tFileIndex) to High(tFileIndex) do
      case i of
        FileIndexTxt :   s := s + Trenn + Textdatei + Trenn + Stern + ExtTxt;
        FileIndexHtm :   s := s + Trenn + HtmlDatei + Trenn + Stern + ExtHtm;
        {$ifndef Unix}
          FileIndexRtf : s := s + Trenn + RtfDatei  + Trenn + Stern + ExtRtf;
        {$endif}
      end;
    DateiFilter := Copy(s, 2, length(s));
  end;

procedure TMainForm.Datei;
  var     s       : String;
          IniFile : tIniFile;
  begin
    SaveDialog.FileName := YearText(Jahr.Position);
    case SysLocale.PriLangID of
      Lang_German:
        SaveDialog.Filter :=
          DateiFilter('Textdatei', 'HTML Datei', 'Rich Text Datei');
    else
      SaveDialog.Filter :=
        DateiFilter('Text file', 'HTML file', 'Rich text file');
    end;
    IniFile := tIniFile.Create(IniName);
    if IniFile <> Nil then
      begin
        SaveDialog.FilterIndex := IniFile.ReadInteger(
          IniFileTypes, IniSaveFile, 0);
        IniFile.Free;
      end;
    If SaveDialog.Execute Then
      begin
        IniFile := tIniFile.Create(IniName);
        if IniFile <> Nil then
          begin
            IniFile.WriteInteger(
              IniFileTypes, IniSaveFile, SaveDialog.FilterIndex);
            IniFile.Free;
          end;
        s := ExtractFileExt(SaveDialog.FileName);
        s := Copy(SaveDialog.FileName, 1,
                  length(SaveDialog.FileName) - length(s));
        case tFileIndex(SaveDialog.FilterIndex - 1) of
          FileIndexTxt :   begin
                             SaveDialog.FileName := s + '.' + ExtTxt;
                             TextDatei;
                           end;
          FileIndexHtm :   begin
                             SaveDialog.FileName := s + '.' + ExtHtm;
                             HtmlDatei;
                           end;
          {$ifndef Unix}
            FileIndexRtf : begin
                             SaveDialog.FileName := s + '.' + ExtRtf;
                             RtfDatei;
                           end;
          {$endif}
        end;
      end;
  end;

procedure TMainForm.TextDatei;
  var     j                  : Integer;
          m, Monat, Woche    : word;
          Day, TestDatum,
          NaechstesMondDatum,
          Datum              : tJulianDay;
          Phase,
          NaechsteMondphase  : tMoonsPhase;
          BesondererTag,
          s, p               : String;
          Txt                : TextFile;
          DaylightBias,
          DoubleSummerBias,
          StandardBias       : Double;
  begin
    AssignFile(Txt, SaveDialog.FileName);
    Rewrite(Txt);
    DaylightBias     := 0;
    DoubleSummerBias := 0;
    StandardBias     := 0;
    GetDayLightDates(Jahr.Position,
                     DaylightDate1,
                     DoubleSummerDate,
                     DaylightDate2,
                     StandardDate,
                     DaylightBias,
                     DoubleSummerBias,
                     StandardBias);
    Day   := 1.5;
    Monat := 1;
    Datum := LocalJulianDay(Jahr.Position, Monat, Day);
    NaechstesMondDatum := Datum + 7;
    NaechsteMondPhase  := NewMoon;
    for Phase := Low(tMoonsPhase) to high(tMoonsPhase) do
      begin
        TestDatum := MoonsPhase(Phase, Datum);
        if TestDatum >= Datum Then
          if TestDatum < NaechstesMondDatum Then
            begin
              NaechstesMondDatum := TestDatum;
              NaechsteMondPhase  := Phase;
            end;
      end;
    repeat
      Application.ProcessMessages;
      Write(Txt, A_HT, LocalJulianFormatDateTime(GetLongDateFormat, Datum));
      if LocalSameDate(Datum, NaechstesMondDatum) Then
        begin
          Write(Txt, A_HT, MoonsPhaseName[NaechsteMondPhase]);
          if NaechsteMondPhase = high(tMoonsPhase) Then
            NaechsteMondPhase := Low(tMoonsPhase)
          else
            inc(NaechsteMondPhase);
          NaechstesMondDatum :=
            MoonsPhase(NaechsteMondPhase, NaechstesMondDatum + 7);
        end;
      s := DaylightText(Datum);
      if s > '' then
        write(Txt, ' ', s);
      WriteLn(Txt);
      BesondererTag := '';
      CalPrintHoliday(Datum, BesondererTag);    
      while BesondererTag > '' do
        begin
          j := Pos(A_LF, BesondererTag);
          if j = 0 Then
            j := Length(BesondererTag) + 1;
          WriteLn(Txt, A_HT, Copy(BesondererTag, 1, j - 1));
          BesondererTag := Copy(BesondererTag, j + 1, length(BesondererTag));
        end;
      p := DatesForm.IsTermin(Trunc(Day), Monat, Jahr.Position);
      while p > '' do
        begin
          j := Pos(A_LF, p);
          if j = 0 Then
            j := Length(p) + 1;
          WriteLn(Txt, A_HT, CalcTermin(Copy(p, 1, j - 1), Jahr.Position, s));
          p := Copy(p, j + 1, length(p));
        end;
      WriteLn(Txt);
      WriteLn(Txt);
      Datum := Datum + 1;
      LocalJulianDate(Datum, j, Monat, Day);
    until j <> Jahr.Position;
    Day   := 1.5;
    Monat := 1;
    Datum := LocalJulianDay(Jahr.Position, Monat, Day);
    Case LocalJulDayOfWeek(Datum {Neujahr, Feiertag}) of
      Friday,
      Saturday,
      Sunday: Woche := 0 {enthlt keinen Arbeitstag}
    else
      Woche := 1 {enthlt Arbeitstage};
    end;
    for Monat := 1 to 12 do
      begin
        WriteLn(Txt, A_HT, GetLongMonthName(Monat), ' ', YearText(Jahr.Position));
        Write(Txt,   A_HT, LongWeekName);
        for j := 0 to 6 do
          Write(Txt, A_HT,
                copy(GetShortDayName(succ((j + Monday + 6) mod 7)), 1, 2));
        WriteLn(Txt);
        Write(Txt, A_HT, Woche);
        for j := 1 to (LocalJulDayOfWeek(Datum) + 7 - Monday) mod 7 do
          Write(Txt, A_HT);
        repeat
          Application.ProcessMessages;
          Write(Txt, A_HT, Trunc(Day));
          Datum := Datum + 1;
          m     := 0;
          LocalJulianDate(Datum, j, m, Day);
          if LocalJulDayOfWeek(Datum) = Monday Then
            begin
              Inc(Woche);
              if m = Monat Then
                begin
                  WriteLn(Txt);
                  Write(Txt, A_HT, Woche);
                end;
            end;
        until m <> Monat;
        WriteLn(Txt);
        WriteLn(Txt);
        Day   := 1.5;
        Datum := LocalJulianDay(Jahr.Position, Monat, Day);
        repeat
          CalPrintHoliday(Datum, BesondererTag);
          while BesondererTag > '' do
            begin
              j := Pos(A_LF, BesondererTag);
              if j = 0 Then
                j := length(BesondererTag) + 1;
              WriteLn(Txt, A_HT, Trunc(Day), '.', A_HT,
                      Copy(BesondererTag, 1, j - 1));
              BesondererTag := Copy(BesondererTag, j + 1,
                                    length(BesondererTag));
            end;
          p := DatesForm.IsTermin(Trunc(Day), Monat, Jahr.Position);
          while p > '' do
            begin
              j := Pos(A_LF, p);
              if j = 0 Then
                j := Length(p) + 1;
              WriteLn(Txt, A_HT, Trunc(Day), '.', A_HT,
                      CalcTermin(Copy(p, 1, j - 1), Jahr.Position, s));
              p := Copy(p, j + 1, length(p));
            end;
          Datum := Datum + 1;
          LocalJulianDate(Datum, j, m, Day);
        until m <> Monat;
        WriteLn(Txt);
        WriteLn(Txt);
      end;
    CloseFile(Txt);
  end;

procedure TMainForm.RTFAdd(s : String; f : tFont);
  {$ifdef fpc}
    const
      AllFontStyles : TFontStyles = [fsBold, fsItalic, fsUnderline, fsStrikeOut];
  {$endif}
  begin
    RichEdit.SelStart  := length(RichEdit.Text);
    RichEdit.SelText   := s;
    RichEdit.SelStart  := length(RichEdit.Text);
    RichEdit.SelLength := length(s);
    {$ifdef fpc}
      RichEdit.SetRangeParams(RichEdit.SelStart, RichEdit.SelLength,
                              [tmm_Color],  '', 0, f.Color, [], []);
      RichEdit.SetRangeParams(RichEdit.SelStart, RichEdit.SelLength,
                              [tmm_Styles], '', 0, 0, f.Style,
                              AllFontStyles - f.Style);
      RichEdit.SetRangeParams(RichEdit.SelStart, RichEdit.SelLength,
                              [tmm_Size],   '', f.Size, 0, [], []);
    {$else}
      RichEdit.SelAttributes.Color := f.Color;
      RichEdit.SelAttributes.Style := f.Style;
      RichEdit.SelAttributes.Size  := f.Size;
    {$endif}
  end;

procedure TMainForm.RTFDatei;
  var     j                  : Integer;
          m, Monat, Woche    : word;
          Day, TestDatum,
          NaechstesMondDatum,
          Datum              : tJulianDay;
          Phase,
          NaechsteMondphase  : tMoonsPhase;
          BesondererTag,
          s, p               : String;
          b                  : Boolean;
          f                  : tFont;
          DaylightBias,
          DoubleSummerBias,
          StandardBias       : Double;
  begin
    f := tFont.Create;
    if f = Nil then
      case SysLocale.PriLangID of
        Lang_German:
          MsgBox('kann Font Objekt nicht erzeugen!', Caption, mb_IconHand);
      else
        MsgBox('cannot create font object', Caption, mb_IconHand);
      end
    else
      begin
        for j := 0 to sizeof(f) do
          PAnsiChar(f)[j] := PAnsiChar(RichEdit.Font)[j];
        DaylightBias       := 0;
        DoubleSummerBias   := 0;
        StandardBias       := 0;
        m                  := 1;
        Day                := 1.5;
        Monat              := 1;
        BesondererTag      := '';
        RichLen            := 0;
        Datum              := LocalJulianDay(Jahr.Position, Monat, Day);
        NaechstesMondDatum := Datum + 7;
        NaechsteMondPhase  := NewMoon;
        Richedit.Clear;
        GetDayLightDates(Jahr.Position,
                         DaylightDate1,
                         DoubleSummerDate,
                         DaylightDate2,
                         StandardDate,
                         DaylightBias,
                         DoubleSummerBias,
                         StandardBias);
        for Phase := Low(tMoonsPhase) to high(tMoonsPhase) do
          begin
            TestDatum := MoonsPhase(Phase, Datum);
            if TestDatum >= Datum Then
              if TestDatum < NaechstesMondDatum Then
                begin
                  NaechstesMondDatum := TestDatum;
                  NaechsteMondPhase  := Phase;
                end;
          end;
        repeat
          Application.ProcessMessages;
          b := CalPrintHoliday(Datum, BesondererTag);
          f.Style := [];
          f.Size  := 10;
          if b then
            f.Color := clRed
          else
            if LocalJulDayOfWeek(Datum) = Saturday then
              f.Color := clBlue
            else
              f.Color := clBlack;
          RTFAdd(A_HT + LocalJulianFormatDateTime(
            GetLongDateFormat, Datum), f);
          if LocalSameDate(Datum, NaechstesMondDatum) Then
            begin
              RTFAdd(A_HT + MoonsPhaseName[NaechsteMondPhase], f);
              if NaechsteMondPhase = high(tMoonsPhase) Then
                NaechsteMondPhase := Low(tMoonsPhase)
              else
                inc(NaechsteMondPhase);
              NaechstesMondDatum :=
                MoonsPhase(NaechsteMondPhase, NaechstesMondDatum + 7);
            end;
          s := DaylightText(Datum);
          if s > '' then
            RTFAdd(' ' + s, f);
          RTFAdd(A_LF, f);
          while BesondererTag > '' do
            begin
              j := Pos(A_LF, BesondererTag);
              if j = 0 Then
                j := Length(BesondererTag) + 1;
              RTFAdd(A_HT + Copy(BesondererTag, 1, j - 1) + A_LF, f);
              BesondererTag := Copy(BesondererTag, j + 1, length(BesondererTag));
            end;
          p := DatesForm.IsTermin(Trunc(Day), Monat, Jahr.Position);
          while p > '' do
            begin
              j := Pos(A_LF, p);
              if j = 0 Then
                j := Length(p) + 1;
              f.color := clAqua;
              RTFAdd(A_HT + CalcTermin(Copy(p, 1, j - 1), Jahr.Position, s)
                     + A_LF, f);
              p := Copy(p, j + 1, length(p));
            end;
          RTFAdd(A_LF, f);
          RTFAdd(A_LF, f);
          Datum := Datum + 1;
          LocalJulianDate(Datum, j, Monat, Day);
        until j <> Jahr.Position;
        Day   := 1.5;
        Monat := 1;
        Datum := LocalJulianDay(Jahr.Position, Monat, Day);
        Case LocalJulDayOfWeek(Datum {Neujahr, Feiertag}) of
          Friday,
          Saturday,
          Sunday: Woche := 0 {enthlt keinen Arbeitstag}
        else
          Woche := 1 {enthlt Arbeitstage};
        end;
        for Monat := 1 to 12 do
          begin
            f.Color := clBlue;
            f.Size  := 14;
            RTFadd(A_HT + GetLongMonthName(Monat) + ' '
                   + YearText(Jahr.Position) + A_LF,
                   f);
            f.color := clLime;
            f.Size  := 10;
            RTFadd(A_HT + LongWeekName, f);
            for j := 0 to 4 do
              begin
                f.color := clBlack;
                RTFadd(A_HT
                       + copy(GetShortDayName(succ((j + Monday + 6) mod 7)), 1, 2),
                       f);
              end;
            f.color := clAqua;
            RTFadd(A_HT
                   + copy(GetShortDayName(Saturday), 1, 2),
                   f);
            f.color := clRed;
            RTFadd(A_HT
                   + copy(GetShortDayName(Sunday), 1, 2),
                   f);
            RTFadd(A_LF, f);
            f.color := clLime;
            RTFadd(A_HT + IntToStr(Woche), f);
            for j := 1 to (LocalJulDayOfWeek(Datum) + 7 - Monday) mod 7 do
              RTFadd(A_HT, f);
            repeat
              Application.ProcessMessages;
              b := CalPrintHoliday(Datum, BesondererTag);
              if b then
                f.Color := clRed
              else
                if LocalJulDayOfWeek(Datum) = Saturday then
                  f.Color := clAqua
                else
                  f.Color := clBlack;
              p := DatesForm.IsTermin(Trunc(Day), Monat, Jahr.Position);
              RTFadd(A_HT, f);
              if p > '' then
                f.Style := [fsUnderline]
              else
                f.Style := [];
              RTFadd(IntToStr(Trunc(Day)), f);
              f.Style := [];
              Datum := Datum + 1;
              LocalJulianDate(Datum, j, m, Day);
              if LocalJulDayOfWeek(Datum) = Monday Then
                begin
                  Inc(Woche);
                  if m = Monat Then
                    begin
                      RTFadd(A_LF, f);
                      f.color := clLime;
                      RTFadd(A_HT + IntToStr(Woche), f);
                    end;
                end;
            until m <> Monat;
            RTFadd(A_LF, f);
            RTFadd(A_LF, f);
            Day     := 1.5;
            Datum   := LocalJulianDay(Jahr.Position, Monat, Day);
            f.Color := clBlack;
            repeat
              CalPrintHoliday(Datum, BesondererTag);
              while BesondererTag > '' do
                begin
                  j := Pos(A_LF, BesondererTag);
                  if j = 0 Then
                    j := length(BesondererTag) + 1;
                  RTFadd(A_HT + IntToStr(Trunc(Day)) + '.' + A_HT
                         + Copy(BesondererTag, 1, j - 1) + A_LF,
                         f);
                  BesondererTag := Copy(BesondererTag, j + 1,
                                        length(BesondererTag));
                end;
              p := DatesForm.IsTermin(Trunc(Day), Monat, Jahr.Position);
              while p > '' do
                begin
                  j := Pos(A_LF, p);
                  if j = 0 Then
                    j := Length(p) + 1;
                  RTFAdd(A_HT + IntToStr(Trunc(Day)) + '.' + A_HT
                         + CalcTermin(Copy(p, 1, j - 1), Jahr.Position, s) + A_LF,
                         f);
                  p := Copy(p, j + 1, length(p));
                end;
              Datum := Datum + 1;
              LocalJulianDate(Datum, j, m, Day);
            until m <> Monat;
            RTFadd(A_LF, f);
            RTFadd(A_LF, f);
          end;
        s := '';
        try
          RichEdit.Lines.SaveToFile(SaveDialog.FileName);
        except
          on e : exception do
            s := e.Message;
        end;
        if s > '' then
          case SysLocale.PriLangID of
            Lang_German:
              MsgBox('Speichern gescheitert!' + a_LF + s, Caption, mb_IconHand);
          else
            MsgBox('Saving failed!' + a_LF + s, Caption, mb_IconHand);
          end;
        f.Free;
      end;
  end;

procedure TMainForm.HTMLDatei;
  var     j                  : Integer;
          m, Monat, Woche    : word;
          Day, TestDatum,
          NaechstesMondDatum,
          Datum              : tJulianDay;
          Phase,
          NaechsteMondphase  : tMoonsPhase;
          BesondererTag,
          s, p               : String;
          HTML               : TextFile;
          DaylightBias,
          DoubleSummerBias,
          StandardBias       : Double;
  begin
    AssignFile(HTML, SaveDialog.FileName);
    Rewrite(HTML);
    DaylightBias     := 0;
    DoubleSummerBias := 0;
    StandardBias     := 0;
    GetDayLightDates(Jahr.Position,
                     DaylightDate1,
                     DoubleSummerDate,
                     DaylightDate2,
                     StandardDate,
                     DaylightBias,
                     DoubleSummerBias,
                     StandardBias);
    writeln(HTML, '<html>');
    writeln(HTML, '<head>');
    {$ifdef fpc}
      writeln(HTML, '<meta http-equiv="Content-Type" content='
                    +'"text/html; charset=UTF-8">');
    {$else}
      writeln(HTML, '<meta http-equiv="Content-Type" content='
                    +'"text/html; charset=UNKNOWN-8BIT">');
    {$endif}
    writeln(HTML, '</head>');
    writeln(HTML, '<body>');
    Day   := 1.5;
    Monat := 1;
    Datum := LocalJulianDay(Jahr.Position, Monat, Day);
    NaechstesMondDatum := Datum + 7;
    NaechsteMondPhase  := NewMoon;
    for Phase := Low(tMoonsPhase) to high(tMoonsPhase) do
      begin
        TestDatum := MoonsPhase(Phase, Datum);
        if TestDatum >= Datum Then
          if TestDatum < NaechstesMondDatum Then
            begin
              NaechstesMondDatum := TestDatum;
              NaechsteMondPhase  := Phase;
            end;
      end;
    repeat
      Application.ProcessMessages;
      BesondererTag := '';
      if CalPrintHoliday(Datum, BesondererTag) then
        WriteLn(HTML, '<font color="#ff0000">')
      else
        if LocalJulDayOfWeek(Datum) = Saturday then
          WriteLn(HTML, '<font color="#0000ff">')
        else
          WriteLn(HTML, '<font color="#000000">');
      Write(HTML, LocalJulianFormatDateTime(GetLongDateFormat, Datum));
      if LocalSameDate(Datum, NaechstesMondDatum) Then
        begin
          Write(HTML, ' ', MoonsPhaseName[NaechsteMondPhase]);
          if NaechsteMondPhase = high(tMoonsPhase) Then
            NaechsteMondPhase := Low(tMoonsPhase)
          else
            inc(NaechsteMondPhase);
          NaechstesMondDatum :=
            MoonsPhase(NaechsteMondPhase, NaechstesMondDatum + 7);
        end;
      s := DaylightText(Datum);
      if s > '' then
        write(HTML, ' ', s);
      WriteLn(HTML, '<br>');
      while BesondererTag > '' do
        begin
          j := Pos(A_LF, BesondererTag);
          if j = 0 Then
            j := Length(BesondererTag) + 1;
          WriteLn(HTML, Copy(BesondererTag, 1, j - 1), '<br>');
          BesondererTag := Copy(BesondererTag, j + 1, length(BesondererTag));
        end;
      WriteLn(HTML, '</font>');
      WriteLn(HTML, '<font color="#00ffff">');
      p := DatesForm.IsTermin(Trunc(Day), Monat, Jahr.Position);
      while p > '' do
        begin
          j := Pos(A_LF, p);
          if j = 0 Then
            j := Length(p) + 1;
          WriteLn(HTML, CalcTermin(Copy(p, 1, j - 1),
                         Jahr.Position, s), '<br>');
          p := Copy(p, j + 1, length(p));
        end;
      WriteLn(HTML, '</font>');
      WriteLn(HTML, '<p>');
      Datum := Datum + 1;
      LocalJulianDate(Datum, j, Monat, Day);
    until j <> Jahr.Position;
    Day   := 1.5;
    Monat := 1;
    Datum := LocalJulianDay(Jahr.Position, Monat, Day);
    Case LocalJulDayOfWeek(Datum {Neujahr, Feiertag}) of
      Friday,
      Saturday,
      Sunday: Woche := 0 {enthlt keinen Arbeitstag}
    else
      Woche := 1 {enthlt Arbeitstage};
    end;
    for Monat := 1 to 12 do
      begin
        Write(HTML,   '<h1><font color="#0000ff">');
        Write(HTML,   GetLongMonthName(Monat), ' ', YearText(Jahr.Position));
        Write(HTML,   '</font></h1>');
        WriteLn(HTML, '<br>');
        WriteLn(HTML, '<table COLS=8>');
        WriteLn(HTML, '<tr>');
        Write(HTML,   '<td><div align=right>');
        Write(HTML,   '<font color="#00ff00">');
        Write(HTML,   LongWeekName);
        Write(HTML,   '</font>');
        WriteLn(HTML, '</div></td>');
        for j := 0 to 4 do
          begin
            Application.ProcessMessages;
            Write(HTML,   '<td><div align=right>');
            Write(HTML,   '<font color="#000000">');
            Write(HTML,   copy(GetShortDayName(succ((j + Monday + 6) mod 7)),
                               1, 2));
            Write(HTML,   '</font>');
            WriteLn(HTML, '</div></td>');
          end;
        Write(HTML,   '<td><div align=right>');
        Write(HTML,   '<font color="#00ffff">');
        Write(HTML,   copy(GetShortDayName(Saturday), 1, 2));
        Write(HTML,   '</font>');
        WriteLn(HTML, '</div></td>');
        Write(HTML,   '<td><div align=right>');
        Write(HTML,   '<font color="#ff0000">');
        Write(HTML,   copy(GetShortDayName(Sunday), 1, 2));
        Write(HTML,   '</font>');
        WriteLn(HTML, '</div></td>');
        WriteLn(HTML, '</tr>');
        WriteLn(HTML, '<tr>');
        Write(HTML,   '<td><div align=right>');
        Write(HTML,   '<font color="#00ff00">');
        Write(HTML,   Woche);
        Write(HTML,   '</font>');
        WriteLn(HTML, '</div></td>');
        for j := 1 to (LocalJulDayOfWeek(Datum) + 7 - Monday) mod 7 do
          Writeln(HTML, '<td></td>');
        repeat
          Write(HTML,   '<td><div align=right>');
          p := DatesForm.IsTermin(Trunc(Day), Monat, Jahr.Position);
          if p > '' then
            Write(HTML, '<u>');
          if CalPrintHoliday(Datum, BesondererTag) then
            Write(HTML, '<font color="#ff0000">')
          else
            if LocalJulDayOfWeek(Datum) = Saturday then
              Write(HTML, '<font color="#00ffff">')
            else
              Write(HTML, '<font color="#000000">');
          Write(HTML,   Trunc(Day));
          Write(HTML,   '</font>');
          if p > '' then
            Write(HTML, '</u>');
          WriteLn(HTML, '</div></td>');
          Datum := Datum + 1;
          m     := 0;
          LocalJulianDate(Datum, j, m, Day);
          if LocalJulDayOfWeek(Datum) = Monday then
            begin
              Inc(Woche);
              if m = Monat Then
                begin
                  WriteLn(HTML, '</tr>');
                  WriteLn(HTML, '<tr>');
                  Write(HTML,   '<td><div align=right>');
                  Write(HTML,   '<font color="#00ff00">');
                  Write(HTML,   Woche);
                  Write(HTML,   '</font>');
                  WriteLn(HTML, '</div></td>');
                end;
            end;
        until m <> Monat;
        WriteLn(HTML, '</tr>');
        WriteLn(HTML, '</table>');
        WriteLn(HTML, '<table COLS=2>');
        Day   := 1.5;
        Datum := LocalJulianDay(Jahr.Position, Monat, Day);
        repeat
          CalPrintHoliday(Datum, BesondererTag);
          while BesondererTag > '' do
            begin
              j := Pos(A_LF, BesondererTag);
              if j = 0 Then
                j := Length(BesondererTag) + 1;
              WriteLn(HTML, '<tr>');
              Write(HTML,   '<td><div align=right>');
              Write(HTML,   '<font color="#000000">');
              Write(HTML,   Trunc(Day), '.');
              Write(HTML,   '</font>');
              WriteLn(HTML, '</div></td>');
              Write(HTML,   '<td>');
              Write(HTML,   '<font color="#000000">');
              Write(HTML,   Copy(BesondererTag, 1, j - 1));
              Write(HTML,   '</font>');
              WriteLn(HTML, '</td>');
              WriteLn(HTML, '</tr>');
              BesondererTag := Copy(BesondererTag, j + 1,
                                    length(BesondererTag));
            end;
          p := DatesForm.IsTermin(Trunc(Day), Monat, Jahr.Position);
          while p > '' do
            begin
              j := Pos(A_LF, p);
              if j = 0 Then
                j := length(p) + 1;
              WriteLn(HTML, '<tr>');
              Write(HTML,   '<td><div align=right>');
              Write(HTML,   '<font color="#000000">');
              Write(HTML,   Trunc(Day), '.');
              Write(HTML,   '</font>');
              WriteLn(HTML, '</div></td>');
              Write(HTML,   '<td>');
              Write(HTML,   '<font color="#000000">');
              Write(HTML,   CalcTermin(Copy(p, 1, j - 1), Jahr.Position, s));
              Write(HTML,   '</font>');
              WriteLn(HTML, '</td>');
              WriteLn(HTML, '</tr>');
              p := Copy(p, j + 1, length(p));
            end;
          Datum := Datum + 1;
          LocalJulianDate(Datum, j, m, Day);
        until m <> Monat;
        WriteLn(HTML, '</table>');
      end;
    writeln(HTML, '</body>');
    writeln(HTML, '</html>');
    CloseFile(HTML);
  end;

procedure TMainForm.EnableAll(MakeEnabled : Boolean);
  var     c : tColor;
  begin
    if MakeEnabled then
      c := clWindowText
    else
      c := clGrayText;
    Jahr.Enabled              := MakeEnabled;
    JahrEdit.Enabled          := MakeEnabled;
    JahrEdit.Font.Color       := c;
    UpDownVon.enabled         := MakeEnabled;
    Von.Enabled               := MakeEnabled;
    Von.Font.Color            := c;
    UpDownBis.enabled         := MakeEnabled;
    Bis.Enabled               := MakeEnabled;
    Bis.Font.Color            := c;
    Formular.Enabled          := MakeEnabled;
    TerminListe.Enabled       := MakeEnabled;
    LayoutComboBox.Enabled    := MakeEnabled;
    FeiertageListe.Enabled    := MakeEnabled;
    BtnNewDates.Enabled       := MakeEnabled;
    BtnNewLayout.Enabled      := MakeEnabled;
    BtnNewUserHoliday.Enabled := MakeEnabled;
    BtnNewAutoHoliday.Enabled := MakeEnabled;
    if MakeEnabled then
      begin
        CheckTerminListeButtons;
        CheckLayoutButtons;
        CheckFeiertageButtons;
      end
    else
      begin
        BtnDrucken.Enabled         := False;
        BtnExport.Enabled          := False;
        BtnEditDates.Enabled       := False;
        BtnCopyDates.Enabled       := False;
        BtnDelDates.Enabled        := False;
        BtnEditLayout.Enabled      := False;
        BtnCopyLayout.Enabled      := False;
        BtnDelLayout.Enabled       := False;
        BtnEditUserHoliday.Enabled := False;
        BtnCopyUserHoliday.Enabled := False;
        BtnDelHoliday.Enabled      := False;
        BtnEditAutoHoliday.Enabled := False;
        BtnCopyAutoHoliday.Enabled := False;
      end;
  end;

procedure TMainForm.BtnDruckenClick(Sender: TObject);
  var     OldOrientation : tPrinterOrientation;
  begin
    EnableAll(False);
    TerminListeLoad;
    UserHolidaysLoad;
    AutoHolidaysLoad;
    Status         := Ok;
    OldOrientation := Printer.Orientation;
    case tFormular(Formular.ItemIndex) of
      FormularEineSeite:
        if PrintDialog.execute then
           { PrintDialog.execute kann z.B. Printer.Orientation berschreiben
             Daher wird das Layout erst hier gesetzt
           }
          begin
            Screen.Cursor  := crHourGlass;
            OldOrientation := Printer.Orientation;
            LayoutLoad;
            CanvasX := LayoutForm.PrinterLogX;
            CanvasY := LayoutForm.PrinterLogY;
            try
              PrintEineSeite;
            except
            end;
            Screen.Cursor := crDefault;
          end;
      FormularRingbuch:
        if PrintDialog.execute then
          begin
            Screen.Cursor  := crHourGlass;
            OldOrientation := Printer.Orientation;
            LayoutLoad;
            CanvasX := LayoutForm.PrinterLogX;
            CanvasY := LayoutForm.PrinterLogY;
            try
              PrintRingbuch;
            except
            end;
            Screen.Cursor := crDefault;
          end;
      FormularMonat:
        if PrintDialog.execute then
          begin
            Screen.Cursor  := crHourGlass;
            OldOrientation := Printer.Orientation;
            LayoutLoad;
            CanvasX := LayoutForm.PrinterLogX;
            CanvasY := LayoutForm.PrinterLogY;
            try
              PrintMonatsplaner;
            except
            end;
            Screen.Cursor := crDefault;
          end;
      FormularBilder:
        if PrintDialog.execute then
          begin
            Screen.Cursor  := crHourGlass;
            OldOrientation := Printer.Orientation;
            LayoutLoad;
            CanvasX := LayoutForm.PrinterLogX;
            CanvasY := LayoutForm.PrinterLogY;
            try
              PrintBilder;
            except
            end;
            Screen.Cursor := crDefault;
          end;
      FormularDatei:
        begin
          Screen.Cursor := crHourGlass;
          Datei;
          Screen.Cursor := crDefault;
        end;
    end;
    Printer.Orientation := OldOrientation;
    StatusCheck;
    EnableAll(True);
  end;

procedure TMainForm.FormularClick(Sender: TObject);
  var     IniFile     : tIniFile;
          DefaultVon,
          DefaultBis  : String;
  begin
    try
      IniFile := tIniFile.Create(IniName);
    except
      IniFile := Nil;
    end;
    if IniFile <> Nil then
      try
        IniFile.WriteInteger(Name, IniForm, Formular.ItemIndex);
      finally
        IniFile.Free;
      end;
    case tFormular(Formular.ItemIndex) of
      FormularEineSeite:
        begin
          LayoutGroupBox.Visible := True;
          BereichBox.Visible     := True;
          DefaultVon             := GetLongMonthName(1);
          DefaultBis             := GetLongMonthName(12);
          case SysLocale.PriLangID of
            LANG_GERMAN:
              begin
                BtnDrucken.Caption := '&Drucken';
                LabelVon.Caption   := 'Monat';
                Von.Hint           := 'nur aufsteigend';
              end;
          else
            begin
              BtnDrucken.Caption := '&Print';
              LabelVon.Caption   := 'Month';
              Von.Hint           := 'only ascending';
            end;
          end;
        end;
      FormularMonat:
        begin
          LayoutGroupBox.Visible := True;
          BereichBox.Visible     := True;
          DefaultVon             := '';
          DefaultBis             := GetLongMonthName(12);
          case SysLocale.PriLangID of
            LANG_GERMAN:
              begin
                BtnDrucken.Caption := '&Drucken';
                LabelVon.Caption   := 'Monat';
                Von.Hint           := 'nur aufsteigend';
             end;
          else
            begin
              BtnDrucken.Caption := '&Print';
              LabelVon.Caption   := 'Month';
              Von.Hint           := 'only ascending';
            end;
          end;
        end;
      FormularRingbuch:
        begin
          LayoutGroupBox.Visible := True;
          BereichBox.Visible     := True;
          DefaultVon             := '';
          DefaultBis             := '53';
          LabelVon.Caption       := LongWeekName;
          case SysLocale.PriLangID of
            Lang_German:
              begin
                BtnDrucken.Caption := '&Drucken';
                Von.Hint           := 'auf- oder absteigend';
              end;
          else
            begin
              BtnDrucken.Caption := '&Print';
              Von.Hint           := 'ascending or descending';
            end;
          end;
        end;
      FormularBilder:
        begin
          LayoutGroupBox.Visible := True;
          BereichBox.Visible     := True;
          DefaultVon             := GetLongMonthName(1);
          DefaultBis             := GetLongMonthName(12);
          case SysLocale.PriLangID of
            Lang_German:
              begin
                BtnDrucken.Caption := '&Drucken';
                LabelVon.Caption   := 'Monat';
                Von.Hint           := 'auf- oder absteigend';
              end;
          else
            begin
              BtnDrucken.Caption := '&Print';
              LabelVon.Caption   := 'Month';
              Von.Hint           := 'ascending or descending';
            end;
          end;
        end;
      FormularDatei:
        begin
          LayoutGroupBox.Visible := False;
          BereichBox.Visible     := False;
          DefaultVon             := '';
          DefaultBis             := '';
          case SysLocale.PriLangID of
            Lang_German: BtnDrucken.Caption := '&Speichern unter';
          else
            BtnDrucken.Caption := 'S&ave as';
          end;
        end;
    end;
    try
      IniFile := tIniFile.Create(IniName);
    except
      IniFile := Nil;
    end;
    if IniFile <> Nil then
      try
        Von.Text :=
          IniFile.ReadString(
            IniLayout + ' ' + LayoutComboBox.Text,
            FormularName(tFormular(Formular.ItemIndex), LANG_ENGLISH)
              + ' ' + IniFrom,
            DefaultVon);
        Bis.Text :=
          IniFile.ReadString(
            IniLayout + ' ' + LayoutComboBox.Text,
            FormularName(tFormular(Formular.ItemIndex), Lang_English)
              + ' ' + IniUntil,
            DefaultBis);
      finally
        IniFile.Free;
      end;
    KorrektVon;
    KorrektBis;
    Bis.Hint := Von.Hint;
    CheckLayoutButtons;
  end;

procedure TMainForm.FormCreate(Sender: TObject);
  var     nJahr,
          nMonat,
          nTag         : Word;
          i,
          PrinterLogX,
          PrinterLogY,
          PrinterResX,
          PrinterResY  : Integer;
          q, r, s      : String;
          Inifile      : tIniFile;
          error        : Boolean;
  begin
    Caption               := LinkName;
    Application.Title     := Caption;
    DaylightDate1         := 0;
    DoubleSummerDate      := 0;
    DaylightDate2         := 0;
    StandardDate          := 0;
    AuthorVal.Caption     := CopyrightName;
    Strasse.Caption       := CopyrightStrasse;
    Ort.Caption           := CopyrightOrt;
    TelefonRegion.Caption := CopyrightTelefonRegion;
    TelefonVal.Caption    := CopyrightTelefon;
    eMailVal.Caption      := CopyrighteMail;
    InternetVal.Caption   := CopyrightInternet;
    {$ifdef fpc}
      PrinterResX         := Printer.PageWidth;
      PrinterResY         := Printer.PageHeight;
      PrinterLogX         := Printer.XDPI;
      PrinterLogY         := Printer.YDPI;
    {$else}
      PrinterResX         := GetDeviceCaps(Printer.Handle, HorzRes);
      PrinterResY         := GetDeviceCaps(Printer.Handle, VertRes);
      PrinterLogX         := GetDeviceCaps(Printer.Handle, LogPixelsX);
      PrinterLogY         := GetDeviceCaps(Printer.Handle, LogPixelsY);
    {$endif}
    {$ifdef Unix}
      BtnLink.Visible := False;
    {$endif}
    if   (PrinterResX = 0) or (PrinterResY = 0)
      or (PrinterLogX = 0) or (PrinterLogY = 0)
    then
      begin
        case SysLocale.PriLangID of
          Lang_German : MsgBox('kann keinen Drucker finden', Caption, mb_IconHand);
        else
          MsgBox('cannot find a printer', Caption, mb_IconHand);
        end;
        Application.Terminate;
      end;
    try
      RichFormat          := tList.Create;
    except
      RichFormat          := Nil;
    end;
    if RichFormat = Nil then
      begin
        MsgBox('cannot create rich format', Caption, mb_IconHand);
        Application.Terminate;
      end;
    if   IntToDez(VersionJahr,  4, False)
       + IntToDez(VersionMonat, 2, False)
       + IntToDez(VersionTag,   2, False) > LizenzVersion then
      Lizenznehmer := '';
    Lizenznehmer   := '!';
    LabelLizenznehmer.Caption := Lizenznehmer;
    if Lizenznehmer = '' then
      begin
        LabelLizenznehmer.Font.Color := clBlue;
        LabelLizenznehmer.Cursor     := crHandPoint;
      end;
    Jahr.Min := MinYear;
    case SysLocale.PriLangID of
      Lang_German:
        begin
          i := MinYear;
          s := IntToStr(abs(i));
          if i < 0 then
            r := ' vor '
          else
            r := ' nach ';
          LabelBereich.Caption := CP1252toSystem(
            'Dieses Programm druckt Ihnen fr die Jahre ab ')
            + s + r + 'Christus einen Kalender aus.';
          LabelVersion.Caption :=
            '1980 bis ' + IntToStr(VersionTag)
            + '. ' + CP1252toSystem(GermanLongMonthNames[VersionMonat])
            + ' '  + IntToStr(VersionJahr);
          if LabelLizenznehmer.Caption = '' then
            LabelLizenznehmer.Caption := 'unlizensiert';
        end;
    else
      begin
        i := MinYear;
        s := IntToStr(abs(i));
        if i < 0 then
          r := ' before '
        else
          r := ' after ';
        LabelBereich.Caption :=
          'This program prints for you a calendar to the years beginning in '
          + s + r + 'Christ.';
        LabelVersion.Caption :=
          '1980 until ' + EnglishLongMonthNames[VersionMonat]
          + ' ' + Ordinal(VersionTag)
          + ' ' + IntToStr(VersionJahr);
        LabelMath.Caption    := 'The calculations are based on Jean Meeus: '
                                + 'Astronomical Formulae for Calculators.';
        LabelPhone.Caption                     := 'Phone / Answ. mach.';
        BtnPflege.Caption                      := 'Pro&gram maintained';
        BtnExport.Caption                      := 'E&xport';
        LabelBis.Caption                       := 'until';
        JahrBox.Caption                        := '&Year';
        LayoutGroupBox.Caption                 := '&Layout';
        BereichBox.Caption                     := '&Range';
        TerminBox.Caption                      := 'Date&s';
        FeiertageBox.Caption                   := 'Holi&days';
        IndividualHolidayBox.Caption           := 'Indi&vidual';
        AutoHolidayBox.Caption                 := 'A&utomatic';
        BtnNewDates.Caption                    := 'New';
        BtnCopyDates.Caption                   := 'Copy';
        BtnEditDates.Caption                   := 'Edit';
        BtnDelDates.Caption                    := 'Delete';
        BtnNewLayout.Caption                   := 'New';
        BtnCopyLayout.Caption                  := 'Copy';
        BtnEditLayout.Caption                  := 'Edit';
        BtnDelLayout.Caption                   := 'Delete';
        BtnNewUserHoliday.Caption              := 'New';
        BtnCopyUserHoliday.Caption             := 'Copy';
        BtnEditUserHoliday.Caption             := 'Edit';
        BtnDelHoliday.Caption                  := 'Delete';
        BtnNewAutoHoliday.Caption              := 'New';
        BtnCopyAutoHoliday.Caption             := 'Copy';
        BtnEditAutoHoliday.Caption             := 'Edit';
        Formular.Caption                       := 'Form';
        LabelLizenz.Caption                    := 'Licensed to';
        Formular.Items[ord(FormularEineSeite)] := '&Outline';
        Formular.Items[ord(FormularRingbuch)]  := 'Appointment boo&k';
        Formular.Items[ord(FormularMonat)]     := '&Monthly schedule';
        Formular.Items[ord(FormularBilder)]    := 'P&ictures';
        Formular.Items[ord(FormularDatei)]     := '&File';
        BtnLink.Caption                        := 'S&hortcuts';
        InternetVal.Hint                       := 'Check for an upgrade '
                                                  + 'and visit the web site';
        if LabelLizenznehmer.Caption = '' then
          LabelLizenznehmer.Caption := 'unlicensed';
      end;
    end;
    UpDownVon.Height := Jahr.Height;
    UpDownBis.Height := Jahr.Height;
    LoadFormFromIni(Self);
    DecodeDate(Date, nJahr, nMonat, nTag);
    Jahr.Position := nJahr;
    case SysLocale.PriLangID  of
      Lang_German: Standard := '(standard)';
    else
      Standard := '(default)';
    end;
    case SysLocale.PriLangID  of
      Lang_German: Keine := '(keine)';
    else
      Keine := '(none)';
    end;
    LayoutComboBox.Items.Add(Standard);
    FeiertageListe.Items.Add(Standard);
    TerminListe.Items.Add(Keine);
    LayoutComboBox.ItemIndex := 0;
    FeiertageListe.ItemIndex := 0;
    TerminListe.ItemIndex    := 0;
    error                    := False;
    try
      IniFile                := tIniFile.Create(IniName);
    except
      IniFile                := Nil;
    end;
    if IniFile = Nil then
      error := True
    else
      begin
        try
          Jahr.Position := IniFile.ReadInteger(Name, IniYear, Jahr.Position);
          Formular.ItemIndex := IniFile.ReadInteger(Name, IniForm, 0);
          i                  := 0;
          repeat
            s := IntToStr(i);
            q := IniFile.ReadString(IniLayouts, s, '');
            if q > '' then
              if LayoutComboBox.Items.IndexOf(q) = -1 then
                LayoutComboBox.Items.Add(q);
            inc(i);
          until q = '';
          LayoutComboBox.ItemIndex :=
            IniFile.ReadInteger(IniLayouts, IniActual,
                                LayoutComboBox.ItemIndex);
          i := 0;
          repeat
            s := IntToStr(i);
            q := IniFile.ReadString(IniDateLists, s, '');
            if q > '' then
              if TerminListe.Items.IndexOf(q) = -1 then
                TerminListe.Items.Add(q);
            inc(i);
          until q = '';
          TerminListe.ItemIndex :=
            IniFile.ReadInteger(IniDateLists, IniActual, TerminListe.ItemIndex);
          i := 0;
          repeat
            s := IntToStr(i);
            q := IniFile.ReadString(IniHolidayList, s, '');
            if q > '' then
              if FeiertageListe.Items.IndexOf(q) = -1 then
                FeiertageListe.Items.Add(q);
            inc(i);
          until q = '';
          FeiertageListe.ItemIndex :=
            IniFile.ReadInteger(IniHolidayList, IniActual,
                                FeiertageListe.ItemIndex);
        except
          error := True;
        end;
        IniFile.Free;
      end;
    if error then
      case SysLocale.PriLangID of
        Lang_German :
          MsgBox('kann ini Datei nicht lesen', Caption, mb_IconHand);
      else
        MsgBox('cannot read ini file', Caption, mb_IconHand);
      end;
    FormularClick(Sender);
    CheckLayoutButtons;
    CheckTerminListeButtons;
    CheckFeiertageButtons;
  end;

procedure TMainForm.BtnDelLayoutClick(Sender: TObject);
  var     IniFile : tIniFile;
          i       : Integer;
  begin
    case SysLocale.PriLangID of
      Lang_German:
        i := MsgBox('Sind Sie sicher?', CP1252ToSystem('Layout lschen'),
                    mb_OkCancel or mb_IconQuestion);
    else
      i := MsgBox('Are you sure?', 'Delete layout',
                  mb_OkCancel or mb_IconQuestion);
    end;
    if i = idOk Then
      begin
        try
          IniFile := tIniFile.Create(IniName);
        except
          IniFile := Nil;
        end;
        if IniFile <> Nil then
          try
            IniFile.EraseSection(IniLayout + ' ' + LayoutComboBox.Text);
          finally
            IniFile.Free;
          end;
        LayoutComboBox.Items.Delete(LayoutComboBox.ItemIndex);
        LayoutComboBox.ItemIndex := LayoutComboBox.Items.IndexOf(Standard);
        CheckLayoutButtons;
        SaveLayouts;
      end;
  end;

function CheckWoche(Woche : String; EmptyValid : Boolean; Jahr : Integer)
              : Boolean;
  var    w, e : Integer;
  begin
    if Woche = '' then
      CheckWoche := EmptyValid
    else
      begin
        val(Woche, w, e);
        if e = 0 then
          CheckWoche := (w >= FirstWeek(Jahr)) and (w <= LastWeek(Jahr))
        else
          CheckWoche := False;
      end;
  end;

procedure TMainForm.CheckFeiertageButtons;
  begin
    BtnDelHoliday.Enabled      := FeiertageListe.Text <> Standard;
    BtnEditUserHoliday.Enabled := BtnDelHoliday.enabled;
    BtnCopyUserHoliday.Enabled := BtnDelHoliday.enabled;
    BtnEditAutoHoliday.Enabled := BtnDelHoliday.enabled;
    BtnCopyAutoHoliday.Enabled := BtnDelHoliday.enabled;
  end;

procedure TMainForm.CheckLayoutButtons;
  var     iVon, iBis : Integer;
  begin
    case tFormular(Formular.ItemIndex) of
      FormularEineSeite:
        BtnDrucken.Enabled :=     (GetMonat(von.Text) > 0)
                              and (Jahr.Position <> 0);
      FormularMonat:
        begin
          iVon := GetMonat(von.Text);
          iBis := GetMonat(Bis.Text);
          BtnDrucken.Enabled :=     (iVon > 0)
                                and ((iBis = 0) or (iBis >= iVon))
                                and (Jahr.Position <> 0);
        end;
      FormularRingbuch:
        BtnDrucken.Enabled :=     CheckWoche(Von.Text, False, Jahr.Position)
                              and CheckWoche(Bis.Text, True,  Jahr.Position)
                              and (Jahr.Position <> 0);
      FormularBilder:
        BtnDrucken.Enabled :=     (GetMonat(von.Text) > 0)
                              and (Jahr.Position <> 0);
      FormularDatei:
        BtnDrucken.Enabled := Jahr.Position <> 0;
    end;
    BtnDelLayout.Enabled   :=  LayoutComboBox.Text <> Standard;
    BtnEditLayout.Enabled  := (LayoutComboBox.Text <> Standard)
                              and BtnDrucken.enabled;
    BtnCopyLayout.Enabled  := BtnEditLayout.enabled;
    if Lizenznehmer = '' then
      BtnDrucken.enabled := False;
    BtnExport.enabled := BtnDrucken.Enabled and
      (tFormular(Formular.ItemIndex) < FormularDatei);
  end;

procedure TMainForm.LayoutComboBoxChange(Sender: TObject);
  var     IniFile : tIniFile;
  begin
    try
      IniFile := tIniFile.Create(IniName);
    except
      IniFile := Nil;
    end;
    if IniFile <> Nil then
      try
        IniFile.WriteInteger(IniLayouts, IniActual, LayoutComboBox.ItemIndex);
      finally
        IniFile.Free;
      end;
    FormularClick(Sender);
  end;

procedure TMainForm.SaveLayouts;
  var     IniFile : tIniFile;
          i       : Integer;
          s       : String;
          error   : Boolean;
  begin
    error := False;
    try
      IniFile := tIniFile.Create(IniName);
    except
      IniFile := Nil;
    end;
    if IniFile = Nil then
      error := True
    else
      begin
        try
          IniFile.EraseSection(IniLayouts);
          for i := 0 to LayoutComboBox.Items.Count - 1 do
            begin
              s := IntToStr(i);
              IniFile.WriteString(IniLayouts, s, LayoutComboBox.Items[i]);
            end;
          i := LayoutComboBox.ItemIndex;
          if i < 0 then
            i := LayoutComboBox.Items.IndexOf(Standard);
          IniFile.WriteInteger(IniLayouts, IniActual, i);
        except
          error := True;
        end;
        IniFile.Free;
      end;
    if error then
      case SysLocale.PriLangID of
        Lang_German :
          MsgBox('kann Layouts nicht speichern', Caption, mb_IconHand);
      else
        MsgBox('cannot save layouts', Caption, mb_IconHand);
      end
  end;

procedure TMainForm.PaintPreview(Check : Boolean);
  begin
    If PreviewForm.Image = PreviewForm.Image1 then
      PreviewForm.Image := PreviewForm.Image2
    else
      PreviewForm.Image := PreviewForm.Image1;
    PreviewForm.Image.Height  := PreviewForm.ClientHeight;
    PreviewForm.Image.Width   := PreviewForm.ClientWidth;
    PreviewForm.Image.Picture.Bitmap.Height := PreviewForm.ClientHeight;
    PreviewForm.Image.Picture.Bitmap.Width  := PreviewForm.ClientWidth;
    ClearPreview;
    Status  := Ok;
    CanvasX := (LayoutForm.PrinterLogX * LongInt(PreviewForm.ClientWidth ))
               div LayoutForm.PrinterResX;
    CanvasY := (LayoutForm.PrinterLogY * LongInt(PreviewForm.ClientHeight))
               div LayoutForm.PrinterResY;
    case tFormular(Formular.ItemIndex) of
      FormularEineSeite:
        PreviewEineSeite;
      FormularRingbuch:
        PreviewRingbuch;
      FormularMonat:
        PreviewMonatsplaner;
      FormularBilder:
        PreviewBilder;
    end;
    If PreviewForm.Image = PreviewForm.Image1 then
      PreviewForm.Image2.Visible := False
    else
      PreviewForm.Image1.Visible := False;
    PreviewForm.Image.Visible := True;
    if Check then
      StatusCheck;
  end;

procedure TMainForm.ShowLayout;
  var     OldOrientation : tPrinterOrientation;
  begin
    EnableAll(False);
    OldOrientation := Printer.Orientation;
    TerminListeLoad;
    UserHolidaysLoad;
    AutoHolidaysLoad;
    PaintPreview(True);
    PreviewForm.Show;
    LayoutForm.Show;
    Printer.Orientation := OldOrientation;
  end;

procedure TMainForm.BtnNewLayoutClick(Sender: TObject);
  begin
    LayoutForm.Layout.Text := '';
    LayoutForm.Load;
    ShowLayout;
  end;

procedure TMainForm.BtnEditLayoutClick(Sender: TObject);
  begin
    Layoutload;
    ShowLayout;
  end;

procedure TMainForm.BtnNewDatesClick(Sender: TObject);
  begin
    DatesForm.Liste.Text := '';
    DatesForm.Load;
    if DatesForm.ShowModal = mrOK Then
      begin
        TerminListe.ItemIndex :=
          TerminListe.Items.Add(DatesForm.Liste.Text);
        CheckTerminListeButtons;
        SaveTerminListen;
      end;
  end;

procedure TMainForm.SaveTerminListen;
  var     IniFile : tIniFile;
          i       : Integer;
          s       : String;
          error   : Boolean;
  begin
    error := False;
    try
      IniFile := tIniFile.Create(IniName);
    except
      IniFile := Nil;
    end;
    if IniFile = Nil then
      error := True
    else
      begin
        try
          IniFile.EraseSection(IniDateLists);
          for i := 0 to TerminListe.Items.Count - 1 do
            begin
              s := IntToStr(i);
              IniFile.WriteString(IniDateLists, s, TerminListe.Items[i]);
            end;
          i := TerminListe.ItemIndex;
          if i < 0 then
            i := TerminListe.Items.IndexOf(Keine);
          IniFile.WriteInteger(IniDateLists, IniActual, i);
        except
          error := True;
        end;
        IniFile.Free;
      end;
    if Error then
      case SysLocale.PriLangID of
        Lang_German :
          MsgBox('kann Terminlisten nicht speichern', Caption, mb_IconHand);
      else
        MsgBox('cannot save date lists', Caption, mb_IconHand);
      end
  end;

procedure TMainForm.SaveFeiertageListe;
  var     IniFile : tIniFile;
          i       : Integer;
          s       : String;
          error   : Boolean;
  begin
    error := False;
    try
      IniFile := tIniFile.Create(IniName);
    except
      IniFile := Nil;
    end;
    if IniFile = Nil then
      error := True
    else
      begin
        try
          IniFile.EraseSection(IniHolidayList);
          for i := 0 to FeiertageListe.Items.Count - 1 do
            begin
              s := IntToStr(i);
              IniFile.WriteString(IniHolidayList, s, FeiertageListe.Items[i]);
            end;
          i := FeiertageListe.ItemIndex;
          if i < 0 then
            i := FeiertageListe.Items.IndexOf(Keine);
          IniFile.WriteInteger(IniHolidayList, IniActual, i);
        except
          error := True;
        end;
        IniFile.Free;
      end;
    if error then
      case SysLocale.PriLangID of
        Lang_German :
          MsgBox('kann Feiertagelisten nicht speichern', Caption, mb_IconHand);
      else
        MsgBox('cannot save holiday lists', Caption, mb_IconHand);
      end;
  end;

procedure TMainForm.BtnEditDatesClick(Sender: TObject);
  begin
    TerminListeLoad;
    DatesForm.ShowModal;
  end;

procedure TMainForm.BtnDelDatesClick(Sender: TObject);
  var     IniFile : tIniFile;
          i       : Integer;
  begin
    case SysLocale.PriLangID of
      Lang_German:
        i := MsgBox('Sind Sie sicher?', CP1252ToSystem('Terminliste lschen'),
                    mb_OkCancel or mb_IconQuestion);
    else
      i := MsgBox('Are you sure?', 'Delete date list',
                  mb_OkCancel or mb_IconQuestion);
    end;
    if i = idOk Then
      begin
        try
          IniFile := tIniFile.Create(IniName);
        except
          IniFile := Nil;
        end;
        if IniFile <> Nil then
          try
            IniFile.EraseSection(IniList + ' ' + TerminListe.Text);
          finally
            IniFile.Free;
          end;
        i := TerminListe.ItemIndex;
        TerminListe.ItemIndex := TerminListe.Items.IndexOf(Keine);
        TerminListe.Items.Delete(i);
        CheckTerminListeButtons;
        SaveTerminListen;
      end;
  end;

procedure TMainForm.CheckTerminListeButtons;
  begin
    BtnDelDates.Enabled  := TerminListe.Text <> Keine;
    BtnEditDates.Enabled := BtnDelDates.Enabled;
    BtnCopyDates.Enabled := BtnEditDates.Enabled;
  end;

procedure TMainForm.TerminListeLoad;
  begin
    if TerminListe.Text = Keine Then
      DatesForm.Liste.Text := ''
    else
      DatesForm.Liste.Text := TerminListe.Text;
    DatesForm.Load;
  end;

procedure TMainForm.TerminListeChange(Sender: TObject);
  var     IniFile : tIniFile;
  begin
    CheckTerminListeButtons;
    try
      IniFile := tIniFile.Create(IniName);
    except
      IniFile := Nil;
    end;
    if IniFile <> Nil then
      try
        IniFile.WriteInteger(IniDateLists, IniActual, TerminListe.ItemIndex);
      finally
        IniFile.Free;
      end;
  end;

procedure TMainForm.BtnCopyDatesClick(Sender: TObject);
  begin
    TerminListeLoad;
    DatesForm.Liste.Text     := '';
    DatesForm.Liste.Color    := clWindow;
    DatesForm.Liste.ReadOnly := False;
    DatesForm.Liste.Tabstop  := True;
    if DatesForm.ShowModal = mrOK Then
      begin
        TerminListe.ItemIndex :=
          TerminListe.Items.Add(DatesForm.Liste.Text);
        SaveTerminListen;
      end;
  end;

procedure TMainForm.FormClose(Sender: TObject;
                              var CloseAction: TCloseAction);
  begin
    if CloseAction = caFree then;
    SaveFormToIni(Self);
  end;

procedure TMainForm.VonChange(Sender: TObject);
  var     IniFile : tIniFile;
  begin
    if LayoutComboBox.Text <> Standard then
      begin
        try
          IniFile := tIniFile.Create(IniName);
        except
          IniFile := Nil;
        end;
        if IniFile <> Nil then
          try
            IniFile.WriteString(
              IniLayout + ' ' + LayoutComboBox.Text,
              FormularName(tFormular(Formular.ItemIndex),
                           Lang_English) + ' ' + IniFrom,
              Von.Text);
          finally
            IniFile.Free;
          end;
      end;
    CheckLayoutButtons;
  end;

procedure TMainForm.BisChange(Sender: TObject);
  var     IniFile : tIniFile;
  begin
    if LayoutComboBox.Text <> Standard then
      begin
        try
          IniFile := tIniFile.Create(IniName);
        except
          IniFile := Nil;
        end;
        if IniFile <> Nil then
          try
            IniFile.WriteString(
              IniLayout + ' ' + LayoutComboBox.Text,
              FormularName(tFormular(Formular.ItemIndex), Lang_English)
              + ' ' + IniUntil,
              Bis.Text);
          finally
            IniFile.Free;
          end;
      end;
    CheckLayoutButtons;
  end;

procedure TMainForm.DownClick(Edit : TEdit);
  var     i, e : Integer;
          s    : String;
  begin
    case tFormular(Formular.ItemIndex) of
      FormularBilder,
      FormularEineSeite,
      FormularMonat:
        begin
          i := GetMonat(Edit.Text);
          if i > 1 then
            Edit.Text := GetLongMonthName(i - 1)
          else
            Edit.Text := GetLongMonthName(12);
        end;
      FormularRingbuch:
        begin
          Val(Edit.Text, i, e);
          if e = 0 then
            begin
              dec(i);
              s := IntToStr(i);
              Edit.Text := s;
            end
          else
            Edit.Text := '53';
        end;
    end;
    if Edit = Von then
      KorrektVon
    else
      KorrektBis;
  end;

procedure TMainForm.UpClick(Edit: TEdit);
  var     i, e : Integer;
          s    : String;
  begin
    case tFormular(Formular.ItemIndex) of
      FormularBilder,
      FormularEineSeite,
      FormularMonat:
        begin
          i := GetMonat(Edit.Text);
          if (0 < i) and (i < 12) then
            Edit.Text := GetLongMonthName(i + 1)
          else
            Edit.Text := GetLongMonthName(1);
        end;
      FormularRingbuch:
        begin
          Val(Edit.Text, i, e);
          if e = 0 then
            begin
              inc(i);
              s := IntToStr(i);
              Edit.Text := s;
            end
          else
            Edit.Text := '1';
        end;
    end;
    if Edit = Von then
      KorrektVon
    else
      KorrektBis;
  end;

procedure TMainForm.KorrektVon;
  var     i, e    : Integer;
          s       : String;
          j, m, t : Word;
          jd      : tJulianDay;
  begin
    DecodeDate(Date, j, m, t);
    case tFormular(Formular.ItemIndex) of
      FormularEineSeite:
        if GetMonat(Von.Text) < 1 then
          Von.Text := GetLongMonthName(1);
      FormularRingbuch:
        begin
          Val(Von.Text, i, e);
          if e <> 0 then
            begin
              if Integer(j) = Jahr.Position then
                begin
                  jd := LocalJulianDay(j, m, t + 0.5);
                  i  := trunc(jd - Week0(j)) div 7;
                end
              else
                i := FirstWeek(Jahr.Position);
            end
          else
            if i < FirstWeek(Jahr.Position) then
              i := FirstWeek(Jahr.Position)
            else
              if i > LastWeek(Jahr.Position) then
                i := LastWeek(Jahr.Position);
          s := IntToStr(i);
          Von.Text := s;
        end;
      FormularBilder,
      FormularMonat:
        if GetMonat(Von.Text) < 1 then
          if Integer(j) = Jahr.Position then
            Von.Text := GetLongMonthName(m)
          else
            Von.Text := GetLongMonthName(1);
    end;
  end;

procedure TMainForm.KorrektBis;
  var     i, e : Integer;
          s    : String;
  begin
    case tFormular(Formular.ItemIndex) of
      FormularEineSeite:
        if GetMonat(Bis.Text) < 1 then
          Bis.Text := GetLongMonthName(12);
      FormularRingbuch:
        if Bis.Text > '' then
          begin
            Val(Bis.Text, i, e);
            if e <> 0 then
              i := LastWeek(Jahr.Position)
            else
              if i < FirstWeek(Jahr.Position) then
                i := FirstWeek(Jahr.Position)
              else
                if i > LastWeek(Jahr.Position) then
                  i := LastWeek(Jahr.Position);
            s := IntToStr(i);
            Bis.Text := s;
          end;
      FormularBilder,
      FormularMonat:
        if Bis.Text > '' then
          if GetMonat(Bis.Text) < 1 then
            Bis.Text := GetLongMonthName(12);
    end;
  end;

procedure TMainForm.JahrChange(Sender: TObject);
  Var     IniFile : tIniFile;
  begin
    BtnNewLayout.enabled := Jahr.Position <> 0;
    if Jahr.Position <> 0 then
      Jahr.Hint := ''
    else
      case SysLocale.PriLangID of
        Lang_German:
          Jahr.Hint := '0 existiert nicht';
      else
        Jahr.Hint := '0 does not exist';
      end;
    JahrEdit.Hint         := Jahr.Hint;
    BtnDrucken.enabled    := BtnNewLayout.enabled and (Lizenznehmer > '');
    BtnEditLayout.enabled := BtnNewLayout.enabled
                             and (LayoutComboBox.Text <> Standard);
    BtnCopyLayout.enabled := BtnEditLayout.enabled;
    BtnExport.enabled := BtnDrucken.Enabled and
      (tFormular(Formular.ItemIndex) < FormularDatei);
    if BtnNewLayout.enabled then
      begin
        try
          IniFile := tIniFile.Create(IniName);
        except
          IniFile := Nil;
        end;
        if IniFile <> Nil then
          try
            IniFile.WriteInteger(Name, IniYear, Jahr.Position);
          finally
            IniFile.Free;
          end;
      end;
    KorrektVon;
    KorrektBis;
  end;

procedure TMainForm.BtnPflegeClick(Sender: TObject);
  begin
    MaintainForm.ShowModal;
  end;

procedure TMainForm.PreviewBilder;
  begin
    FormBreite := PreviewForm.ClientWidth;
    FormHoehe  := PreviewForm.ClientHeight;
    PrepareBilder(PreviewForm.Image.Picture.Bitmap.Canvas);
    PaintBilder(LayoutForm.Pictures.Row, PreviewForm.Image.Picture.Bitmap.Canvas);
  end;

procedure TMainForm.BmpBilder(Bitmap : tBitmap);
  var     i,
          iVon,
          iBis,
          YesNo : Integer;
          s, t  : String;
  begin
    iVon  := GetMonat(Von.Text);
    iBis  := GetMonat(Bis.Text);
    YesNo := mrNo;
    if iBis = 0 then
      iBis := iVon;
    if iBis < iVon then
      begin
        i    := iBis;
        iBis := iVon;
        iVon := i;
      end;
    PrepareBilder(Bitmap.Canvas);
    i := iVon;
    while i <= iBis do
      begin
        Bitmap.Canvas.Brush.Color := clWhite;
        Bitmap.Canvas.Brush.Style := bsSolid;
        Bitmap.Canvas.FillRect(Rect(0, 0, Bitmap.Width, Bitmap.Height));
        PaintBilder(i, Bitmap.Canvas);
        if Status <> OK then
          i := iBis + 1
        else
          begin
            s := SavePictureDialog.FileName;
            if iBis <> iVon then
              begin
                t := ExtractFileExt(s);
                s := Copy(s, 1, length(s) - length(t))
                       + ' ' + GetShortMonthName(i) + t;
              end;
            SaveBMP(Bitmap, s, YesNo);
            inc(i);
          end;
      end;
  end;

procedure TMainForm.EmfBilder;
  {$ifndef fpc}
    var   i,
          iVon, iBis,
          YesNo          : Integer;
          s, t           : String;
          MetaFile       : tMetaFile;
          MetaFileCanvas : tMetaFileCanvas;
  {$endif}
  begin
    {$ifndef fpc}
      iVon  := GetMonat(Von.Text);
      iBis  := GetMonat(Bis.Text);
      YesNo := mrNo;
      if iBis = 0 then
        iBis := iVon;
      if iBis < iVon then
        begin
          i    := iBis;
          iBis := iVon;
          iVon := i;
        end;
      i := iVon;
      while i <= iBis do
        begin
          case SysLocale.PriLangID of
            Lang_German:
              begin
                s := 'Bildkalender ' + GetLongMonthName(i);
                CreateMetaFile(s, MetaFile, MetaFileCanvas);
                if MetaFile = Nil then
                  MsgBox(CP1252ToSystem('kann Metafile fr ') + s
                         + ' nicht erzeugen', Caption, mb_IconHand);
              end;
          else
            s := 'picture calendar ' + GetLongMonthName(i);
            CreateMetaFile(s, MetaFile, MetaFileCanvas);
            if MetaFile = Nil then
              MsgBox('cannot create metafile of ' + s,
                     Caption, mb_IconHand);
          end;
          if MetaFile = Nil then
            i := iBis
          else
            begin
              PrepareBilder(MetafileCanvas);
              PaintBilder(i, MetafileCanvas);
              s := SavePictureDialog.FileName;
              if iBis <> iVon then
                begin
                  t := ExtractFileExt(s);
                  s := Copy(s, 1, length(s) - length(t))
                       + ' ' + GetShortMonthName(i) + t;
                end;
              MetaFileCanvas.Free;
              SaveEmf(Metafile, s, YesNo);
              MetaFile.Free;
            end;
          inc(i);
        end;
    {$endif}
  end;

procedure TMainForm.PrintBilder;
  var     k, m, r,
          iVon,
          iBis,
          Copies   : Integer;
  begin
    FormBreite := LayoutForm.PrinterResX;
    FormHoehe  := LayoutForm.PrinterResY;
    iVon       := GetMonat(Von.Text);
    iBis       := GetMonat(Bis.Text);
    if iBis = 0 then
      iBis := iVon;
    if iBis > iVon then
      r := 1
    else
      r := -1;
    Copies             := PrintDialog.Copies;
    PrintDialog.Copies := 1;
    k                  := 0;
    while k < Copies do
      begin
        inc(k);
        m := iVon;
        repeat
          case SysLocale.PriLangID of
            Lang_German:
              Printer.Title := 'Kalender ' + YearText(Jahr.Position) + ' '
                               + FormularName(tFormular(Formular.ItemIndex),
                                              SysLocale.PriLangID) + ' '
                               + GetLongMonthName(m);
          else
            Printer.Title := 'Calendar ' + YearText(Jahr.Position) + ' '
                             + FormularName(tFormular(Formular.ItemIndex),
                                            SysLocale.PriLangID) + ' '
                             + GetLongMonthName(m);
          end;
          Printer.BeginDoc;
          if (k = 1) and (m = iVon) then
            PrepareBilder(Printer.Canvas);
          PaintBilder(m, Printer.Canvas);
          if (Status = PicNotFound) or
             ((Status = FontZuHoch) or (Status = FontZuBreit))
             and (LayoutForm.CheckSizes.Checked)
          then
            begin
              Printer.Abort;
              k := Copies;
              m := iBis;
            end
          else
            Printer.Enddoc;
          inc(m, r);
        until m = iBis + r;
      end;
  end;

procedure TMainForm.PaintBilder(Monat : Word; c : tCanvas);
  var     Day      : Double;
          i, j     : Integer;
          Zeilen,
          m, h, b  : Word;
          Datum    : tJulianDay;
          r        : Real;
          s, t,
          u, p     : String;
          Picture  : tPicture;
          DateList : tDateList;
          l        : tStringList;
  begin
    Val(LayoutForm.MarginBottom.Text, r, j);
    yEnde := FormHoehe - MMtoPixel(r, CanvasY);
    PaintBkgnd(c, 0, 0, FormBreite, FormHoehe);
    c.Font.Size   := (LayoutForm.FontData[eFeiertagListe, False].Size
                      * longint(CanvasY)) div c.Font.PixelsPerInch;
    c.Font.Color  := LayoutForm.FontData[eFeiertagListe, False].Color;
    c.Font.Style  := LayoutForm.FontData[eFeiertagListe, False].Style;
    c.Brush.style := bsClear;
    h := (FeiertagHoehe * LongInt(CanvasY)) div LayoutForm.PrinterLogY;
    try
      DateList := tDateList.Create;
    except
      DateList := Nil;
    end;
    if DateList = Nil then
      MsgBox('cannot create date list', Caption, mb_IconHand)
    else
      try
        Day   := 1.5;
        Datum := LocalJulianDay(Jahr.Position, Monat, Day);
        Repeat
          p := '';
          CalPrintHoliday(Datum, p);
          while p > '' do
            begin
              j := Pos(A_LF, p);
              if j = 0 Then
                j := length(p) + 1;
              t := Copy(p, 1, j - 1);
              p := Copy(p, j + 1, length(p));
              DateList.Add(Datum, t);
            end;
          p := DatesForm.IsTermin(Trunc(Day), Monat, Jahr.Position);
          while p > '' do
            begin
              j := Pos(A_LF, p);
              if j = 0 Then
                j := length(p) + 1;
              u := '';
              t := CalcTermin(Copy(p, 1, j - 1), Jahr.Position, u);
              p := Copy(p, j + 1, length(p));
              if t > '' then
                DateList.Add(Datum, t);
            end;
          Datum := Datum + 1;
          m     := 0;
          LocalJulianDate(Datum, j, m, Day);
        until m <> Monat;
        DateList.Sort(0, DateList.Dates.Count - 1);
        b := WochenBreite + PunktWeite + c.TextWidth('#')
             + DateList.GetWidth(c) + c.TextWidth('##');
        Val(LayoutForm.MarginRight.Text, r, j);
        Spalten := (FormBreite - Textrand - MMtoPixel(r, CanvasX)
                    + c.TextWidth('##')) div b;
        if Spalten < 1 then
          Status := FontZuBreit
        else
          begin
            Zeilen := (DateList.Dates.Count + Spalten - 1) div Spalten;
            Dec(yEnde, Zeilen * h);
            for i := 0 to DateList.Dates.Count - 1 do
              begin
                LocalJulianDate(pJulDate(DateList.Dates.Items[i])^.jDay,
                                         j, m, Day);
                s := IntToStr(trunc(Day));
                TextOutRight(TextRand + (i div Zeilen) * b
                             + WochenBreite + PunktWeite,
                             yEnde + (i mod Zeilen) * h,
                             s + '.', c);
                c.TextOut(TextRand + (i div Zeilen) * b
                          + WochenBreite + PunktWeite
                          + c.TextWidth('#'),
                          yEnde + (i mod Zeilen) * h,
                          pJulDate(DateList.Dates.Items[i])^.DateName);
              end;
          end;
      finally
        DateList.Free;
      end;
    If Monat = 12 then
      Datum := LocalJulianDay(Jahr.Position + 1, 1, 1.5) - 1
    else
      Datum := LocalJulianDay(Jahr.Position, Monat + 1, 1.5) - 1;
    j := (yEnde * LongInt(LayoutForm.PrinterLogY)) div CanvasY
         - (trunc(Datum - Week0(Jahr.Position)) div 7
            - trunc(LocalJulianDay(Jahr.Position, Monat, 1.5)
            - Week0(Jahr.Position)) div 7
            + 4) * TextHoehe;
    BlockMonat(Monat, TextRand, j, c);
    j := ((j - TextHoehe) * LongInt(CanvasY)) div LayoutForm.PrinterLogY;
    Val(LayoutForm.MarginRight.Text, r, yEnde);
    m := FormBreite - TextRand - MMtoPixel(r, CanvasX);
    Val(LayoutForm.MarginTop.Text, r, yEnde);
    yEnde := MMtoPixel(r, CanvasY);
    if yEnde >= j then
      Status := FontZuHoch
    else
      begin
        t := Trim(LayoutForm.Pictures.Cells[2, Monat]);
        if t > '' then
          begin
            try
              l := tStringList.Create;
            except
              l := Nil;
            end;
            if l = Nil then
              MsgBox('cannot create string list', Caption, mb_IconHand)
            else
              try
                c.Font.Size   :=
                  (LayoutForm.FontData[eFeiertagListe, False].Size
                   * longint(CanvasY)) div c.Font.PixelsPerInch;
                c.Font.Color  :=
                  LayoutForm.FontData[eFeiertagListe, False].Color;
                c.Font.Style  :=
                  LayoutForm.FontData[eFeiertagListe, False].Style;
                c.Brush.style := bsClear;
                while t > '' do
                  begin
                    SplitText(t, s, m, c, False);
                    l.Add(s);
                  end;
                Dec(j, (l.count + 1) * h);
                if j <= yEnde then
                  Status := ZuvielText
                else
                  for i := 0 to l.Count - 1 do
                    begin
                      inc(j, h);
                      c.TextOut(TextRand, j, l[i]);
                    end;
                Dec(j, l.count * h);
              finally
                l.Free;
              end;
          end;
        Dec(j, yEnde);
        if LayoutForm.Bilder[Monat] > '' then
          begin
            try
              Picture := tPicture.Create;
            except
              Picture := Nil;
            end;
            if Picture <> Nil then
              try
                Picture.LoadFromFile(LayoutForm.Bilder[Monat]);
              except
                Picture.Free;
                Picture := Nil;
              end;
            if Picture = Nil then
              begin
                case SysLocale.PriLangID of
                  Lang_German:
                    MsgBox(LayoutForm.Bilder[Monat] + ' nicht gefunden',
                           Caption, mb_IconHand);
                else
                  MsgBox(LayoutForm.Bilder[Monat] + ' not found', Caption,
                         mb_IconHand);
                end;
                Status := PicNotFound;
                c.Rectangle(0, yEnde, FormBreite - 1, yEnde + j);
                c.MoveTo(0,              yEnde);
                c.LineTo(FormBreite - 1, yEnde + j);
                c.MoveTo(0,              yEnde + j);
                c.LineTo(FormBreite - 1, yEnde);
              end
            else
              begin
                if   longint(Picture.Graphic.Width)  * j
                   > longint(Picture.Graphic.Height) * FormBreite
                then
                  c.StretchDraw(
                    Rect(0,
                         yEnde + (j - (FormBreite * longint(Picture.Graphic.Height))
                                      div Picture.Graphic.Width) div 2,
                         FormBreite,
                         yEnde + (j + (FormBreite * longint(Picture.Graphic.Height))
                                      div Picture.Graphic.Width) div 2),
                    Picture.Graphic)
                else
                  c.StretchDraw(
                    Rect((FormBreite - (j * longint(Picture.Graphic.Width))
                                        div Picture.Graphic.Height) div 2,
                         yEnde,
                         (FormBreite + (j * longint(Picture.Graphic.Width))
                                        div Picture.Graphic.Height) div 2,
                         yEnde + j),
                    Picture.Graphic);
                Picture.Free;
              end;
          end;
      end;
  end;

procedure TMainForm.PrepareBilder(c: tCanvas);
  var     i, j : Integer;
          r    : Real;
  begin
    c.Font.Name    := LayoutForm.FontData[eArbeitsTag, False].Name;
    c.Font.CharSet := LayoutForm.FontData[eArbeitsTag, False].CharSet;
    c.Font.Size    := (LayoutForm.FontData[eArbeitsTag, False].Size
                       * longint(CanvasY)) div c.Font.PixelsPerInch;
    ZahlWeite      := GetTagWeite(c);
    c.Font.Size    := (LayoutForm.FontData[eFeiertagListe, False].Size
                       * longint(CanvasY)) div c.Font.PixelsPerInch;
    PunktWeite     := c.TextWidth('.');
    Val(LayoutForm.MarginLeft.Text, r, j);
    j := j;
    TextRand := MMtoPixel(r, CanvasX);
    Val(LayoutForm.MarginRight.Text, r, j);
    i        := MMtoPixel(r, CanvasX);
    if LayoutForm.Weeks.checked then
      begin
        WochenBreite := GetWochenBreite(c);
        DayGap       := (FormBreite - TextRand - i
                         - WochenBreite - 7 * ZahlWeite
                        ) div 7;
      end
    else
      begin
        WochenBreite := ZahlWeite;
        DayGap       := (FormBreite - TextRand - i - 7 * ZahlWeite) div 6;
      end;
    if DayGap < PunktWeite then
      Status := FontZuBreit;
    c.Font.Size   := (LayoutForm.FontData[eArbeitsTag, False].Size
                      * longint(LayoutForm.PrinterLogY))
                     div c.Font.PixelsPerInch;
    TextHoehe     := GetTextHoehe(c);
    c.Font.Size   := (LayoutForm.FontData[eFeiertagListe, False].Size
                      * longint(LayoutForm.PrinterLogY))
                     div c.Font.PixelsPerInch;
    FeiertagHoehe := GetTextHoehe(c);
  end;

procedure TMainForm.eMailValClick(Sender: TObject);
  begin
    {$ifdef fpc}
      {$ifdef Unix}
        fpSystem('xdg-email --subject "Unix ' + CalPrint + '" mailto:'
                 + (Sender as tLabel).Caption);
      {$else}
        OpenURL('mailto:' + (Sender as tLabel).Caption
               + ' ? subject=Lazarus%20' + CalPrint);
      {$endif}
    {$else}
      Exec(Handle, 'mailto:' + (Sender as tLabel).Caption
                   + ' ? subject=Delphi%20' + CalPrint, '', sw_ShowNormal);
    {$endif} 
  end;

procedure TMainForm.InternetValClick(Sender: TObject);
  var     b, ok : Boolean;
          s     : String;
  begin
    Screen.Cursor := crHourGlass;
    {$ifdef Unix}
      s           := CalPrint;
    {$else}
      s           := CalPrint + '.exe';
    {$endif}
    b             := False;
    ok            := InetUpdate(s, VersionJahr, VersionMonat, VersionTag, b);
    Screen.Cursor := crDefault;
    if ok then
      if b then
        case SysLocale.PriLangID of
          Lang_German :
            b := MsgBox('Es gibt eine neue Version von ' + Caption + '! '
                        + CP1252ToSystem('Mchten Sie diese jetzt laden?'),
                        Caption, mb_YesNo) = idYes;
        else
          b := MsgBox('There is a new release of ' + Caption + '! '
                      + 'Would you like to download it now?',
                      Caption, mb_YesNo) = idYes;
        end
      else
        case SysLocale.PriLangID of
          Lang_German :
            MsgBox(Caption + ' ist auf dem neuesten Stand.', Caption, mb_Ok);
        else
          MsgBox(Caption + ' is the latest release.', Caption, mb_Ok);
        end
    else
      case SysLocale.PriLangID of
        Lang_German :
          MsgBox('Konnte die Version von ' + Caption
                 + CP1252ToSystem(' nicht prfen.'),
                 Caption, mb_Ok);
      else
        MsgBox('Could not check the release of ' + Caption + '.',
               Caption, mb_Ok);
      end;
    Screen.Cursor := crHourGlass;
    {$ifdef fpc}
      if b then
        OpenUrl(s)
      else
        OpenUrl((Sender as tLabel).Caption);
    {$else}
      if b then
        Exec(Handle, s, '', sw_ShowNormal)
      else
        Exec(Handle, (Sender as tLabel).Caption, '', sw_ShowNormal);
    {$endif}
    Screen.Cursor := crDefault;
  end;

procedure TMainForm.BtnLinkClick(Sender: TObject);
  begin
    {$ifndef unix}
      LinkForm.ShowModal;
    {$endif}
  end;

function TMainForm.GetWochenBreite(c: tCanvas): Word;
  var    b1, b2 : Integer;
  begin
    b1 := c.TextWidth('##');
    b2 := c.TextWidth(ShortWeekName);
    if b1 > b2 then
      GetWochenBreite := b1
    else
      GetWochenBreite := b2;
  end;

function TMainForm.GetTagWeite(c: tCanvas): Word;
  var    i, b, w : Integer;
  begin
    w := c.TextWidth('##');
    for i := Sunday to Saturday do
      begin
        b := c.TextWidth(Copy(GetShortDayName(i), 1, 2));
        if b > w then
          w := b;
      end;
    GetTagWeite := w;
  end;

function SaveFilter(EmfFile, WmfFile, Bild : String) : String;
  var    i : tPicIndex;
         s : String;
  begin
    s := '';
    for i := low(tPicIndex) to High(tPicIndex) do
      case i of
        PicIndexJpg :
            s := s + Trenn
                   + UpperCase(ExtGraphicExtension(tJpegImage, 1))
                   + Bild
                   + LowerCase(ExtGraphicExtension(tJpegImage, 1));
        PicIndexBmp :
            s := s + Trenn + UpperCase(ExtGraphicExtension(tBitmap, 1))
                   + Bild
                   + LowerCase(ExtGraphicExtension(tBitmap, 1));
        {$ifdef fpc}
          PicIndexPng :
            s := s + Trenn
                   + UpperCase(ExtGraphicExtension(tPortableNetworkGraphic, 1))
                   + Bild
                   + LowerCase(ExtGraphicExtension(tPortableNetworkGraphic, 1));
        {$else}
          PicIndexGif :
            s := s + Trenn
                   + UpperCase(ExtGraphicExtension(tGifImage, 1))
                   + Bild
                   + LowerCase(ExtGraphicExtension(tGifImage, 1));
          PicIndexEmf :
            s := s + Trenn
                   + EmfFile + Trenn + Stern
                   + LowerCase(ExtGraphicExtension(tMetaFile, 1));
          PicIndexWmf :
            s := s + Trenn + WmfFile + Trenn + Stern
                   + LowerCase(ExtGraphicExtension(tMetaFile, 2));
        {$endif}
        {$ifdef DelphiPng}
          PicIndexPng :
            s := s + Trenn
                   + UpperCase(ExtGraphicExtension(tPngObject, 1))
                   + Bild
                   + LowerCase(ExtGraphicExtension(tPngObject, 1));
        {$endif}
      end;
    {$ifdef fpc}
      if EmfFile = '' then;
      if WmfFile = '' then;
    {$endif}
    SaveFilter := Copy(s, 2, length(s));
  end;

procedure TMainForm.BtnExportClick(Sender: TObject);
  var     h, w           : Real;
          e              : Integer;
          s              : String;
          Bitmap         : tBitmap;
          OldOrientation : tPrinterOrientation;
          IniFile        : tIniFile;
  begin
    EnableAll(False);
    case SysLocale.PriLangID of
      Lang_German:
        SavePictureDialog.Filter :=
          SaveFilter('Erweiterter Metafile', 'Metafile', Bild);
    else
      SavePictureDialog.Filter :=
        SaveFilter('Enhanced Metafile', 'Metafile', Picture);
    end;
    IniFile := tIniFile.Create(IniName);
    if IniFile <> Nil then
      begin
        SavePictureDialog.FilterIndex := IniFile.ReadInteger(
          IniFileTypes, IniGraphicExport, 0);
        IniFile.Free;
      end;
    SavePictureDialog.FileName := YearText(Jahr.Position);
    if SavePictureDialog.execute then
      begin
        IniFile := tIniFile.Create(IniName);
        if IniFile <> Nil then
          begin
            IniFile.WriteInteger(
              IniFileTypes, IniGraphicExport, SavePictureDialog.FilterIndex);
            IniFile.Free;
          end;
        s := ExtractFileExt(SavePictureDialog.FileName);
        s := Copy(SavePictureDialog.FileName, 1,
                  length(SavePictureDialog.FileName) - length(s));
        case tPicIndex(SavePictureDialog.FilterIndex - 1) of
          PicIndexBmp :
              SavePictureDialog.FileName := s + '.'
                + ExtGraphicExtension(tBitmap, 1);
          PicIndexJpg :
              SavePictureDialog.FileName := s + '.'
                + ExtGraphicExtension(tJpegImage, 1);
          {$ifdef fpc}
            PicIndexPng :
              SavePictureDialog.FileName := s + '.'
                + ExtGraphicExtension(tPortableNetworkGraphic, 1);
          {$else}
            PicIndexGif :
              SavePictureDialog.FileName := s + '.'
                + ExtGraphicExtension(tGifImage, 1);
            PicIndexEmf :
              SavePictureDialog.FileName := s + '.'
                + ExtGraphicExtension(tMetafile, 1);
            PicIndexWmf :
              SavePictureDialog.FileName := s + '.'
                + ExtGraphicExtension(tMetafile, 2);
          {$endif}
          {$ifdef DelphiPng}
            PicIndexPng :
              SavePictureDialog.FileName := s + '.'
                + ExtGraphicExtension(tPngObject, 1);
          {$endif}
        end;
        OldOrientation := Printer.Orientation;
        TerminListeLoad;
        UserHolidaysLoad;
        AutoHolidaysLoad;
        LayoutLoad;
        BmpForm.y_by_x       :=  1;
        BmpForm.HoeheMM.Text := '0';
        {$ifdef fpc}
          BmpForm.UpDownDPI.Position := Printer.YDPI;
        {$else}
          BmpForm.UpDownDPI.Position :=
            GetDeviceCaps(Printer.Handle, LogPixelsY);
        {$endif}
        BmpForm.DPI.Text := IntToStr(BmpForm.UpDownDPI.Position);
        case tFormular(Formular.ItemIndex) of
          FormularRingbuch,
          FormularEineSeite :
            begin
              val(LayoutForm.PaperHeight.Text, h, e);
              e := e;
              val(LayoutForm.PaperWidth.Text,  w, e);
              if w <> 0 then
                BmpForm.y_by_x := h/w;
              BmpForm.HoeheMM.Text := LayoutForm.PaperHeight.Text;
            end;
        else
          BmpForm.y_by_x := LayoutForm.HoeheMax / LayoutForm.BreiteMax;
          str(LayoutForm.HoeheMax : 1 : 1, s);
          BmpForm.HoeheMM.Text := s;
        end;
        BmpForm.Calculate;
        case tPicIndex(SavePictureDialog.FilterIndex - 1) of
          {$ifndef fpc}
            PicIndexGif,
          {$endif}
          PicIndexPng,
          PicIndexBmp,
          PicIndexJpg:
            if BmpForm.ShowModal = mrOk then
              begin
                BmpForm.Calculate;
                val(BmpForm.BreitePixel.Text, FormBreite, e);
                val(BmpForm.HoehePixel.Text,  FormHoehe,  e);
                try
                  Bitmap := tBitmap.Create;
                except
                  Bitmap := Nil;
                end;
                if Bitmap <> Nil then
                  try
                    Bitmap.Pixelformat := pf24Bit;
                    Bitmap.Width       := FormBreite;
                    Bitmap.Height      := FormHoehe;
                  except
                    Bitmap.Free;
                    Bitmap := Nil;
                  end;
                if Bitmap = Nil then
                  case SysLocale.PriLangID of
                    Lang_German:
                      MsgBox(CP1252ToSystem('Bitmap zu gro'),
                             Caption, mb_IconHand);
                  else
                    MsgBox('Bitmap too large', Caption, mb_IconHand);
                  end
                else
                  begin
                    Status        := Ok;
                    CanvasX       := BmpForm.UpDownDPI.Position;
                    CanvasY       := BmpForm.UpDownDPI.Position;
                    Screen.Cursor := crHourGlass;
                    { Bei Lazarus ist ein leeres Bild schwarz }
                    Bitmap.Canvas.Brush.Color := clWhite;
                    Bitmap.Canvas.FillRect(
                      Rect(0, 0, Bitmap.Width, Bitmap.Height));
                    case tFormular(Formular.ItemIndex) of
                      FormularEineSeite:
                        BmpEineSeite(Bitmap);
                      FormularRingbuch:
                        BmpRingbuch(Bitmap);
                      FormularMonat:
                        BmpMonatsplaner(Bitmap);
                      FormularBilder:
                        BmpBilder(Bitmap);
                    end;
                    Screen.Cursor := crDefault;
                    StatusCheck;
                    Bitmap.Free;
                  end;
              end;
          {$ifndef fpc}
            PicIndexWmf,
            PicIndexEmf:
              begin
                BmpForm.Calculate;
                val(BmpForm.BreitePixel.Text, FormBreite, e);
                val(BmpForm.HoehePixel.Text,  FormHoehe,  e);
                Printer.BeginDoc;
                Status        := Ok;
                CanvasX       := BmpForm.UpDownDPI.Position;
                CanvasY       := BmpForm.UpDownDPI.Position;
                Screen.Cursor := crHourGlass;
                case tFormular(Formular.ItemIndex) of
                  FormularEineSeite:
                    EmfEineSeite;
                  FormularRingbuch:
                    EmfRingbuch;
                  FormularMonat:
                    EmfMonatsplaner;
                  FormularBilder:
                    EmfBilder;
                end;
                Screen.Cursor := crDefault;
                StatusCheck;
                Printer.Abort;
              end;
          {$endif}
        end;
        Printer.Orientation := OldOrientation;
      end;
    EnableAll(True);
  end;

procedure TMainForm.JahrEditExit(Sender: TObject);
  Var     s       : String;
          nJahr,
          nMonat,
          nTag    : Word;
  begin
    if JahrEdit.Text = '' then
      begin
        DecodeDate(Date, nJahr, nMonat, nTag);
        Jahr.Position := nJahr;
      end;
    s := IntToStr(Jahr.Position);
    JahrEdit.Text := s;
  end;

procedure TMainForm.UpDownBisClick(Sender: TObject; Button: TUDBtnType);
  begin
    if Button = btNext then
      UpClick(Bis)
    else
      DownClick(Bis);
  end;

procedure TMainForm.UpDownVonClick(Sender: TObject; Button: TUDBtnType);
  begin
    if Button = btNext then
      UpClick(Von)
    else
      DownClick(Von);
  end;

procedure TMainForm.LabelLizenznehmerClick(Sender: TObject);
  var s : String;
      i : Integer;
  begin
    if Lizenznehmer = '' then
      begin
        LizenzForm.ShowModal;
        s := '';
        for i := 0 to LizenzForm.MemoLizenzCode.Lines.Count - 1 do
          s := s + Trim(LizenzForm.MemoLizenzCode.Lines[i]);
        if SetLizenz(Trim(LizenzForm.EditLizenznehmer.Text), s) >=
             IntToDez(VersionJahr,  4, False)
           + IntToDez(VersionMonat, 2, False)
           + IntToDez(VersionTag,   2, False)
        then
          begin
            LabelLizenznehmer.ParentFont := True;
            LabelLizenznehmer.Caption    := LizenzNehmer;
            LabelLizenznehmer.Cursor     := crDefault;
            JahrChange(Sender);
          end;
      end;
  end;

procedure TMainForm.FeiertageListeChange(Sender: TObject);
  var     IniFile : tIniFile;
  begin
    CheckFeiertageButtons;
    try
      IniFile := tIniFile.Create(IniName);
    except
      IniFile := Nil;
    end;
    if IniFile <> Nil then
      try
        IniFile.WriteInteger(IniHolidayList, IniActual, FeiertageListe.ItemIndex);
      finally
        IniFile.Free;
      end;
  end;

procedure TMainForm.BtnNewUserHolidayClick(Sender: TObject);
  begin
    UserHolidaysForm.HolidayList.Text := '';
    UserHolidaysForm.Load;
    if UserHolidaysForm.ShowModal = mrOK Then
      begin
        FeiertageListe.ItemIndex :=
          FeiertageListe.Items.Add(UserHolidaysForm.HolidayList.Text);
        CheckFeiertageButtons;
        SaveFeiertageListe;
      end;
  end;

procedure TMainForm.BtnNewAutoHolidayClick(Sender: TObject);
  begin
    AutoHolidayForm.HolidayList.Text := '';
    AutoHolidayForm.Load;
    if AutoHolidayForm.ShowModal = mrOK Then
      begin
        FeiertageListe.ItemIndex :=
          FeiertageListe.Items.Add(AutoHolidayForm.HolidayList.Text);
        CheckFeiertageButtons;
        SaveFeiertageListe;
      end;
  end;

procedure TMainForm.UserHolidaysLoad;
  begin
    if FeiertageListe.Text = Standard Then
      UserHolidaysForm.HolidayList.Text := ''
    else
      UserHolidaysForm.HolidayList.Text := FeiertageListe.Text;
    UserHolidaysForm.Load;
  end;

procedure TMainForm.AutoHolidaysLoad;
  begin
    if FeiertageListe.Text = Standard Then
      AutoHolidayForm.HolidayList.Text := ''
    else
      AutoHolidayForm.HolidayList.Text := FeiertageListe.Text;
    AutoHolidayForm.Load;
  end;

procedure TMainForm.BtnCopyUserHolidayClick(Sender: TObject);
  begin
    UserHolidaysLoad;
    UserHolidaysForm.HolidayList.Text     := '';
    UserHolidaysForm.HolidayList.Color    := clWindow;
    UserHolidaysForm.HolidayList.ReadOnly := False;
    UserHolidaysForm.HolidayList.Tabstop  := True;
    if UserHolidaysForm.ShowModal = mrOK Then
      begin
        FeiertageListe.ItemIndex :=
          FeiertageListe.Items.Add(UserHolidaysForm.HolidayList.Text);
        SaveFeiertageListe;
      end;
  end;

procedure TMainForm.BtnEditUserHolidayClick(Sender: TObject);
  begin
    UserHolidaysLoad;
    UserHolidaysForm.ShowModal;
  end;

procedure TMainForm.BtnDelHolidayClick(Sender: TObject);
  var     IniFile : tIniFile;
          i       : Integer;
  begin
    case SysLocale.PriLangID of
      Lang_German:
        i := MsgBox('Sind Sie sicher?',
                    CP1252ToSystem('Feiertageliste lschen'),
                    mb_OkCancel or mb_IconQuestion);
    else
      i := MsgBox('Are you sure?', 'Delete holiday list',
                  mb_OkCancel or mb_IconQuestion);
    end;
    if i = idOk Then
      begin
        try
          IniFile := tIniFile.Create(IniName);
        except
          IniFile := Nil;
        end;
        if IniFile <> Nil then
          try
            IniFile.EraseSection(IniHolidayList + ' ' + FeiertageListe.Text);
          finally
            IniFile.Free;
          end;
        i := FeiertageListe.ItemIndex;
        FeiertageListe.ItemIndex := FeiertageListe.Items.IndexOf(Standard);
        FeiertageListe.Items.Delete(i);
        CheckFeiertageButtons;
        SaveFeiertageListe;
      end;
  end;

procedure TMainForm.BtnCopyAutoHolidayClick(Sender: TObject);
  begin
    AutoHolidaysLoad;
    AutoHolidayForm.HolidayList.Text     := '';
    AutoHolidayForm.HolidayList.Color    := clWindow;
    AutoHolidayForm.HolidayList.ReadOnly := False;
    AutoHolidayForm.HolidayList.Tabstop  := True;
    if AutoHolidayForm.ShowModal = mrOK Then
      begin
        FeiertageListe.ItemIndex :=
          FeiertageListe.Items.Add(UserHolidaysForm.HolidayList.Text);
        SaveFeiertageListe;
      end;
  end;
                  
procedure TMainForm.BtnEditAutoHolidayClick(Sender: TObject);
  begin
    AutoHolidaysLoad;
    AutoHolidayForm.ShowModal;
  end;

procedure TMainForm.BtnCopyLayoutClick(Sender: TObject);
  begin
    LayoutLoad;
    LayoutForm.Layout.Text     := '';
    LayoutForm.Layout.Color    := clWindow;
    LayoutForm.Layout.ReadOnly := False;
    LayoutForm.Layout.Tabstop  := True;
    ShowLayout;
  end;

end.
